// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import org.andromda.metafacades.uml.AttributeFacade;

/**
 * <p>
 * Represents a criteria search attribute.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface SpringCriteriaAttribute
    extends AttributeFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isSpringCriteriaAttributeMetaType();

    /**
     * <p>
     * Returns the name of the attribute to be used in the criteria
     * query.
     * </p>
     * @return String
     */
    public String getAttributeName();

    /**
     * <p>
     * Returns the comparator for the attribute.
     * </p>
     * @return String
     */
    public String getComparator();

    /**
     * <p>
     * The comparator as a constant expression usable in the template.
     * </p>
     * @return String
     */
    public String getComparatorConstant();

    /**
     * <p>
     * Returns the hibernate matchmode constant to use for matching
     * Strings.
     * </p>
     * @return String
     */
    public String getMatchMode();

    /**
     * <p>
     * Returns the matchmode constant for usage in templates.
     * </p>
     * @return String
     */
    public String getMatchModeConstant();

    /**
     * <p>
     * Returns the order direction if it has been set.
     * </p>
     * @return String
     */
    public String getOrderDirection();

    /**
     * <p>
     * Returns the relevance of the ordering setting. The lower the
     * number, the more relevant it is.
     * </p>
     * @return int
     */
    public int getOrderRelevance();

    /**
     * <p>
     * Indicates whether or not the attribute has a tagged value for
     * the comparator.
     * </p>
     * @return boolean
     */
    public boolean isComparatorPresent();

    /**
     * <p>
     * Returns <code>true</code> if a matchmode has ben set.
     * </p>
     * @return boolean
     */
    public boolean isMatchModePresent();

    /**
     * <p>
     * Defines whether the underlying attribute on the queried entity
     * may be NULL and should therefore be included in the search.
     * </p>
     * @return boolean
     */
    public boolean isNullable();

    /**
     * <p>
     * Returns true if the attribute is used to order the result set.
     * </p>
     * @return boolean
     */
    public boolean isOrderable();
}