// license-header java merge-point
//
// Attention: generated code (by MetafacadeLogic.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import java.util.Collection;
import org.andromda.core.common.Introspector;
import org.andromda.core.metafacade.MetafacadeBase;
import org.andromda.core.metafacade.MetafacadeFactory;
import org.andromda.core.metafacade.ModelValidationMessage;
import org.andromda.metafacades.uml.AttributeFacade;
import org.andromda.metafacades.uml.ClassifierFacade;
import org.andromda.metafacades.uml.ConstraintFacade;
import org.andromda.metafacades.uml.DependencyFacade;
import org.andromda.metafacades.uml.EnumerationFacade;
import org.andromda.metafacades.uml.ModelElementFacade;
import org.andromda.metafacades.uml.ModelFacade;
import org.andromda.metafacades.uml.PackageFacade;
import org.andromda.metafacades.uml.StateMachineFacade;
import org.andromda.metafacades.uml.StereotypeFacade;
import org.andromda.metafacades.uml.TaggedValueFacade;
import org.andromda.metafacades.uml.TemplateParameterFacade;
import org.andromda.metafacades.uml.TypeMappings;

/**
 * <p>
 * Represents a criteria search attribute.
 * </p>
 * MetafacadeLogic for SpringCriteriaAttribute
 *
 * @see SpringCriteriaAttribute
 */
public abstract class SpringCriteriaAttributeLogic
    extends MetafacadeBase
    implements SpringCriteriaAttribute
{
    /**
     * The underlying UML object
     * @see Object
     */
    protected Object metaObject;

    /** Create Metafacade implementation instance using the MetafacadeFactory from the context
     * @param metaObjectIn
     * @param context
     */
    protected SpringCriteriaAttributeLogic(Object metaObjectIn, String context)
    {
        super(metaObjectIn, getContext(context));
        this.superAttributeFacade =
           (AttributeFacade)
            MetafacadeFactory.getInstance().createFacadeImpl(
                    "org.andromda.metafacades.uml.AttributeFacade",
                    metaObjectIn,
                    getContext(context));
        this.metaObject = metaObjectIn;
    }

    /**
     * Gets the context for this metafacade logic instance.
     * @param context String. Set to SpringCriteriaAttribute if null
     * @return context String
     */
    private static String getContext(String context)
    {
        if (context == null)
        {
            context = "org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute";
        }
        return context;
    }

    private AttributeFacade superAttributeFacade;
    private boolean superAttributeFacadeInitialized = false;

    /**
     * Gets the AttributeFacade parent instance.
     * @return this.superAttributeFacade AttributeFacade
     */
    private AttributeFacade getSuperAttributeFacade()
    {
        if (!this.superAttributeFacadeInitialized)
        {
            ((MetafacadeBase)this.superAttributeFacade).setMetafacadeContext(this.getMetafacadeContext());
            this.superAttributeFacadeInitialized = true;
        }
        return this.superAttributeFacade;
    }

    /** Reset context only for non-root metafacades
     * @param context
     * @see org.andromda.core.metafacade.MetafacadeBase#resetMetafacadeContext(String context)
     */
    @Override
    public void resetMetafacadeContext(String context)
    {
        if (!this.contextRoot) // reset context only for non-root metafacades
        {
            context = getContext(context);  // to have same value as in original constructor call
            setMetafacadeContext (context);
            if (this.superAttributeFacadeInitialized)
            {
                ((MetafacadeBase)this.superAttributeFacade).resetMetafacadeContext(context);
            }
        }
    }

    /**
     * @return boolean true always
     * @see SpringCriteriaAttribute
     */
    public boolean isSpringCriteriaAttributeMetaType()
    {
        return true;
    }

    // --------------- attributes ---------------------

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#getAttributeName()
    * @return String
    */
    protected abstract String handleGetAttributeName();

    private String __attributeName1a;
    private boolean __attributeName1aSet = false;

    /**
     * <p>
     * Returns the name of the attribute to be used in the criteria
     * query.
     * </p>
     * @return (String)handleGetAttributeName()
     */
    public final String getAttributeName()
    {
        String attributeName1a = this.__attributeName1a;
        if (!this.__attributeName1aSet)
        {
            // attributeName has no pre constraints
            attributeName1a = handleGetAttributeName();
            // attributeName has no post constraints
            this.__attributeName1a = attributeName1a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__attributeName1aSet = true;
            }
        }
        return attributeName1a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#getComparator()
    * @return String
    */
    protected abstract String handleGetComparator();

    private String __comparator2a;
    private boolean __comparator2aSet = false;

    /**
     * <p>
     * Returns the comparator for the attribute.
     * </p>
     * @return (String)handleGetComparator()
     */
    public final String getComparator()
    {
        String comparator2a = this.__comparator2a;
        if (!this.__comparator2aSet)
        {
            // comparator has no pre constraints
            comparator2a = handleGetComparator();
            // comparator has no post constraints
            this.__comparator2a = comparator2a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__comparator2aSet = true;
            }
        }
        return comparator2a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#isComparatorPresent()
    * @return boolean
    */
    protected abstract boolean handleIsComparatorPresent();

    private boolean __comparatorPresent3a;
    private boolean __comparatorPresent3aSet = false;

    /**
     * <p>
     * Indicates whether or not the attribute has a tagged value for
     * the comparator.
     * </p>
     * @return (boolean)handleIsComparatorPresent()
     */
    public final boolean isComparatorPresent()
    {
        boolean comparatorPresent3a = this.__comparatorPresent3a;
        if (!this.__comparatorPresent3aSet)
        {
            // comparatorPresent has no pre constraints
            comparatorPresent3a = handleIsComparatorPresent();
            // comparatorPresent has no post constraints
            this.__comparatorPresent3a = comparatorPresent3a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__comparatorPresent3aSet = true;
            }
        }
        return comparatorPresent3a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#getComparatorConstant()
    * @return String
    */
    protected abstract String handleGetComparatorConstant();

    private String __comparatorConstant4a;
    private boolean __comparatorConstant4aSet = false;

    /**
     * <p>
     * The comparator as a constant expression usable in the template.
     * </p>
     * @return (String)handleGetComparatorConstant()
     */
    public final String getComparatorConstant()
    {
        String comparatorConstant4a = this.__comparatorConstant4a;
        if (!this.__comparatorConstant4aSet)
        {
            // comparatorConstant has no pre constraints
            comparatorConstant4a = handleGetComparatorConstant();
            // comparatorConstant has no post constraints
            this.__comparatorConstant4a = comparatorConstant4a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__comparatorConstant4aSet = true;
            }
        }
        return comparatorConstant4a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#isNullable()
    * @return boolean
    */
    protected abstract boolean handleIsNullable();

    private boolean __nullable5a;
    private boolean __nullable5aSet = false;

    /**
     * <p>
     * Defines whether the underlying attribute on the queried entity
     * may be NULL and should therefore be included in the search.
     * </p>
     * @return (boolean)handleIsNullable()
     */
    public final boolean isNullable()
    {
        boolean nullable5a = this.__nullable5a;
        if (!this.__nullable5aSet)
        {
            // nullable has no pre constraints
            nullable5a = handleIsNullable();
            // nullable has no post constraints
            this.__nullable5a = nullable5a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__nullable5aSet = true;
            }
        }
        return nullable5a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#getMatchMode()
    * @return String
    */
    protected abstract String handleGetMatchMode();

    private String __matchMode6a;
    private boolean __matchMode6aSet = false;

    /**
     * <p>
     * Returns the hibernate matchmode constant to use for matching
     * Strings.
     * </p>
     * @return (String)handleGetMatchMode()
     */
    public final String getMatchMode()
    {
        String matchMode6a = this.__matchMode6a;
        if (!this.__matchMode6aSet)
        {
            // matchMode has no pre constraints
            matchMode6a = handleGetMatchMode();
            // matchMode has no post constraints
            this.__matchMode6a = matchMode6a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__matchMode6aSet = true;
            }
        }
        return matchMode6a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#getMatchModeConstant()
    * @return String
    */
    protected abstract String handleGetMatchModeConstant();

    private String __matchModeConstant7a;
    private boolean __matchModeConstant7aSet = false;

    /**
     * <p>
     * Returns the matchmode constant for usage in templates.
     * </p>
     * @return (String)handleGetMatchModeConstant()
     */
    public final String getMatchModeConstant()
    {
        String matchModeConstant7a = this.__matchModeConstant7a;
        if (!this.__matchModeConstant7aSet)
        {
            // matchModeConstant has no pre constraints
            matchModeConstant7a = handleGetMatchModeConstant();
            // matchModeConstant has no post constraints
            this.__matchModeConstant7a = matchModeConstant7a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__matchModeConstant7aSet = true;
            }
        }
        return matchModeConstant7a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#isMatchModePresent()
    * @return boolean
    */
    protected abstract boolean handleIsMatchModePresent();

    private boolean __matchModePresent8a;
    private boolean __matchModePresent8aSet = false;

    /**
     * <p>
     * Returns <code>true</code> if a matchmode has ben set.
     * </p>
     * @return (boolean)handleIsMatchModePresent()
     */
    public final boolean isMatchModePresent()
    {
        boolean matchModePresent8a = this.__matchModePresent8a;
        if (!this.__matchModePresent8aSet)
        {
            // matchModePresent has no pre constraints
            matchModePresent8a = handleIsMatchModePresent();
            // matchModePresent has no post constraints
            this.__matchModePresent8a = matchModePresent8a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__matchModePresent8aSet = true;
            }
        }
        return matchModePresent8a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#isOrderable()
    * @return boolean
    */
    protected abstract boolean handleIsOrderable();

    private boolean __orderable9a;
    private boolean __orderable9aSet = false;

    /**
     * <p>
     * Returns true if the attribute is used to order the result set.
     * </p>
     * @return (boolean)handleIsOrderable()
     */
    public final boolean isOrderable()
    {
        boolean orderable9a = this.__orderable9a;
        if (!this.__orderable9aSet)
        {
            // orderable has no pre constraints
            orderable9a = handleIsOrderable();
            // orderable has no post constraints
            this.__orderable9a = orderable9a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__orderable9aSet = true;
            }
        }
        return orderable9a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#getOrderDirection()
    * @return String
    */
    protected abstract String handleGetOrderDirection();

    private String __orderDirection10a;
    private boolean __orderDirection10aSet = false;

    /**
     * <p>
     * Returns the order direction if it has been set.
     * </p>
     * @return (String)handleGetOrderDirection()
     */
    public final String getOrderDirection()
    {
        String orderDirection10a = this.__orderDirection10a;
        if (!this.__orderDirection10aSet)
        {
            // orderDirection has no pre constraints
            orderDirection10a = handleGetOrderDirection();
            // orderDirection has no post constraints
            this.__orderDirection10a = orderDirection10a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__orderDirection10aSet = true;
            }
        }
        return orderDirection10a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringCriteriaAttribute#getOrderRelevance()
    * @return int
    */
    protected abstract int handleGetOrderRelevance();

    private int __orderRelevance11a;
    private boolean __orderRelevance11aSet = false;

    /**
     * <p>
     * Returns the relevance of the ordering setting. The lower the
     * number, the more relevant it is.
     * </p>
     * @return (int)handleGetOrderRelevance()
     */
    public final int getOrderRelevance()
    {
        int orderRelevance11a = this.__orderRelevance11a;
        if (!this.__orderRelevance11aSet)
        {
            // orderRelevance has no pre constraints
            orderRelevance11a = handleGetOrderRelevance();
            // orderRelevance has no post constraints
            this.__orderRelevance11a = orderRelevance11a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__orderRelevance11aSet = true;
            }
        }
        return orderRelevance11a;
    }

    /**
     * @return true
     * @see AttributeFacade
     */
    public boolean isAttributeFacadeMetaType()
    {
        return true;
    }

    /**
     * @return true
     * @see ModelElementFacade
     */
    public boolean isModelElementFacadeMetaType()
    {
        return true;
    }

    // ----------- delegates to AttributeFacade ------------
    /**
     * <p>
     * Searches the given feature for the specified tag.
     * </p>
     * <p>
     * If the follow boolean is set to true then the search will
     * continue from the class attribute to the class itself and then
     * up the class hierarchy.
     * </p>
     * @see AttributeFacade#findTaggedValue(String name, boolean follow)
     */
    public Object findTaggedValue(String name, boolean follow)
    {
        return this.getSuperAttributeFacade().findTaggedValue(name, follow);
    }

    /**
     * <p>
     * The default value of the attribute.  This is the value given if
     * no value is defined.
     * </p>
     * @see AttributeFacade#getDefaultValue()
     */
    public String getDefaultValue()
    {
        return this.getSuperAttributeFacade().getDefaultValue();
    }

    /**
     * <p>
     * If the attribute is an enumeration literal this represents the
     * owning enumeration. Can be empty.
     * </p>
     * @see AttributeFacade#getEnumeration()
     */
    public EnumerationFacade getEnumeration()
    {
        return this.getSuperAttributeFacade().getEnumeration();
    }

    /**
     * <p>
     * Returns the enumeration literal parameters defined by tagged
     * value as a comma separated list.
     * </p>
     * @see AttributeFacade#getEnumerationLiteralParameters()
     */
    public String getEnumerationLiteralParameters()
    {
        return this.getSuperAttributeFacade().getEnumerationLiteralParameters();
    }

    /**
     * <p>
     * The value for this attribute if it is an enumeration literal,
     * null otherwise. The default value is returned as a String if it
     * has been specified, if it's not specified this attribute's name
     * is assumed.
     * </p>
     * @see AttributeFacade#getEnumerationValue()
     */
    public String getEnumerationValue()
    {
        return this.getSuperAttributeFacade().getEnumerationValue();
    }

    /**
     * <p>
     * The name of the accessor operation that would retrieve this
     * attribute's value.
     * </p>
     * @see AttributeFacade#getGetterName()
     */
    public String getGetterName()
    {
        return this.getSuperAttributeFacade().getGetterName();
    }

    /**
     * <p>
     * The name of the type that is returned on the accessor and
     * mutator operations,  determined in part by the multiplicity.
     * </p>
     * @see AttributeFacade#getGetterSetterTypeName()
     */
    public String getGetterSetterTypeName()
    {
        return this.getSuperAttributeFacade().getGetterSetterTypeName();
    }

    /**
     * <p>
     * the lower value for the multiplicity
     * </p>
     * <p>
     * -only applicable for UML2
     * </p>
     * @see AttributeFacade#getLower()
     */
    public int getLower()
    {
        return this.getSuperAttributeFacade().getLower();
    }

    /**
     * <p>
     * Gets the classifier who is the owner of the attributes.
     * </p>
     * @see AttributeFacade#getOwner()
     */
    public ClassifierFacade getOwner()
    {
        return this.getSuperAttributeFacade().getOwner();
    }

    /**
     * <p>
     * The name of the mutator operation that would retrieve this
     * attribute's value.
     * </p>
     * @see AttributeFacade#getSetterName()
     */
    public String getSetterName()
    {
        return this.getSuperAttributeFacade().getSetterName();
    }

    /**
     * <p>
     * The classifier owning this attribute.
     * </p>
     * @see AttributeFacade#getType()
     */
    public ClassifierFacade getType()
    {
        return this.getSuperAttributeFacade().getType();
    }

    /**
     * <p>
     * the upper value for the multiplicity (will be -1 for *)
     * </p>
     * <p>
     * -only applicable for UML2
     * </p>
     * @see AttributeFacade#getUpper()
     */
    public int getUpper()
    {
        return this.getSuperAttributeFacade().getUpper();
    }

    /**
     * <p>
     * True if this attribute can only be set.
     * </p>
     * @see AttributeFacade#isAddOnly()
     */
    public boolean isAddOnly()
    {
        return this.getSuperAttributeFacade().isAddOnly();
    }

    /**
     * <p>
     * True if this attribute can be modified.
     * </p>
     * @see AttributeFacade#isChangeable()
     */
    public boolean isChangeable()
    {
        return this.getSuperAttributeFacade().isChangeable();
    }

    /**
     * <p>
     * Indicates if the default value is present.
     * </p>
     * @see AttributeFacade#isDefaultValuePresent()
     */
    public boolean isDefaultValuePresent()
    {
        return this.getSuperAttributeFacade().isDefaultValuePresent();
    }

    /**
     * <p>
     * If the attribute is derived (its value is computed). UML2 only.
     * UML14 always returns false. Default=false.
     * </p>
     * @see AttributeFacade#isDerived()
     */
    public boolean isDerived()
    {
        return this.getSuperAttributeFacade().isDerived();
    }

    /**
     * <p>
     * True if this attribute is owned by an enumeration.
     * </p>
     * @see AttributeFacade#isEnumerationLiteral()
     */
    public boolean isEnumerationLiteral()
    {
        return this.getSuperAttributeFacade().isEnumerationLiteral();
    }

    /**
     * <p>
     * Returns true if enumeration literal parameters exist (defined by
     * tagged value) for the literal.
     * </p>
     * @see AttributeFacade#isEnumerationLiteralParametersExist()
     */
    public boolean isEnumerationLiteralParametersExist()
    {
        return this.getSuperAttributeFacade().isEnumerationLiteralParametersExist();
    }

    /**
     * <p>
     * True if this attribute is owned by an enumeration but is defined
     * as a member variable (NOT a literal).
     * </p>
     * @see AttributeFacade#isEnumerationMember()
     */
    public boolean isEnumerationMember()
    {
        return this.getSuperAttributeFacade().isEnumerationMember();
    }

    /**
     * <p>
     * IsLeaf property in the operation. If true, operation is final,
     * cannot be extended or implemented by a descendant.
     * </p>
     * @see AttributeFacade#isLeaf()
     */
    public boolean isLeaf()
    {
        return this.getSuperAttributeFacade().isLeaf();
    }

    /**
     * <p>
     * Whether or not this attribute has a multiplicity greater than 1.
     * </p>
     * @see AttributeFacade#isMany()
     */
    public boolean isMany()
    {
        return this.getSuperAttributeFacade().isMany();
    }

    /**
     * <p>
     * Indicates whether or not the attributes are ordered (if
     * multiplicity is greater than 1).
     * </p>
     * @see AttributeFacade#isOrdered()
     */
    public boolean isOrdered()
    {
        return this.getSuperAttributeFacade().isOrdered();
    }

    /**
     * <p>
     * Whether or not this attribute can be modified.
     * </p>
     * @see AttributeFacade#isReadOnly()
     */
    public boolean isReadOnly()
    {
        return this.getSuperAttributeFacade().isReadOnly();
    }

    /**
     * <p>
     * Whether or not the multiplicity of this attribute is 1.
     * </p>
     * @see AttributeFacade#isRequired()
     */
    public boolean isRequired()
    {
        return this.getSuperAttributeFacade().isRequired();
    }

    /**
     * <p>
     * Indicates if this attribute is 'static', meaning it has a
     * classifier scope.
     * </p>
     * @see AttributeFacade#isStatic()
     */
    public boolean isStatic()
    {
        return this.getSuperAttributeFacade().isStatic();
    }

    /**
     * <p>
     * If the attribute is unique within the Collection type. UML2
     * only. UML14 always returns false. Unique+Ordered determines the
     * implementation Collection type. Default=false.
     * </p>
     * @see AttributeFacade#isUnique()
     */
    public boolean isUnique()
    {
        return this.getSuperAttributeFacade().isUnique();
    }

    /**
     * <p>
     * Copies all tagged values from the given ModelElementFacade to
     * this model element facade.
     * </p>
     * @see ModelElementFacade#copyTaggedValues(ModelElementFacade element)
     */
    public void copyTaggedValues(ModelElementFacade element)
    {
        this.getSuperAttributeFacade().copyTaggedValues(element);
    }

    /**
     * <p>
     * Finds the tagged value with the specified 'tagName'. In case
     * there are more values the first one found will be returned.
     * </p>
     * @see ModelElementFacade#findTaggedValue(String tagName)
     */
    public Object findTaggedValue(String tagName)
    {
        return this.getSuperAttributeFacade().findTaggedValue(tagName);
    }

    /**
     * <p>
     * Returns all the values for the tagged value with the specified
     * name. The returned collection will contains only String
     * instances, or will be empty. Never null.
     * </p>
     * @see ModelElementFacade#findTaggedValues(String tagName)
     */
    public Collection findTaggedValues(String tagName)
    {
        return this.getSuperAttributeFacade().findTaggedValues(tagName);
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element. The templates parameter will be
     * replaced by the correct one given the binding relation of the
     * parameter to this element.
     * </p>
     * @see ModelElementFacade#getBindedFullyQualifiedName(ModelElementFacade bindedElement)
     */
    public String getBindedFullyQualifiedName(ModelElementFacade bindedElement)
    {
        return this.getSuperAttributeFacade().getBindedFullyQualifiedName(bindedElement);
    }

    /**
     * <p>
     * Gets all constraints belonging to the model element.
     * </p>
     * @see ModelElementFacade#getConstraints()
     */
    public Collection<ConstraintFacade> getConstraints()
    {
        return this.getSuperAttributeFacade().getConstraints();
    }

    /**
     * <p>
     * Returns the constraints of the argument kind that have been
     * placed onto this model. Typical kinds are "inv", "pre" and
     * "post". Other kinds are possible.
     * </p>
     * @see ModelElementFacade#getConstraints(String kind)
     */
    public Collection getConstraints(String kind)
    {
        return this.getSuperAttributeFacade().getConstraints(kind);
    }

    /**
     * <p>
     * Gets the documentation for the model element, The indent
     * argument is prefixed to each line. By default this method wraps
     * lines after 64 characters.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * 64)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent)
     */
    public String getDocumentation(String indent)
    {
        return this.getSuperAttributeFacade().getDocumentation(indent);
    }

    /**
     * <p>
     * This method returns the documentation for this model element,
     * with the lines wrapped after the specified number of characters,
     * values of less than 1 will indicate no line wrapping is
     * required. By default paragraphs are returned as HTML.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * lineLength, true)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength)
     */
    public String getDocumentation(String indent, int lineLength)
    {
        return this.getSuperAttributeFacade().getDocumentation(indent, lineLength);
    }

    /**
     * 
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength, boolean htmlStyle)
     */
    public String getDocumentation(String indent, int lineLength, boolean htmlStyle)
    {
        return this.getSuperAttributeFacade().getDocumentation(indent, lineLength, htmlStyle);
    }

    /**
     * <p>
     * The fully qualified name of this model element.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName()
     */
    public String getFullyQualifiedName()
    {
        return this.getSuperAttributeFacade().getFullyQualifiedName();
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element.  If modelName is true, then the
     * original name of the model element (the name contained within
     * the model) will be the name returned, otherwise a name from a
     * language mapping will be returned.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName(boolean modelName)
     */
    public String getFullyQualifiedName(boolean modelName)
    {
        return this.getSuperAttributeFacade().getFullyQualifiedName(modelName);
    }

    /**
     * <p>
     * Returns the fully qualified name as a path, the returned value
     * always starts with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedNamePath()
     */
    public String getFullyQualifiedNamePath()
    {
        return this.getSuperAttributeFacade().getFullyQualifiedNamePath();
    }

    /**
     * <p>
     * Gets the unique identifier of the underlying model element.
     * </p>
     * @see ModelElementFacade#getId()
     */
    public String getId()
    {
        return this.getSuperAttributeFacade().getId();
    }

    /**
     * <p>
     * UML2: Retrieves the keywords for this element. Used to modify
     * implementation properties which are not represented by other
     * properties, i.e. native, transient, volatile, synchronized,
     * (added annotations) override, deprecated. Can also be used to
     * suppress compiler warnings: (added annotations) unchecked,
     * fallthrough, path, serial, finally, all. Annotations require
     * JDK5 compiler level.
     * </p>
     * @see ModelElementFacade#getKeywords()
     */
    public Collection<String> getKeywords()
    {
        return this.getSuperAttributeFacade().getKeywords();
    }

    /**
     * <p>
     * UML2: Retrieves a localized label for this named element.
     * </p>
     * @see ModelElementFacade#getLabel()
     */
    public String getLabel()
    {
        return this.getSuperAttributeFacade().getLabel();
    }

    /**
     * <p>
     * The language mappings that have been set for this model elemnt.
     * </p>
     * @see ModelElementFacade#getLanguageMappings()
     */
    public TypeMappings getLanguageMappings()
    {
        return this.getSuperAttributeFacade().getLanguageMappings();
    }

    /**
     * 
     * @see ModelElementFacade#getModel()
     */
    public ModelFacade getModel()
    {
        return this.getSuperAttributeFacade().getModel();
    }

    /**
     * <p>
     * The name of the model element.
     * </p>
     * @see ModelElementFacade#getName()
     */
    public String getName()
    {
        return this.getSuperAttributeFacade().getName();
    }

    /**
     * <p>
     * Gets the package to which this model element belongs.
     * </p>
     * @see ModelElementFacade#getPackage()
     */
    public ModelElementFacade getPackage()
    {
        return this.getSuperAttributeFacade().getPackage();
    }

    /**
     * <p>
     * The name of this model element's package.
     * </p>
     * @see ModelElementFacade#getPackageName()
     */
    public String getPackageName()
    {
        return this.getSuperAttributeFacade().getPackageName();
    }

    /**
     * <p>
     * Gets the package name (optionally providing the ability to
     * retrieve the model name and not the mapped name).
     * </p>
     * @see ModelElementFacade#getPackageName(boolean modelName)
     */
    public String getPackageName(boolean modelName)
    {
        return this.getSuperAttributeFacade().getPackageName(modelName);
    }

    /**
     * <p>
     * Returns the package as a path, the returned value always starts
     * with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getPackagePath()
     */
    public String getPackagePath()
    {
        return this.getSuperAttributeFacade().getPackagePath();
    }

    /**
     * <p>
     * UML2: Returns the value of the 'Qualified Name' attribute. A
     * name which allows the NamedElement to be identified within a
     * hierarchy of nested Namespaces. It is constructed from the names
     * of the containing namespaces starting at the root of the
     * hierarchy and ending with the name of the NamedElement itself.
     * </p>
     * @see ModelElementFacade#getQualifiedName()
     */
    public String getQualifiedName()
    {
        return this.getSuperAttributeFacade().getQualifiedName();
    }

    /**
     * <p>
     * Gets the root package for the model element.
     * </p>
     * @see ModelElementFacade#getRootPackage()
     */
    public PackageFacade getRootPackage()
    {
        return this.getSuperAttributeFacade().getRootPackage();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * source.
     * </p>
     * @see ModelElementFacade#getSourceDependencies()
     */
    public Collection<DependencyFacade> getSourceDependencies()
    {
        return this.getSuperAttributeFacade().getSourceDependencies();
    }

    /**
     * <p>
     * If this model element is the context of an activity graph, this
     * represents that activity graph.
     * </p>
     * @see ModelElementFacade#getStateMachineContext()
     */
    public StateMachineFacade getStateMachineContext()
    {
        return this.getSuperAttributeFacade().getStateMachineContext();
    }

    /**
     * <p>
     * The collection of ALL stereotype names for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypeNames()
     */
    public Collection<String> getStereotypeNames()
    {
        return this.getSuperAttributeFacade().getStereotypeNames();
    }

    /**
     * <p>
     * Gets all stereotypes for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypes()
     */
    public Collection<StereotypeFacade> getStereotypes()
    {
        return this.getSuperAttributeFacade().getStereotypes();
    }

    /**
     * 
     * @see ModelElementFacade#getTaggedValues()
     */
    public Collection<TaggedValueFacade> getTaggedValues()
    {
        return this.getSuperAttributeFacade().getTaggedValues();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * target.
     * </p>
     * @see ModelElementFacade#getTargetDependencies()
     */
    public Collection<DependencyFacade> getTargetDependencies()
    {
        return this.getSuperAttributeFacade().getTargetDependencies();
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameter(String parameterName)
     */
    public Object getTemplateParameter(String parameterName)
    {
        return this.getSuperAttributeFacade().getTemplateParameter(parameterName);
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameters()
     */
    public Collection<TemplateParameterFacade> getTemplateParameters()
    {
        return this.getSuperAttributeFacade().getTemplateParameters();
    }

    /**
     * <p>
     * The visibility (i.e. public, private, protected or package) of
     * the model element, will attempt a lookup for these values in the
     * language mappings (if any).
     * </p>
     * @see ModelElementFacade#getVisibility()
     */
    public String getVisibility()
    {
        return this.getSuperAttributeFacade().getVisibility();
    }

    /**
     * <p>
     * Returns true if the model element has the exact stereotype
     * (meaning no stereotype inheritance is taken into account when
     * searching for the stereotype), false otherwise.
     * </p>
     * @see ModelElementFacade#hasExactStereotype(String stereotypeName)
     */
    public boolean hasExactStereotype(String stereotypeName)
    {
        return this.getSuperAttributeFacade().hasExactStereotype(stereotypeName);
    }

    /**
     * <p>
     * Does the UML Element contain the named Keyword? Keywords can be
     * separated by space, comma, pipe, semicolon, or << >>
     * </p>
     * @see ModelElementFacade#hasKeyword(String keywordName)
     */
    public boolean hasKeyword(String keywordName)
    {
        return this.getSuperAttributeFacade().hasKeyword(keywordName);
    }

    /**
     * <p>
     * Returns true if the model element has the specified stereotype. 
     * If the stereotype itself does not match, then a search will be
     * made up the stereotype inheritance hierarchy, and if one of the
     * stereotype's ancestors has a matching name this method will
     * return true, false otherwise.
     * </p>
     * <p>
     * For example, if we have a certain stereotype called
     * <<exception>> and a model element has a stereotype called
     * <<applicationException>> which extends <<exception>>, when
     * calling this method with 'stereotypeName' defined as 'exception'
     * the method would return true since <<applicationException>>
     * inherits from <<exception>>.  If you want to check if the model
     * element has the exact stereotype, then use the method
     * 'hasExactStereotype' instead.
     * </p>
     * @see ModelElementFacade#hasStereotype(String stereotypeName)
     */
    public boolean hasStereotype(String stereotypeName)
    {
        return this.getSuperAttributeFacade().hasStereotype(stereotypeName);
    }

    /**
     * 
     * @see ModelElementFacade#isBindingDependenciesPresent()
     */
    public boolean isBindingDependenciesPresent()
    {
        return this.getSuperAttributeFacade().isBindingDependenciesPresent();
    }

    /**
     * <p>
     * Indicates if any constraints are present on this model element.
     * </p>
     * @see ModelElementFacade#isConstraintsPresent()
     */
    public boolean isConstraintsPresent()
    {
        return this.getSuperAttributeFacade().isConstraintsPresent();
    }

    /**
     * <p>
     * Indicates if any documentation is present on this model element.
     * </p>
     * @see ModelElementFacade#isDocumentationPresent()
     */
    public boolean isDocumentationPresent()
    {
        return this.getSuperAttributeFacade().isDocumentationPresent();
    }

    /**
     * <p>
     * True if this element name is a reserved word in Java, C#, ANSI
     * or ISO C, C++, JavaScript.
     * </p>
     * @see ModelElementFacade#isReservedWord()
     */
    public boolean isReservedWord()
    {
        return this.getSuperAttributeFacade().isReservedWord();
    }

    /**
     * 
     * @see ModelElementFacade#isTemplateParametersPresent()
     */
    public boolean isTemplateParametersPresent()
    {
        return this.getSuperAttributeFacade().isTemplateParametersPresent();
    }

    /**
     * <p>
     * Searches for the constraint with the specified 'name' on this
     * model element, and if found translates it using the specified
     * 'translation' from a translation library discovered by the
     * framework.
     * </p>
     * @see ModelElementFacade#translateConstraint(String name, String translation)
     */
    public String translateConstraint(String name, String translation)
    {
        return this.getSuperAttributeFacade().translateConstraint(name, translation);
    }

    /**
     * <p>
     * Translates all constraints belonging to this model element with
     * the given 'translation'.
     * </p>
     * @see ModelElementFacade#translateConstraints(String translation)
     */
    public String[] translateConstraints(String translation)
    {
        return this.getSuperAttributeFacade().translateConstraints(translation);
    }

    /**
     * <p>
     * Translates the constraints of the specified 'kind' belonging to
     * this model element.
     * </p>
     * @see ModelElementFacade#translateConstraints(String kind, String translation)
     */
    public String[] translateConstraints(String kind, String translation)
    {
        return this.getSuperAttributeFacade().translateConstraints(kind, translation);
    }

    /**
     * @see org.andromda.core.metafacade.MetafacadeBase#initialize()
     */
    @Override
    public void initialize()
    {
        this.getSuperAttributeFacade().initialize();
    }

    /**
     * @return Object getSuperAttributeFacade().getValidationOwner()
     * @see org.andromda.core.metafacade.MetafacadeBase#getValidationOwner()
     */
    @Override
    public Object getValidationOwner()
    {
        Object owner = this.getSuperAttributeFacade().getValidationOwner();
        return owner;
    }

    /**
     * @return String getSuperAttributeFacade().getValidationName()
     * @see org.andromda.core.metafacade.MetafacadeBase#getValidationName()
     */
    @Override
    public String getValidationName()
    {
        String name = this.getSuperAttributeFacade().getValidationName();
        return name;
    }

    /**
     * @param validationMessages Collection<ModelValidationMessage>
     * @see org.andromda.core.metafacade.MetafacadeBase#validateInvariants(Collection validationMessages)
     */
    @Override
    public void validateInvariants(Collection<ModelValidationMessage> validationMessages)
    {
        this.getSuperAttributeFacade().validateInvariants(validationMessages);
    }

    /**
     * The property that stores the name of the metafacade.
     */
    private static final String NAME_PROPERTY = "name";
    private static final String FQNAME_PROPERTY = "fullyQualifiedName";

    /**
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        final StringBuilder toString = new StringBuilder(this.getClass().getName());
        toString.append("[");
        try
        {
            toString.append(Introspector.instance().getProperty(this, FQNAME_PROPERTY));
        }
        catch (final Throwable tryAgain)
        {
            try
            {
                toString.append(Introspector.instance().getProperty(this, NAME_PROPERTY));
            }
            catch (final Throwable ignore)
            {
                // - just ignore when the metafacade doesn't have a name or fullyQualifiedName property
            }
        }
        toString.append("]");
        return toString.toString();
    }
}