// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import org.andromda.metafacades.uml.DependencyFacade;

/**
 * <p>
 * Represents a dependency between spring objects.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface SpringDependency
    extends DependencyFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isSpringDependencyMetaType();

    /**
     * <p>
     * The name of the DAO reference getter name.
     * </p>
     * @return String
     */
    public String getDaoGetterName();

    /**
     * <p>
     * The name given to a DAO reference.
     * </p>
     * @return String
     */
    public String getDaoName();

    /**
     * <p>
     * The DAO reference setter's name.
     * </p>
     * @return String
     */
    public String getDaoSetterName();

    /**
     * 
     * @return String
     */
    public String getTransformationAnonymousName();

    /**
     * <p>
     * The name of the constant designated for use as a transformation
     * flag for value objects (only makes sense when this dependency
     * goes into a value object).
     * </p>
     * @return String
     */
    public String getTransformationConstantName();

    /**
     * <p>
     * Stores the transformation constrant name.
     * </p>
     * @return int
     */
    public int getTransformationConstantValue();

    /**
     * <p>
     * The name of the method use for transformation into a value
     * object (only makes sense when this dependency goes into a value
     * object).
     * </p>
     * @return String
     */
    public String getTransformationMethodName();

    /**
     * <p>
     * Returns the name of the method for transforming the contents of
     * a collection to an array.
     * </p>
     * @return String
     */
    public String getTransformationToArrayMethodName();

    /**
     * <p>
     * Returns the name of the method for transforming the contents of
     * a collection.
     * </p>
     * @return String
     */
    public String getTransformationToCollectionMethodName();

    /**
     * <p>
     * The method name that performs the value object collection to
     * entity collection transformation.
     * </p>
     * @return String
     */
    public String getTransformationToEntityCollectionMethodName();

    /**
     * <p>
     * The name of the "to entity" transformation method name.
     * </p>
     * @return String
     */
    public String getTransformationToEntityMethodName();

    /**
     * <p>
     * The name of the class that performs the value object to entity
     * transformation.
     * </p>
     * @return String
     */
    public String getValueObjectToEntityTransformerName();

    /**
     * <p>
     * Indicates if this dependency is part of a circular reference
     * (meaning that both entities reference each other).
     * </p>
     * @return boolean
     */
    public boolean isCircularReference();
}