// license-header java merge-point
//
// Attention: generated code (by MetafacadeLogic.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import java.util.Collection;
import org.andromda.core.common.Introspector;
import org.andromda.core.metafacade.MetafacadeBase;
import org.andromda.core.metafacade.MetafacadeFactory;
import org.andromda.core.metafacade.ModelValidationMessage;
import org.andromda.metafacades.uml.ConstraintFacade;
import org.andromda.metafacades.uml.DependencyFacade;
import org.andromda.metafacades.uml.ModelElementFacade;
import org.andromda.metafacades.uml.ModelFacade;
import org.andromda.metafacades.uml.PackageFacade;
import org.andromda.metafacades.uml.StateMachineFacade;
import org.andromda.metafacades.uml.StereotypeFacade;
import org.andromda.metafacades.uml.TaggedValueFacade;
import org.andromda.metafacades.uml.TemplateParameterFacade;
import org.andromda.metafacades.uml.TypeMappings;

/**
 * <p>
 * Represents a dependency between spring objects.
 * </p>
 * MetafacadeLogic for SpringDependency
 *
 * @see SpringDependency
 */
public abstract class SpringDependencyLogic
    extends MetafacadeBase
    implements SpringDependency
{
    /**
     * The underlying UML object
     * @see Object
     */
    protected Object metaObject;

    /** Create Metafacade implementation instance using the MetafacadeFactory from the context
     * @param metaObjectIn
     * @param context
     */
    protected SpringDependencyLogic(Object metaObjectIn, String context)
    {
        super(metaObjectIn, getContext(context));
        this.superDependencyFacade =
           (DependencyFacade)
            MetafacadeFactory.getInstance().createFacadeImpl(
                    "org.andromda.metafacades.uml.DependencyFacade",
                    metaObjectIn,
                    getContext(context));
        this.metaObject = metaObjectIn;
    }

    /**
     * Gets the context for this metafacade logic instance.
     * @param context String. Set to SpringDependency if null
     * @return context String
     */
    private static String getContext(String context)
    {
        if (context == null)
        {
            context = "org.andromda.cartridges.spring.metafacades.SpringDependency";
        }
        return context;
    }

    private DependencyFacade superDependencyFacade;
    private boolean superDependencyFacadeInitialized = false;

    /**
     * Gets the DependencyFacade parent instance.
     * @return this.superDependencyFacade DependencyFacade
     */
    private DependencyFacade getSuperDependencyFacade()
    {
        if (!this.superDependencyFacadeInitialized)
        {
            ((MetafacadeBase)this.superDependencyFacade).setMetafacadeContext(this.getMetafacadeContext());
            this.superDependencyFacadeInitialized = true;
        }
        return this.superDependencyFacade;
    }

    /** Reset context only for non-root metafacades
     * @param context
     * @see org.andromda.core.metafacade.MetafacadeBase#resetMetafacadeContext(String context)
     */
    @Override
    public void resetMetafacadeContext(String context)
    {
        if (!this.contextRoot) // reset context only for non-root metafacades
        {
            context = getContext(context);  // to have same value as in original constructor call
            setMetafacadeContext (context);
            if (this.superDependencyFacadeInitialized)
            {
                ((MetafacadeBase)this.superDependencyFacade).resetMetafacadeContext(context);
            }
        }
    }

    /**
     * @return boolean true always
     * @see SpringDependency
     */
    public boolean isSpringDependencyMetaType()
    {
        return true;
    }

    // --------------- attributes ---------------------

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationConstantName()
    * @return String
    */
    protected abstract String handleGetTransformationConstantName();

    private String __transformationConstantName1a;
    private boolean __transformationConstantName1aSet = false;

    /**
     * <p>
     * The name of the constant designated for use as a transformation
     * flag for value objects (only makes sense when this dependency
     * goes into a value object).
     * </p>
     * @return (String)handleGetTransformationConstantName()
     */
    public final String getTransformationConstantName()
    {
        String transformationConstantName1a = this.__transformationConstantName1a;
        if (!this.__transformationConstantName1aSet)
        {
            // transformationConstantName has no pre constraints
            transformationConstantName1a = handleGetTransformationConstantName();
            // transformationConstantName has no post constraints
            this.__transformationConstantName1a = transformationConstantName1a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationConstantName1aSet = true;
            }
        }
        return transformationConstantName1a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationMethodName()
    * @return String
    */
    protected abstract String handleGetTransformationMethodName();

    private String __transformationMethodName2a;
    private boolean __transformationMethodName2aSet = false;

    /**
     * <p>
     * The name of the method use for transformation into a value
     * object (only makes sense when this dependency goes into a value
     * object).
     * </p>
     * @return (String)handleGetTransformationMethodName()
     */
    public final String getTransformationMethodName()
    {
        String transformationMethodName2a = this.__transformationMethodName2a;
        if (!this.__transformationMethodName2aSet)
        {
            // transformationMethodName has no pre constraints
            transformationMethodName2a = handleGetTransformationMethodName();
            // transformationMethodName has no post constraints
            this.__transformationMethodName2a = transformationMethodName2a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationMethodName2aSet = true;
            }
        }
        return transformationMethodName2a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationAnonymousName()
    * @return String
    */
    protected abstract String handleGetTransformationAnonymousName();

    private String __transformationAnonymousName3a;
    private boolean __transformationAnonymousName3aSet = false;

    /**
     * 
     * @return (String)handleGetTransformationAnonymousName()
     */
    public final String getTransformationAnonymousName()
    {
        String transformationAnonymousName3a = this.__transformationAnonymousName3a;
        if (!this.__transformationAnonymousName3aSet)
        {
            // transformationAnonymousName has no pre constraints
            transformationAnonymousName3a = handleGetTransformationAnonymousName();
            // transformationAnonymousName has no post constraints
            this.__transformationAnonymousName3a = transformationAnonymousName3a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationAnonymousName3aSet = true;
            }
        }
        return transformationAnonymousName3a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#isCircularReference()
    * @return boolean
    */
    protected abstract boolean handleIsCircularReference();

    private boolean __circularReference4a;
    private boolean __circularReference4aSet = false;

    /**
     * <p>
     * Indicates if this dependency is part of a circular reference
     * (meaning that both entities reference each other).
     * </p>
     * @return (boolean)handleIsCircularReference()
     */
    public final boolean isCircularReference()
    {
        boolean circularReference4a = this.__circularReference4a;
        if (!this.__circularReference4aSet)
        {
            // circularReference has no pre constraints
            circularReference4a = handleIsCircularReference();
            // circularReference has no post constraints
            this.__circularReference4a = circularReference4a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__circularReference4aSet = true;
            }
        }
        return circularReference4a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationToCollectionMethodName()
    * @return String
    */
    protected abstract String handleGetTransformationToCollectionMethodName();

    private String __transformationToCollectionMethodName5a;
    private boolean __transformationToCollectionMethodName5aSet = false;

    /**
     * <p>
     * Returns the name of the method for transforming the contents of
     * a collection.
     * </p>
     * @return (String)handleGetTransformationToCollectionMethodName()
     */
    public final String getTransformationToCollectionMethodName()
    {
        String transformationToCollectionMethodName5a = this.__transformationToCollectionMethodName5a;
        if (!this.__transformationToCollectionMethodName5aSet)
        {
            // transformationToCollectionMethodName has no pre constraints
            transformationToCollectionMethodName5a = handleGetTransformationToCollectionMethodName();
            // transformationToCollectionMethodName has no post constraints
            this.__transformationToCollectionMethodName5a = transformationToCollectionMethodName5a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationToCollectionMethodName5aSet = true;
            }
        }
        return transformationToCollectionMethodName5a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getDaoName()
    * @return String
    */
    protected abstract String handleGetDaoName();

    private String __daoName6a;
    private boolean __daoName6aSet = false;

    /**
     * <p>
     * The name given to a DAO reference.
     * </p>
     * @return (String)handleGetDaoName()
     */
    public final String getDaoName()
    {
        String daoName6a = this.__daoName6a;
        if (!this.__daoName6aSet)
        {
            // daoName has no pre constraints
            daoName6a = handleGetDaoName();
            // daoName has no post constraints
            this.__daoName6a = daoName6a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoName6aSet = true;
            }
        }
        return daoName6a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getDaoGetterName()
    * @return String
    */
    protected abstract String handleGetDaoGetterName();

    private String __daoGetterName7a;
    private boolean __daoGetterName7aSet = false;

    /**
     * <p>
     * The name of the DAO reference getter name.
     * </p>
     * @return (String)handleGetDaoGetterName()
     */
    public final String getDaoGetterName()
    {
        String daoGetterName7a = this.__daoGetterName7a;
        if (!this.__daoGetterName7aSet)
        {
            // daoGetterName has no pre constraints
            daoGetterName7a = handleGetDaoGetterName();
            // daoGetterName has no post constraints
            this.__daoGetterName7a = daoGetterName7a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoGetterName7aSet = true;
            }
        }
        return daoGetterName7a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getDaoSetterName()
    * @return String
    */
    protected abstract String handleGetDaoSetterName();

    private String __daoSetterName8a;
    private boolean __daoSetterName8aSet = false;

    /**
     * <p>
     * The DAO reference setter's name.
     * </p>
     * @return (String)handleGetDaoSetterName()
     */
    public final String getDaoSetterName()
    {
        String daoSetterName8a = this.__daoSetterName8a;
        if (!this.__daoSetterName8aSet)
        {
            // daoSetterName has no pre constraints
            daoSetterName8a = handleGetDaoSetterName();
            // daoSetterName has no post constraints
            this.__daoSetterName8a = daoSetterName8a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoSetterName8aSet = true;
            }
        }
        return daoSetterName8a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationConstantValue()
    * @return int
    */
    protected abstract int handleGetTransformationConstantValue();

    private int __transformationConstantValue9a;
    private boolean __transformationConstantValue9aSet = false;

    /**
     * <p>
     * Stores the transformation constrant name.
     * </p>
     * @return (int)handleGetTransformationConstantValue()
     */
    public final int getTransformationConstantValue()
    {
        int transformationConstantValue9a = this.__transformationConstantValue9a;
        if (!this.__transformationConstantValue9aSet)
        {
            // transformationConstantValue has no pre constraints
            transformationConstantValue9a = handleGetTransformationConstantValue();
            // transformationConstantValue has no post constraints
            this.__transformationConstantValue9a = transformationConstantValue9a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationConstantValue9aSet = true;
            }
        }
        return transformationConstantValue9a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationToEntityCollectionMethodName()
    * @return String
    */
    protected abstract String handleGetTransformationToEntityCollectionMethodName();

    private String __transformationToEntityCollectionMethodName10a;
    private boolean __transformationToEntityCollectionMethodName10aSet = false;

    /**
     * <p>
     * The method name that performs the value object collection to
     * entity collection transformation.
     * </p>
     * @return (String)handleGetTransformationToEntityCollectionMethodName()
     */
    public final String getTransformationToEntityCollectionMethodName()
    {
        String transformationToEntityCollectionMethodName10a = this.__transformationToEntityCollectionMethodName10a;
        if (!this.__transformationToEntityCollectionMethodName10aSet)
        {
            // transformationToEntityCollectionMethodName has no pre constraints
            transformationToEntityCollectionMethodName10a = handleGetTransformationToEntityCollectionMethodName();
            // transformationToEntityCollectionMethodName has no post constraints
            this.__transformationToEntityCollectionMethodName10a = transformationToEntityCollectionMethodName10a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationToEntityCollectionMethodName10aSet = true;
            }
        }
        return transformationToEntityCollectionMethodName10a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationToEntityMethodName()
    * @return String
    */
    protected abstract String handleGetTransformationToEntityMethodName();

    private String __transformationToEntityMethodName11a;
    private boolean __transformationToEntityMethodName11aSet = false;

    /**
     * <p>
     * The name of the "to entity" transformation method name.
     * </p>
     * @return (String)handleGetTransformationToEntityMethodName()
     */
    public final String getTransformationToEntityMethodName()
    {
        String transformationToEntityMethodName11a = this.__transformationToEntityMethodName11a;
        if (!this.__transformationToEntityMethodName11aSet)
        {
            // transformationToEntityMethodName has no pre constraints
            transformationToEntityMethodName11a = handleGetTransformationToEntityMethodName();
            // transformationToEntityMethodName has no post constraints
            this.__transformationToEntityMethodName11a = transformationToEntityMethodName11a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationToEntityMethodName11aSet = true;
            }
        }
        return transformationToEntityMethodName11a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getValueObjectToEntityTransformerName()
    * @return String
    */
    protected abstract String handleGetValueObjectToEntityTransformerName();

    private String __valueObjectToEntityTransformerName12a;
    private boolean __valueObjectToEntityTransformerName12aSet = false;

    /**
     * <p>
     * The name of the class that performs the value object to entity
     * transformation.
     * </p>
     * @return (String)handleGetValueObjectToEntityTransformerName()
     */
    public final String getValueObjectToEntityTransformerName()
    {
        String valueObjectToEntityTransformerName12a = this.__valueObjectToEntityTransformerName12a;
        if (!this.__valueObjectToEntityTransformerName12aSet)
        {
            // valueObjectToEntityTransformerName has no pre constraints
            valueObjectToEntityTransformerName12a = handleGetValueObjectToEntityTransformerName();
            // valueObjectToEntityTransformerName has no post constraints
            this.__valueObjectToEntityTransformerName12a = valueObjectToEntityTransformerName12a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__valueObjectToEntityTransformerName12aSet = true;
            }
        }
        return valueObjectToEntityTransformerName12a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringDependency#getTransformationToArrayMethodName()
    * @return String
    */
    protected abstract String handleGetTransformationToArrayMethodName();

    private String __transformationToArrayMethodName13a;
    private boolean __transformationToArrayMethodName13aSet = false;

    /**
     * <p>
     * Returns the name of the method for transforming the contents of
     * a collection to an array.
     * </p>
     * @return (String)handleGetTransformationToArrayMethodName()
     */
    public final String getTransformationToArrayMethodName()
    {
        String transformationToArrayMethodName13a = this.__transformationToArrayMethodName13a;
        if (!this.__transformationToArrayMethodName13aSet)
        {
            // transformationToArrayMethodName has no pre constraints
            transformationToArrayMethodName13a = handleGetTransformationToArrayMethodName();
            // transformationToArrayMethodName has no post constraints
            this.__transformationToArrayMethodName13a = transformationToArrayMethodName13a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transformationToArrayMethodName13aSet = true;
            }
        }
        return transformationToArrayMethodName13a;
    }

    /**
     * @return true
     * @see DependencyFacade
     */
    public boolean isDependencyFacadeMetaType()
    {
        return true;
    }

    /**
     * @return true
     * @see ModelElementFacade
     */
    public boolean isModelElementFacadeMetaType()
    {
        return true;
    }

    // ----------- delegates to DependencyFacade ------------
    /**
     * <p>
     * The "getter" name for this dependency.
     * </p>
     * @see DependencyFacade#getGetterName()
     */
    public String getGetterName()
    {
        return this.getSuperDependencyFacade().getGetterName();
    }

    /**
     * <p>
     * The "setter" name for this dependency.
     * </p>
     * @see DependencyFacade#getSetterName()
     */
    public String getSetterName()
    {
        return this.getSuperDependencyFacade().getSetterName();
    }

    /**
     * <p>
     * The source element of this dependency.
     * </p>
     * @see DependencyFacade#getSourceElement()
     */
    public ModelElementFacade getSourceElement()
    {
        return this.getSuperDependencyFacade().getSourceElement();
    }

    /**
     * <p>
     * Gets the element to which the dependencies belong.
     * </p>
     * @see DependencyFacade#getTargetElement()
     */
    public ModelElementFacade getTargetElement()
    {
        return this.getSuperDependencyFacade().getTargetElement();
    }

    /**
     * <p>
     * Copies all tagged values from the given ModelElementFacade to
     * this model element facade.
     * </p>
     * @see ModelElementFacade#copyTaggedValues(ModelElementFacade element)
     */
    public void copyTaggedValues(ModelElementFacade element)
    {
        this.getSuperDependencyFacade().copyTaggedValues(element);
    }

    /**
     * <p>
     * Finds the tagged value with the specified 'tagName'. In case
     * there are more values the first one found will be returned.
     * </p>
     * @see ModelElementFacade#findTaggedValue(String tagName)
     */
    public Object findTaggedValue(String tagName)
    {
        return this.getSuperDependencyFacade().findTaggedValue(tagName);
    }

    /**
     * <p>
     * Returns all the values for the tagged value with the specified
     * name. The returned collection will contains only String
     * instances, or will be empty. Never null.
     * </p>
     * @see ModelElementFacade#findTaggedValues(String tagName)
     */
    public Collection findTaggedValues(String tagName)
    {
        return this.getSuperDependencyFacade().findTaggedValues(tagName);
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element. The templates parameter will be
     * replaced by the correct one given the binding relation of the
     * parameter to this element.
     * </p>
     * @see ModelElementFacade#getBindedFullyQualifiedName(ModelElementFacade bindedElement)
     */
    public String getBindedFullyQualifiedName(ModelElementFacade bindedElement)
    {
        return this.getSuperDependencyFacade().getBindedFullyQualifiedName(bindedElement);
    }

    /**
     * <p>
     * Gets all constraints belonging to the model element.
     * </p>
     * @see ModelElementFacade#getConstraints()
     */
    public Collection<ConstraintFacade> getConstraints()
    {
        return this.getSuperDependencyFacade().getConstraints();
    }

    /**
     * <p>
     * Returns the constraints of the argument kind that have been
     * placed onto this model. Typical kinds are "inv", "pre" and
     * "post". Other kinds are possible.
     * </p>
     * @see ModelElementFacade#getConstraints(String kind)
     */
    public Collection getConstraints(String kind)
    {
        return this.getSuperDependencyFacade().getConstraints(kind);
    }

    /**
     * <p>
     * Gets the documentation for the model element, The indent
     * argument is prefixed to each line. By default this method wraps
     * lines after 64 characters.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * 64)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent)
     */
    public String getDocumentation(String indent)
    {
        return this.getSuperDependencyFacade().getDocumentation(indent);
    }

    /**
     * <p>
     * This method returns the documentation for this model element,
     * with the lines wrapped after the specified number of characters,
     * values of less than 1 will indicate no line wrapping is
     * required. By default paragraphs are returned as HTML.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * lineLength, true)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength)
     */
    public String getDocumentation(String indent, int lineLength)
    {
        return this.getSuperDependencyFacade().getDocumentation(indent, lineLength);
    }

    /**
     * 
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength, boolean htmlStyle)
     */
    public String getDocumentation(String indent, int lineLength, boolean htmlStyle)
    {
        return this.getSuperDependencyFacade().getDocumentation(indent, lineLength, htmlStyle);
    }

    /**
     * <p>
     * The fully qualified name of this model element.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName()
     */
    public String getFullyQualifiedName()
    {
        return this.getSuperDependencyFacade().getFullyQualifiedName();
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element.  If modelName is true, then the
     * original name of the model element (the name contained within
     * the model) will be the name returned, otherwise a name from a
     * language mapping will be returned.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName(boolean modelName)
     */
    public String getFullyQualifiedName(boolean modelName)
    {
        return this.getSuperDependencyFacade().getFullyQualifiedName(modelName);
    }

    /**
     * <p>
     * Returns the fully qualified name as a path, the returned value
     * always starts with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedNamePath()
     */
    public String getFullyQualifiedNamePath()
    {
        return this.getSuperDependencyFacade().getFullyQualifiedNamePath();
    }

    /**
     * <p>
     * Gets the unique identifier of the underlying model element.
     * </p>
     * @see ModelElementFacade#getId()
     */
    public String getId()
    {
        return this.getSuperDependencyFacade().getId();
    }

    /**
     * <p>
     * UML2: Retrieves the keywords for this element. Used to modify
     * implementation properties which are not represented by other
     * properties, i.e. native, transient, volatile, synchronized,
     * (added annotations) override, deprecated. Can also be used to
     * suppress compiler warnings: (added annotations) unchecked,
     * fallthrough, path, serial, finally, all. Annotations require
     * JDK5 compiler level.
     * </p>
     * @see ModelElementFacade#getKeywords()
     */
    public Collection<String> getKeywords()
    {
        return this.getSuperDependencyFacade().getKeywords();
    }

    /**
     * <p>
     * UML2: Retrieves a localized label for this named element.
     * </p>
     * @see ModelElementFacade#getLabel()
     */
    public String getLabel()
    {
        return this.getSuperDependencyFacade().getLabel();
    }

    /**
     * <p>
     * The language mappings that have been set for this model elemnt.
     * </p>
     * @see ModelElementFacade#getLanguageMappings()
     */
    public TypeMappings getLanguageMappings()
    {
        return this.getSuperDependencyFacade().getLanguageMappings();
    }

    /**
     * 
     * @see ModelElementFacade#getModel()
     */
    public ModelFacade getModel()
    {
        return this.getSuperDependencyFacade().getModel();
    }

    /**
     * <p>
     * The name of the model element.
     * </p>
     * @see ModelElementFacade#getName()
     */
    public String getName()
    {
        return this.getSuperDependencyFacade().getName();
    }

    /**
     * <p>
     * Gets the package to which this model element belongs.
     * </p>
     * @see ModelElementFacade#getPackage()
     */
    public ModelElementFacade getPackage()
    {
        return this.getSuperDependencyFacade().getPackage();
    }

    /**
     * <p>
     * The name of this model element's package.
     * </p>
     * @see ModelElementFacade#getPackageName()
     */
    public String getPackageName()
    {
        return this.getSuperDependencyFacade().getPackageName();
    }

    /**
     * <p>
     * Gets the package name (optionally providing the ability to
     * retrieve the model name and not the mapped name).
     * </p>
     * @see ModelElementFacade#getPackageName(boolean modelName)
     */
    public String getPackageName(boolean modelName)
    {
        return this.getSuperDependencyFacade().getPackageName(modelName);
    }

    /**
     * <p>
     * Returns the package as a path, the returned value always starts
     * with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getPackagePath()
     */
    public String getPackagePath()
    {
        return this.getSuperDependencyFacade().getPackagePath();
    }

    /**
     * <p>
     * UML2: Returns the value of the 'Qualified Name' attribute. A
     * name which allows the NamedElement to be identified within a
     * hierarchy of nested Namespaces. It is constructed from the names
     * of the containing namespaces starting at the root of the
     * hierarchy and ending with the name of the NamedElement itself.
     * </p>
     * @see ModelElementFacade#getQualifiedName()
     */
    public String getQualifiedName()
    {
        return this.getSuperDependencyFacade().getQualifiedName();
    }

    /**
     * <p>
     * Gets the root package for the model element.
     * </p>
     * @see ModelElementFacade#getRootPackage()
     */
    public PackageFacade getRootPackage()
    {
        return this.getSuperDependencyFacade().getRootPackage();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * source.
     * </p>
     * @see ModelElementFacade#getSourceDependencies()
     */
    public Collection<DependencyFacade> getSourceDependencies()
    {
        return this.getSuperDependencyFacade().getSourceDependencies();
    }

    /**
     * <p>
     * If this model element is the context of an activity graph, this
     * represents that activity graph.
     * </p>
     * @see ModelElementFacade#getStateMachineContext()
     */
    public StateMachineFacade getStateMachineContext()
    {
        return this.getSuperDependencyFacade().getStateMachineContext();
    }

    /**
     * <p>
     * The collection of ALL stereotype names for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypeNames()
     */
    public Collection<String> getStereotypeNames()
    {
        return this.getSuperDependencyFacade().getStereotypeNames();
    }

    /**
     * <p>
     * Gets all stereotypes for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypes()
     */
    public Collection<StereotypeFacade> getStereotypes()
    {
        return this.getSuperDependencyFacade().getStereotypes();
    }

    /**
     * 
     * @see ModelElementFacade#getTaggedValues()
     */
    public Collection<TaggedValueFacade> getTaggedValues()
    {
        return this.getSuperDependencyFacade().getTaggedValues();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * target.
     * </p>
     * @see ModelElementFacade#getTargetDependencies()
     */
    public Collection<DependencyFacade> getTargetDependencies()
    {
        return this.getSuperDependencyFacade().getTargetDependencies();
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameter(String parameterName)
     */
    public Object getTemplateParameter(String parameterName)
    {
        return this.getSuperDependencyFacade().getTemplateParameter(parameterName);
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameters()
     */
    public Collection<TemplateParameterFacade> getTemplateParameters()
    {
        return this.getSuperDependencyFacade().getTemplateParameters();
    }

    /**
     * <p>
     * The visibility (i.e. public, private, protected or package) of
     * the model element, will attempt a lookup for these values in the
     * language mappings (if any).
     * </p>
     * @see ModelElementFacade#getVisibility()
     */
    public String getVisibility()
    {
        return this.getSuperDependencyFacade().getVisibility();
    }

    /**
     * <p>
     * Returns true if the model element has the exact stereotype
     * (meaning no stereotype inheritance is taken into account when
     * searching for the stereotype), false otherwise.
     * </p>
     * @see ModelElementFacade#hasExactStereotype(String stereotypeName)
     */
    public boolean hasExactStereotype(String stereotypeName)
    {
        return this.getSuperDependencyFacade().hasExactStereotype(stereotypeName);
    }

    /**
     * <p>
     * Does the UML Element contain the named Keyword? Keywords can be
     * separated by space, comma, pipe, semicolon, or << >>
     * </p>
     * @see ModelElementFacade#hasKeyword(String keywordName)
     */
    public boolean hasKeyword(String keywordName)
    {
        return this.getSuperDependencyFacade().hasKeyword(keywordName);
    }

    /**
     * <p>
     * Returns true if the model element has the specified stereotype. 
     * If the stereotype itself does not match, then a search will be
     * made up the stereotype inheritance hierarchy, and if one of the
     * stereotype's ancestors has a matching name this method will
     * return true, false otherwise.
     * </p>
     * <p>
     * For example, if we have a certain stereotype called
     * <<exception>> and a model element has a stereotype called
     * <<applicationException>> which extends <<exception>>, when
     * calling this method with 'stereotypeName' defined as 'exception'
     * the method would return true since <<applicationException>>
     * inherits from <<exception>>.  If you want to check if the model
     * element has the exact stereotype, then use the method
     * 'hasExactStereotype' instead.
     * </p>
     * @see ModelElementFacade#hasStereotype(String stereotypeName)
     */
    public boolean hasStereotype(String stereotypeName)
    {
        return this.getSuperDependencyFacade().hasStereotype(stereotypeName);
    }

    /**
     * 
     * @see ModelElementFacade#isBindingDependenciesPresent()
     */
    public boolean isBindingDependenciesPresent()
    {
        return this.getSuperDependencyFacade().isBindingDependenciesPresent();
    }

    /**
     * <p>
     * Indicates if any constraints are present on this model element.
     * </p>
     * @see ModelElementFacade#isConstraintsPresent()
     */
    public boolean isConstraintsPresent()
    {
        return this.getSuperDependencyFacade().isConstraintsPresent();
    }

    /**
     * <p>
     * Indicates if any documentation is present on this model element.
     * </p>
     * @see ModelElementFacade#isDocumentationPresent()
     */
    public boolean isDocumentationPresent()
    {
        return this.getSuperDependencyFacade().isDocumentationPresent();
    }

    /**
     * <p>
     * True if this element name is a reserved word in Java, C#, ANSI
     * or ISO C, C++, JavaScript.
     * </p>
     * @see ModelElementFacade#isReservedWord()
     */
    public boolean isReservedWord()
    {
        return this.getSuperDependencyFacade().isReservedWord();
    }

    /**
     * 
     * @see ModelElementFacade#isTemplateParametersPresent()
     */
    public boolean isTemplateParametersPresent()
    {
        return this.getSuperDependencyFacade().isTemplateParametersPresent();
    }

    /**
     * <p>
     * Searches for the constraint with the specified 'name' on this
     * model element, and if found translates it using the specified
     * 'translation' from a translation library discovered by the
     * framework.
     * </p>
     * @see ModelElementFacade#translateConstraint(String name, String translation)
     */
    public String translateConstraint(String name, String translation)
    {
        return this.getSuperDependencyFacade().translateConstraint(name, translation);
    }

    /**
     * <p>
     * Translates all constraints belonging to this model element with
     * the given 'translation'.
     * </p>
     * @see ModelElementFacade#translateConstraints(String translation)
     */
    public String[] translateConstraints(String translation)
    {
        return this.getSuperDependencyFacade().translateConstraints(translation);
    }

    /**
     * <p>
     * Translates the constraints of the specified 'kind' belonging to
     * this model element.
     * </p>
     * @see ModelElementFacade#translateConstraints(String kind, String translation)
     */
    public String[] translateConstraints(String kind, String translation)
    {
        return this.getSuperDependencyFacade().translateConstraints(kind, translation);
    }

    /**
     * @see org.andromda.core.metafacade.MetafacadeBase#initialize()
     */
    @Override
    public void initialize()
    {
        this.getSuperDependencyFacade().initialize();
    }

    /**
     * @return Object getSuperDependencyFacade().getValidationOwner()
     * @see org.andromda.core.metafacade.MetafacadeBase#getValidationOwner()
     */
    @Override
    public Object getValidationOwner()
    {
        Object owner = this.getSuperDependencyFacade().getValidationOwner();
        return owner;
    }

    /**
     * @return String getSuperDependencyFacade().getValidationName()
     * @see org.andromda.core.metafacade.MetafacadeBase#getValidationName()
     */
    @Override
    public String getValidationName()
    {
        String name = this.getSuperDependencyFacade().getValidationName();
        return name;
    }

    /**
     * @param validationMessages Collection<ModelValidationMessage>
     * @see org.andromda.core.metafacade.MetafacadeBase#validateInvariants(Collection validationMessages)
     */
    @Override
    public void validateInvariants(Collection<ModelValidationMessage> validationMessages)
    {
        this.getSuperDependencyFacade().validateInvariants(validationMessages);
    }

    /**
     * The property that stores the name of the metafacade.
     */
    private static final String NAME_PROPERTY = "name";
    private static final String FQNAME_PROPERTY = "fullyQualifiedName";

    /**
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        final StringBuilder toString = new StringBuilder(this.getClass().getName());
        toString.append("[");
        try
        {
            toString.append(Introspector.instance().getProperty(this, FQNAME_PROPERTY));
        }
        catch (final Throwable tryAgain)
        {
            try
            {
                toString.append(Introspector.instance().getProperty(this, NAME_PROPERTY));
            }
            catch (final Throwable ignore)
            {
                // - just ignore when the metafacade doesn't have a name or fullyQualifiedName property
            }
        }
        toString.append("]");
        return toString.toString();
    }
}