// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import java.util.Collection;
import org.andromda.metafacades.uml.ClassifierFacade;
import org.andromda.metafacades.uml.Entity;

/**
 * <p>
 * Represents a Spring persistent entity
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface SpringEntity
    extends Entity
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isSpringEntityMetaType();

    /**
     * <p>
     * Returns all value object references (this includes all those
     * that are inherited from any parent entities)
     * </p>
     * @return Collection<ClassifierFacade>
     */
    public Collection<ClassifierFacade> getAllValueObjectReferences();

    /**
     * <p>
     * A quoted comma separated list of the names of embedded values
     * belonging to this entity (that represented as attributes)
     * </p>
     * @return String
     */
    public String getAttributeEmbeddedValueList();

    /**
     * <p>
     * Gets the Spring bean name, and optionally adds a target suffix,
     * if 'targetSuffix' is set to true.
     * </p>
     * @param targetSuffix boolean
     * @return String
     */
    public String getBeanName(boolean targetSuffix);

    /**
     * <p>
     * The DAO base class name.  This is the abstract DAO that contains
     * CRUD operations
     * </p>
     * <p>
     * as well as any generated finders defined on an entity.
     * </p>
     * @return String
     */
    public String getDaoBaseName();

    /**
     * <p>
     * The business operations modeled on the entity that will be
     * generated on the DAO (Data Access Object).
     * </p>
     * @return Collection<SpringEntityOperation>
     */
    public Collection<SpringEntityOperation> getDaoBusinessOperations();

    /**
     * <p>
     * The DAO implementation class name.
     * </p>
     * @return String
     */
    public String getDaoImplementationName();

    /**
     * <p>
     * The name of the DAO for the specified entity.
     * </p>
     * @return String
     */
    public String getDaoName();

    /**
     * <p>
     * The constant name denoting no transformation is to be applied.
     * </p>
     * @return String
     */
    public String getDaoNoTransformationConstantName();

    /**
     * <p>
     * The implementation name for the entity.
     * </p>
     * @return String
     */
    public String getEntityImplementationName();

    /**
     * <p>
     * The name of the plain entity name.
     * </p>
     * @return String
     */
    public String getEntityName();

    /**
     * <p>
     * The fully qualified name of the base DAO.
     * </p>
     * @return String
     */
    public String getFullyQualifiedDaoBaseName();

    /**
     * <p>
     * The fully qualified name of the DAO implemetation.
     * </p>
     * @return String
     */
    public String getFullyQualifiedDaoImplementationName();

    /**
     * <p>
     * The fully qualified name of the DAO.
     * </p>
     * @return String
     */
    public String getFullyQualifiedDaoName();

    /**
     * <p>
     * The fully qualified name of the entity implementation class.
     * </p>
     * @return String
     */
    public String getFullyQualifiedEntityImplementationName();

    /**
     * <p>
     * The fully qualified name of the entity class.
     * </p>
     * @return String
     */
    public String getFullyQualifiedEntityName();

    /**
     * <p>
     * Return the value of the tagged value
     * andromda_hibernate_inheritance.
     * </p>
     * @return String
     */
    public String getHibernateInheritanceStrategy();

    /**
     * <p>
     * Travels up the inheritance hierarchy and retrieves the root of
     * this entity.  If the root is the entity itself then just the
     * entity is returned.
     * </p>
     * @return SpringEntity
     */
    public SpringEntity getRoot();

    /**
     * 
     * @return Collection<ClassifierFacade>
     */
    public Collection<ClassifierFacade> getValueObjectReferences();

    /**
     * <p>
     * Indicates whether or not any business DAO operations are
     * present.
     * </p>
     * @return boolean
     */
    public boolean isDaoBusinessOperationsPresent();

    /**
     * <p>
     * True if an implementation is required for the dao class, this is
     * the case when there are business operations or value-object
     * transformation.
     * </p>
     * @return boolean
     */
    public boolean isDaoImplementationRequired();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is class.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceClass();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is concrete.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceConcrete();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is interface.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceInterface();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is subclass.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceSubclass();

    /**
     * <p>
     * Indicates whether or not this entity requires a Hibernate
     * mapping cfg.xml file within the Spring application context.
     * </p>
     * @return boolean
     */
    public boolean isRequiresHibernateMapping();

    /**
     * <p>
     * Returns true if this entity is meant to be used in a richt
     * client application.
     * </p>
     * @return boolean
     */
    public boolean isRichClient();
}