// license-header java merge-point
//
// Attention: generated code (by MetafacadeLogic.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import java.util.Collection;
import java.util.List;
import org.andromda.core.common.Introspector;
import org.andromda.core.metafacade.MetafacadeBase;
import org.andromda.core.metafacade.MetafacadeFactory;
import org.andromda.core.metafacade.ModelValidationMessage;
import org.andromda.metafacades.uml.AssociationEndFacade;
import org.andromda.metafacades.uml.AttributeFacade;
import org.andromda.metafacades.uml.ClassifierFacade;
import org.andromda.metafacades.uml.ConstraintFacade;
import org.andromda.metafacades.uml.DependencyFacade;
import org.andromda.metafacades.uml.Entity;
import org.andromda.metafacades.uml.EntityAssociationEnd;
import org.andromda.metafacades.uml.EntityAttribute;
import org.andromda.metafacades.uml.EntityQueryOperation;
import org.andromda.metafacades.uml.GeneralizableElementFacade;
import org.andromda.metafacades.uml.GeneralizationFacade;
import org.andromda.metafacades.uml.ModelElementFacade;
import org.andromda.metafacades.uml.ModelFacade;
import org.andromda.metafacades.uml.OperationFacade;
import org.andromda.metafacades.uml.PackageFacade;
import org.andromda.metafacades.uml.StateMachineFacade;
import org.andromda.metafacades.uml.StereotypeFacade;
import org.andromda.metafacades.uml.TaggedValueFacade;
import org.andromda.metafacades.uml.TemplateParameterFacade;
import org.andromda.metafacades.uml.TypeMappings;
import org.apache.log4j.Logger;

/**
 * <p>
 * Represents a Spring persistent entity
 * </p>
 * MetafacadeLogic for SpringEntity
 *
 * @see SpringEntity
 */
public abstract class SpringEntityLogic
    extends MetafacadeBase
    implements SpringEntity
{
    /**
     * The underlying UML object
     * @see Object
     */
    protected Object metaObject;

    /** Create Metafacade implementation instance using the MetafacadeFactory from the context
     * @param metaObjectIn
     * @param context
     */
    protected SpringEntityLogic(Object metaObjectIn, String context)
    {
        super(metaObjectIn, getContext(context));
        this.superEntity =
           (Entity)
            MetafacadeFactory.getInstance().createFacadeImpl(
                    "org.andromda.metafacades.uml.Entity",
                    metaObjectIn,
                    getContext(context));
        this.metaObject = metaObjectIn;
    }

    /**
     * The logger instance.
     */
    private static final Logger logger = Logger.getLogger(SpringEntityLogic.class);

    /**
     * Gets the context for this metafacade logic instance.
     * @param context String. Set to SpringEntity if null
     * @return context String
     */
    private static String getContext(String context)
    {
        if (context == null)
        {
            context = "org.andromda.cartridges.spring.metafacades.SpringEntity";
        }
        return context;
    }

    private Entity superEntity;
    private boolean superEntityInitialized = false;

    /**
     * Gets the Entity parent instance.
     * @return this.superEntity Entity
     */
    private Entity getSuperEntity()
    {
        if (!this.superEntityInitialized)
        {
            ((MetafacadeBase)this.superEntity).setMetafacadeContext(this.getMetafacadeContext());
            this.superEntityInitialized = true;
        }
        return this.superEntity;
    }

    /** Reset context only for non-root metafacades
     * @param context
     * @see MetafacadeBase#resetMetafacadeContext(String context)
     */
    @Override
    public void resetMetafacadeContext(String context)
    {
        if (!this.contextRoot) // reset context only for non-root metafacades
        {
            context = getContext(context);  // to have same value as in original constructor call
            setMetafacadeContext (context);
            if (this.superEntityInitialized)
            {
                ((MetafacadeBase)this.superEntity).resetMetafacadeContext(context);
            }
        }
    }

    /**
     * @return boolean true always
     * @see SpringEntity
     */
    public boolean isSpringEntityMetaType()
    {
        return true;
    }

    // --------------- attributes ---------------------

   /**
    * @see SpringEntity#isDaoBusinessOperationsPresent()
    * @return boolean
    */
    protected abstract boolean handleIsDaoBusinessOperationsPresent();

    private boolean __daoBusinessOperationsPresent1a;
    private boolean __daoBusinessOperationsPresent1aSet = false;

    /**
     * <p>
     * Indicates whether or not any business DAO operations are
     * present.
     * </p>
     * @return (boolean)handleIsDaoBusinessOperationsPresent()
     */
    public final boolean isDaoBusinessOperationsPresent()
    {
        boolean daoBusinessOperationsPresent1a = this.__daoBusinessOperationsPresent1a;
        if (!this.__daoBusinessOperationsPresent1aSet)
        {
            // daoBusinessOperationsPresent has no pre constraints
            daoBusinessOperationsPresent1a = handleIsDaoBusinessOperationsPresent();
            // daoBusinessOperationsPresent has no post constraints
            this.__daoBusinessOperationsPresent1a = daoBusinessOperationsPresent1a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoBusinessOperationsPresent1aSet = true;
            }
        }
        return daoBusinessOperationsPresent1a;
    }

   /**
    * @see SpringEntity#isDaoImplementationRequired()
    * @return boolean
    */
    protected abstract boolean handleIsDaoImplementationRequired();

    private boolean __daoImplementationRequired2a;
    private boolean __daoImplementationRequired2aSet = false;

    /**
     * <p>
     * True if an implementation is required for the dao class, this is
     * the case when there are business operations or value-object
     * transformation.
     * </p>
     * @return (boolean)handleIsDaoImplementationRequired()
     */
    public final boolean isDaoImplementationRequired()
    {
        boolean daoImplementationRequired2a = this.__daoImplementationRequired2a;
        if (!this.__daoImplementationRequired2aSet)
        {
            // daoImplementationRequired has no pre constraints
            daoImplementationRequired2a = handleIsDaoImplementationRequired();
            // daoImplementationRequired has no post constraints
            this.__daoImplementationRequired2a = daoImplementationRequired2a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoImplementationRequired2aSet = true;
            }
        }
        return daoImplementationRequired2a;
    }

   /**
    * @see SpringEntity#getDaoNoTransformationConstantName()
    * @return String
    */
    protected abstract String handleGetDaoNoTransformationConstantName();

    private String __daoNoTransformationConstantName3a;
    private boolean __daoNoTransformationConstantName3aSet = false;

    /**
     * <p>
     * The constant name denoting no transformation is to be applied.
     * </p>
     * @return (String)handleGetDaoNoTransformationConstantName()
     */
    public final String getDaoNoTransformationConstantName()
    {
        String daoNoTransformationConstantName3a = this.__daoNoTransformationConstantName3a;
        if (!this.__daoNoTransformationConstantName3aSet)
        {
            // daoNoTransformationConstantName has no pre constraints
            daoNoTransformationConstantName3a = handleGetDaoNoTransformationConstantName();
            // daoNoTransformationConstantName has no post constraints
            this.__daoNoTransformationConstantName3a = daoNoTransformationConstantName3a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoNoTransformationConstantName3aSet = true;
            }
        }
        return daoNoTransformationConstantName3a;
    }

   /**
    * @see SpringEntity#isHibernateInheritanceClass()
    * @return boolean
    */
    protected abstract boolean handleIsHibernateInheritanceClass();

    private boolean __hibernateInheritanceClass4a;
    private boolean __hibernateInheritanceClass4aSet = false;

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is class.
     * </p>
     * @return (boolean)handleIsHibernateInheritanceClass()
     */
    public final boolean isHibernateInheritanceClass()
    {
        boolean hibernateInheritanceClass4a = this.__hibernateInheritanceClass4a;
        if (!this.__hibernateInheritanceClass4aSet)
        {
            // hibernateInheritanceClass has no pre constraints
            hibernateInheritanceClass4a = handleIsHibernateInheritanceClass();
            // hibernateInheritanceClass has no post constraints
            this.__hibernateInheritanceClass4a = hibernateInheritanceClass4a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__hibernateInheritanceClass4aSet = true;
            }
        }
        return hibernateInheritanceClass4a;
    }

   /**
    * @see SpringEntity#isHibernateInheritanceConcrete()
    * @return boolean
    */
    protected abstract boolean handleIsHibernateInheritanceConcrete();

    private boolean __hibernateInheritanceConcrete5a;
    private boolean __hibernateInheritanceConcrete5aSet = false;

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is concrete.
     * </p>
     * @return (boolean)handleIsHibernateInheritanceConcrete()
     */
    public final boolean isHibernateInheritanceConcrete()
    {
        boolean hibernateInheritanceConcrete5a = this.__hibernateInheritanceConcrete5a;
        if (!this.__hibernateInheritanceConcrete5aSet)
        {
            // hibernateInheritanceConcrete has no pre constraints
            hibernateInheritanceConcrete5a = handleIsHibernateInheritanceConcrete();
            // hibernateInheritanceConcrete has no post constraints
            this.__hibernateInheritanceConcrete5a = hibernateInheritanceConcrete5a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__hibernateInheritanceConcrete5aSet = true;
            }
        }
        return hibernateInheritanceConcrete5a;
    }

   /**
    * @see SpringEntity#isHibernateInheritanceInterface()
    * @return boolean
    */
    protected abstract boolean handleIsHibernateInheritanceInterface();

    private boolean __hibernateInheritanceInterface6a;
    private boolean __hibernateInheritanceInterface6aSet = false;

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is interface.
     * </p>
     * @return (boolean)handleIsHibernateInheritanceInterface()
     */
    public final boolean isHibernateInheritanceInterface()
    {
        boolean hibernateInheritanceInterface6a = this.__hibernateInheritanceInterface6a;
        if (!this.__hibernateInheritanceInterface6aSet)
        {
            // hibernateInheritanceInterface has no pre constraints
            hibernateInheritanceInterface6a = handleIsHibernateInheritanceInterface();
            // hibernateInheritanceInterface has no post constraints
            this.__hibernateInheritanceInterface6a = hibernateInheritanceInterface6a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__hibernateInheritanceInterface6aSet = true;
            }
        }
        return hibernateInheritanceInterface6a;
    }

   /**
    * @see SpringEntity#isHibernateInheritanceSubclass()
    * @return boolean
    */
    protected abstract boolean handleIsHibernateInheritanceSubclass();

    private boolean __hibernateInheritanceSubclass7a;
    private boolean __hibernateInheritanceSubclass7aSet = false;

    /**
     * <p>
     * Return true if the hibernate inheritance strategy is subclass.
     * </p>
     * @return (boolean)handleIsHibernateInheritanceSubclass()
     */
    public final boolean isHibernateInheritanceSubclass()
    {
        boolean hibernateInheritanceSubclass7a = this.__hibernateInheritanceSubclass7a;
        if (!this.__hibernateInheritanceSubclass7aSet)
        {
            // hibernateInheritanceSubclass has no pre constraints
            hibernateInheritanceSubclass7a = handleIsHibernateInheritanceSubclass();
            // hibernateInheritanceSubclass has no post constraints
            this.__hibernateInheritanceSubclass7a = hibernateInheritanceSubclass7a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__hibernateInheritanceSubclass7aSet = true;
            }
        }
        return hibernateInheritanceSubclass7a;
    }

   /**
    * @see SpringEntity#getHibernateInheritanceStrategy()
    * @return String
    */
    protected abstract String handleGetHibernateInheritanceStrategy();

    private String __hibernateInheritanceStrategy8a;
    private boolean __hibernateInheritanceStrategy8aSet = false;

    /**
     * <p>
     * Return the value of the tagged value
     * andromda_hibernate_inheritance.
     * </p>
     * @return (String)handleGetHibernateInheritanceStrategy()
     */
    public final String getHibernateInheritanceStrategy()
    {
        String hibernateInheritanceStrategy8a = this.__hibernateInheritanceStrategy8a;
        if (!this.__hibernateInheritanceStrategy8aSet)
        {
            // hibernateInheritanceStrategy has no pre constraints
            hibernateInheritanceStrategy8a = handleGetHibernateInheritanceStrategy();
            // hibernateInheritanceStrategy has no post constraints
            this.__hibernateInheritanceStrategy8a = hibernateInheritanceStrategy8a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__hibernateInheritanceStrategy8aSet = true;
            }
        }
        return hibernateInheritanceStrategy8a;
    }

   /**
    * @see SpringEntity#getFullyQualifiedEntityName()
    * @return String
    */
    protected abstract String handleGetFullyQualifiedEntityName();

    private String __fullyQualifiedEntityName9a;
    private boolean __fullyQualifiedEntityName9aSet = false;

    /**
     * <p>
     * The fully qualified name of the entity class.
     * </p>
     * @return (String)handleGetFullyQualifiedEntityName()
     */
    public final String getFullyQualifiedEntityName()
    {
        String fullyQualifiedEntityName9a = this.__fullyQualifiedEntityName9a;
        if (!this.__fullyQualifiedEntityName9aSet)
        {
            // fullyQualifiedEntityName has no pre constraints
            fullyQualifiedEntityName9a = handleGetFullyQualifiedEntityName();
            // fullyQualifiedEntityName has no post constraints
            this.__fullyQualifiedEntityName9a = fullyQualifiedEntityName9a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__fullyQualifiedEntityName9aSet = true;
            }
        }
        return fullyQualifiedEntityName9a;
    }

   /**
    * @see SpringEntity#getFullyQualifiedEntityImplementationName()
    * @return String
    */
    protected abstract String handleGetFullyQualifiedEntityImplementationName();

    private String __fullyQualifiedEntityImplementationName10a;
    private boolean __fullyQualifiedEntityImplementationName10aSet = false;

    /**
     * <p>
     * The fully qualified name of the entity implementation class.
     * </p>
     * @return (String)handleGetFullyQualifiedEntityImplementationName()
     */
    public final String getFullyQualifiedEntityImplementationName()
    {
        String fullyQualifiedEntityImplementationName10a = this.__fullyQualifiedEntityImplementationName10a;
        if (!this.__fullyQualifiedEntityImplementationName10aSet)
        {
            // fullyQualifiedEntityImplementationName has no pre constraints
            fullyQualifiedEntityImplementationName10a = handleGetFullyQualifiedEntityImplementationName();
            // fullyQualifiedEntityImplementationName has no post constraints
            this.__fullyQualifiedEntityImplementationName10a = fullyQualifiedEntityImplementationName10a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__fullyQualifiedEntityImplementationName10aSet = true;
            }
        }
        return fullyQualifiedEntityImplementationName10a;
    }

   /**
    * @see SpringEntity#getDaoBaseName()
    * @return String
    */
    protected abstract String handleGetDaoBaseName();

    private String __daoBaseName11a;
    private boolean __daoBaseName11aSet = false;

    /**
     * <p>
     * The DAO base class name.  This is the abstract DAO that contains
     * CRUD operations
     * </p>
     * <p>
     * as well as any generated finders defined on an entity.
     * </p>
     * @return (String)handleGetDaoBaseName()
     */
    public final String getDaoBaseName()
    {
        String daoBaseName11a = this.__daoBaseName11a;
        if (!this.__daoBaseName11aSet)
        {
            // daoBaseName has no pre constraints
            daoBaseName11a = handleGetDaoBaseName();
            // daoBaseName has no post constraints
            this.__daoBaseName11a = daoBaseName11a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoBaseName11aSet = true;
            }
        }
        return daoBaseName11a;
    }

   /**
    * @see SpringEntity#getDaoName()
    * @return String
    */
    protected abstract String handleGetDaoName();

    private String __daoName12a;
    private boolean __daoName12aSet = false;

    /**
     * <p>
     * The name of the DAO for the specified entity.
     * </p>
     * @return (String)handleGetDaoName()
     */
    public final String getDaoName()
    {
        String daoName12a = this.__daoName12a;
        if (!this.__daoName12aSet)
        {
            // daoName has no pre constraints
            daoName12a = handleGetDaoName();
            // daoName has no post constraints
            this.__daoName12a = daoName12a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoName12aSet = true;
            }
        }
        return daoName12a;
    }

   /**
    * @see SpringEntity#getDaoImplementationName()
    * @return String
    */
    protected abstract String handleGetDaoImplementationName();

    private String __daoImplementationName13a;
    private boolean __daoImplementationName13aSet = false;

    /**
     * <p>
     * The DAO implementation class name.
     * </p>
     * @return (String)handleGetDaoImplementationName()
     */
    public final String getDaoImplementationName()
    {
        String daoImplementationName13a = this.__daoImplementationName13a;
        if (!this.__daoImplementationName13aSet)
        {
            // daoImplementationName has no pre constraints
            daoImplementationName13a = handleGetDaoImplementationName();
            // daoImplementationName has no post constraints
            this.__daoImplementationName13a = daoImplementationName13a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__daoImplementationName13aSet = true;
            }
        }
        return daoImplementationName13a;
    }

   /**
    * @see SpringEntity#getEntityImplementationName()
    * @return String
    */
    protected abstract String handleGetEntityImplementationName();

    private String __entityImplementationName14a;
    private boolean __entityImplementationName14aSet = false;

    /**
     * <p>
     * The implementation name for the entity.
     * </p>
     * @return (String)handleGetEntityImplementationName()
     */
    public final String getEntityImplementationName()
    {
        String entityImplementationName14a = this.__entityImplementationName14a;
        if (!this.__entityImplementationName14aSet)
        {
            // entityImplementationName has no pre constraints
            entityImplementationName14a = handleGetEntityImplementationName();
            // entityImplementationName has no post constraints
            this.__entityImplementationName14a = entityImplementationName14a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__entityImplementationName14aSet = true;
            }
        }
        return entityImplementationName14a;
    }

   /**
    * @see SpringEntity#getEntityName()
    * @return String
    */
    protected abstract String handleGetEntityName();

    private String __entityName15a;
    private boolean __entityName15aSet = false;

    /**
     * <p>
     * The name of the plain entity name.
     * </p>
     * @return (String)handleGetEntityName()
     */
    public final String getEntityName()
    {
        String entityName15a = this.__entityName15a;
        if (!this.__entityName15aSet)
        {
            // entityName has no pre constraints
            entityName15a = handleGetEntityName();
            // entityName has no post constraints
            this.__entityName15a = entityName15a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__entityName15aSet = true;
            }
        }
        return entityName15a;
    }

   /**
    * @see SpringEntity#getFullyQualifiedDaoBaseName()
    * @return String
    */
    protected abstract String handleGetFullyQualifiedDaoBaseName();

    private String __fullyQualifiedDaoBaseName16a;
    private boolean __fullyQualifiedDaoBaseName16aSet = false;

    /**
     * <p>
     * The fully qualified name of the base DAO.
     * </p>
     * @return (String)handleGetFullyQualifiedDaoBaseName()
     */
    public final String getFullyQualifiedDaoBaseName()
    {
        String fullyQualifiedDaoBaseName16a = this.__fullyQualifiedDaoBaseName16a;
        if (!this.__fullyQualifiedDaoBaseName16aSet)
        {
            // fullyQualifiedDaoBaseName has no pre constraints
            fullyQualifiedDaoBaseName16a = handleGetFullyQualifiedDaoBaseName();
            // fullyQualifiedDaoBaseName has no post constraints
            this.__fullyQualifiedDaoBaseName16a = fullyQualifiedDaoBaseName16a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__fullyQualifiedDaoBaseName16aSet = true;
            }
        }
        return fullyQualifiedDaoBaseName16a;
    }

   /**
    * @see SpringEntity#getFullyQualifiedDaoImplementationName()
    * @return String
    */
    protected abstract String handleGetFullyQualifiedDaoImplementationName();

    private String __fullyQualifiedDaoImplementationName17a;
    private boolean __fullyQualifiedDaoImplementationName17aSet = false;

    /**
     * <p>
     * The fully qualified name of the DAO implemetation.
     * </p>
     * @return (String)handleGetFullyQualifiedDaoImplementationName()
     */
    public final String getFullyQualifiedDaoImplementationName()
    {
        String fullyQualifiedDaoImplementationName17a = this.__fullyQualifiedDaoImplementationName17a;
        if (!this.__fullyQualifiedDaoImplementationName17aSet)
        {
            // fullyQualifiedDaoImplementationName has no pre constraints
            fullyQualifiedDaoImplementationName17a = handleGetFullyQualifiedDaoImplementationName();
            // fullyQualifiedDaoImplementationName has no post constraints
            this.__fullyQualifiedDaoImplementationName17a = fullyQualifiedDaoImplementationName17a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__fullyQualifiedDaoImplementationName17aSet = true;
            }
        }
        return fullyQualifiedDaoImplementationName17a;
    }

   /**
    * @see SpringEntity#getFullyQualifiedDaoName()
    * @return String
    */
    protected abstract String handleGetFullyQualifiedDaoName();

    private String __fullyQualifiedDaoName18a;
    private boolean __fullyQualifiedDaoName18aSet = false;

    /**
     * <p>
     * The fully qualified name of the DAO.
     * </p>
     * @return (String)handleGetFullyQualifiedDaoName()
     */
    public final String getFullyQualifiedDaoName()
    {
        String fullyQualifiedDaoName18a = this.__fullyQualifiedDaoName18a;
        if (!this.__fullyQualifiedDaoName18aSet)
        {
            // fullyQualifiedDaoName has no pre constraints
            fullyQualifiedDaoName18a = handleGetFullyQualifiedDaoName();
            // fullyQualifiedDaoName has no post constraints
            this.__fullyQualifiedDaoName18a = fullyQualifiedDaoName18a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__fullyQualifiedDaoName18aSet = true;
            }
        }
        return fullyQualifiedDaoName18a;
    }

   /**
    * @see SpringEntity#isRequiresHibernateMapping()
    * @return boolean
    */
    protected abstract boolean handleIsRequiresHibernateMapping();

    private boolean __requiresHibernateMapping19a;
    private boolean __requiresHibernateMapping19aSet = false;

    /**
     * <p>
     * Indicates whether or not this entity requires a Hibernate
     * mapping cfg.xml file within the Spring application context.
     * </p>
     * @return (boolean)handleIsRequiresHibernateMapping()
     */
    public final boolean isRequiresHibernateMapping()
    {
        boolean requiresHibernateMapping19a = this.__requiresHibernateMapping19a;
        if (!this.__requiresHibernateMapping19aSet)
        {
            // requiresHibernateMapping has no pre constraints
            requiresHibernateMapping19a = handleIsRequiresHibernateMapping();
            // requiresHibernateMapping has no post constraints
            this.__requiresHibernateMapping19a = requiresHibernateMapping19a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__requiresHibernateMapping19aSet = true;
            }
        }
        return requiresHibernateMapping19a;
    }

   /**
    * @see SpringEntity#getAttributeEmbeddedValueList()
    * @return String
    */
    protected abstract String handleGetAttributeEmbeddedValueList();

    private String __attributeEmbeddedValueList20a;
    private boolean __attributeEmbeddedValueList20aSet = false;

    /**
     * <p>
     * A quoted comma separated list of the names of embedded values
     * belonging to this entity (that represented as attributes)
     * </p>
     * @return (String)handleGetAttributeEmbeddedValueList()
     */
    public final String getAttributeEmbeddedValueList()
    {
        String attributeEmbeddedValueList20a = this.__attributeEmbeddedValueList20a;
        if (!this.__attributeEmbeddedValueList20aSet)
        {
            // attributeEmbeddedValueList has no pre constraints
            attributeEmbeddedValueList20a = handleGetAttributeEmbeddedValueList();
            // attributeEmbeddedValueList has no post constraints
            this.__attributeEmbeddedValueList20a = attributeEmbeddedValueList20a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__attributeEmbeddedValueList20aSet = true;
            }
        }
        return attributeEmbeddedValueList20a;
    }

   /**
    * @see SpringEntity#isRichClient()
    * @return boolean
    */
    protected abstract boolean handleIsRichClient();

    private boolean __richClient21a;
    private boolean __richClient21aSet = false;

    /**
     * <p>
     * Returns true if this entity is meant to be used in a richt
     * client application.
     * </p>
     * @return (boolean)handleIsRichClient()
     */
    public final boolean isRichClient()
    {
        boolean richClient21a = this.__richClient21a;
        if (!this.__richClient21aSet)
        {
            // richClient has no pre constraints
            richClient21a = handleIsRichClient();
            // richClient has no post constraints
            this.__richClient21a = richClient21a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__richClient21aSet = true;
            }
        }
        return richClient21a;
    }

    // ---------------- business methods ----------------------

    /**
     * Method to be implemented in descendants
     * <p>
     * Gets the Spring bean name, and optionally adds a target suffix,
     * if 'targetSuffix' is set to true.
     * </p>
     * @param targetSuffix
     * @return String
     */
    protected abstract String handleGetBeanName(boolean targetSuffix);

    /**
     * <p>
     * Gets the Spring bean name, and optionally adds a target suffix,
     * if 'targetSuffix' is set to true.
     * </p>
     * @param targetSuffix boolean
     * <p>
     * Whether or not to add a target suffix to the bean name.
     * </p>
     * @return handleGetBeanName(targetSuffix)
     */
    public String getBeanName(boolean targetSuffix)
    {
        // getBeanName has no pre constraints
        String returnValue = handleGetBeanName(targetSuffix);
        // getBeanName has no post constraints
        return returnValue;
    }

    // ------------- associations ------------------

    /**
     * 
     * @return (Collection<ClassifierFacade>)handleGetValueObjectReferences()
     */
    public final Collection<ClassifierFacade> getValueObjectReferences()
    {
        Collection<ClassifierFacade> getValueObjectReferences1r = null;
        // springEntity has no pre constraints
        Collection result = handleGetValueObjectReferences();
        List shieldedResult = this.shieldedElements(result);
        try
        {
            getValueObjectReferences1r = (Collection<ClassifierFacade>)shieldedResult;
        }
        catch (ClassCastException ex)
        {
            // Bad things happen if the metafacade type mapping in metafacades.xml is wrong - Warn
            SpringEntityLogic.logger.warn("incorrect metafacade cast for SpringEntityLogic.getValueObjectReferences Collection<ClassifierFacade> " + result + ": " + shieldedResult);
        }
        // springEntity has no post constraints
        return getValueObjectReferences1r;
    }

    /**
     * UML Specific type is returned in Collection, transformed by shieldedElements to AndroMDA Metafacade type
     * @return  Collection
     */
    protected abstract Collection handleGetValueObjectReferences();

    private SpringEntity __getRoot3r;
    private boolean __getRoot3rSet = false;

    /**
     * 
     * @return (SpringEntity)handleGetRoot()
     */
    public final SpringEntity getRoot()
    {
        SpringEntity getRoot3r = this.__getRoot3r;
        if (!this.__getRoot3rSet)
        {
            // springEntity has no pre constraints
            Object result = handleGetRoot();
            MetafacadeBase shieldedResult = this.shieldedElement(result);
            try
            {
                getRoot3r = (SpringEntity)shieldedResult;
            }
            catch (ClassCastException ex)
            {
                // Bad things happen if the metafacade type mapping in metafacades.xml is wrong - Warn
                SpringEntityLogic.logger.warn("incorrect metafacade cast for SpringEntityLogic.getRoot SpringEntity " + result + ": " + shieldedResult);
            }
            // springEntity has no post constraints
            this.__getRoot3r = getRoot3r;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__getRoot3rSet = true;
            }
        }
        return getRoot3r;
    }

    /**
     * UML Specific type is transformed by shieldedElements to AndroMDA Metafacade type
     * @return Object
     */
    protected abstract Object handleGetRoot();

    private Collection<SpringEntityOperation> __getDaoBusinessOperations4r;
    private boolean __getDaoBusinessOperations4rSet = false;

    /**
     * 
     * @return (Collection<SpringEntityOperation>)handleGetDaoBusinessOperations()
     */
    public final Collection<SpringEntityOperation> getDaoBusinessOperations()
    {
        Collection<SpringEntityOperation> getDaoBusinessOperations4r = this.__getDaoBusinessOperations4r;
        if (!this.__getDaoBusinessOperations4rSet)
        {
            // springEntity has no pre constraints
            Collection result = handleGetDaoBusinessOperations();
            List shieldedResult = this.shieldedElements(result);
            try
            {
                getDaoBusinessOperations4r = (Collection<SpringEntityOperation>)shieldedResult;
            }
            catch (ClassCastException ex)
            {
                // Bad things happen if the metafacade type mapping in metafacades.xml is wrong - Warn
                SpringEntityLogic.logger.warn("incorrect metafacade cast for SpringEntityLogic.getDaoBusinessOperations Collection<SpringEntityOperation> " + result + ": " + shieldedResult);
            }
            // springEntity has no post constraints
            this.__getDaoBusinessOperations4r = getDaoBusinessOperations4r;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__getDaoBusinessOperations4rSet = true;
            }
        }
        return getDaoBusinessOperations4r;
    }

    /**
     * UML Specific type is returned in Collection, transformed by shieldedElements to AndroMDA Metafacade type
     * @return  Collection
     */
    protected abstract Collection handleGetDaoBusinessOperations();

    /**
     * 
     * @return (Collection<ClassifierFacade>)handleGetAllValueObjectReferences()
     */
    public final Collection<ClassifierFacade> getAllValueObjectReferences()
    {
        Collection<ClassifierFacade> getAllValueObjectReferences5r = null;
        // springEntity has no pre constraints
        Collection result = handleGetAllValueObjectReferences();
        List shieldedResult = this.shieldedElements(result);
        try
        {
            getAllValueObjectReferences5r = (Collection<ClassifierFacade>)shieldedResult;
        }
        catch (ClassCastException ex)
        {
            // Bad things happen if the metafacade type mapping in metafacades.xml is wrong - Warn
            SpringEntityLogic.logger.warn("incorrect metafacade cast for SpringEntityLogic.getAllValueObjectReferences Collection<ClassifierFacade> " + result + ": " + shieldedResult);
        }
        // springEntity has no post constraints
        return getAllValueObjectReferences5r;
    }

    /**
     * UML Specific type is returned in Collection, transformed by shieldedElements to AndroMDA Metafacade type
     * @return  Collection
     */
    protected abstract Collection handleGetAllValueObjectReferences();

    /**
     * @return true
     * @see Entity
     */
    public boolean isEntityMetaType()
    {
        return true;
    }

    /**
     * @return true
     * @see ClassifierFacade
     */
    public boolean isClassifierFacadeMetaType()
    {
        return true;
    }

    /**
     * @return true
     * @see GeneralizableElementFacade
     */
    public boolean isGeneralizableElementFacadeMetaType()
    {
        return true;
    }

    /**
     * @return true
     * @see ModelElementFacade
     */
    public boolean isModelElementFacadeMetaType()
    {
        return true;
    }

    // ----------- delegates to Entity ------------
    /**
     * <p>
     * Return the attribute which name matches the parameter
     * </p>
     * @see ClassifierFacade#findAttribute(String name)
     */
    public AttributeFacade findAttribute(String name)
    {
        return this.getSuperEntity().findAttribute(name);
    }

    /**
     * <p>
     * Those abstraction dependencies for which this classifier is the
     * client.
     * </p>
     * @see ClassifierFacade#getAbstractions()
     */
    public Collection<ClassifierFacade> getAbstractions()
    {
        return this.getSuperEntity().getAbstractions();
    }

    /**
     * <p>
     * Lists all classes associated to this one and any ancestor
     * classes (through generalization). There will be no duplicates.
     * The order of the elements is predictable.
     * </p>
     * @see ClassifierFacade#getAllAssociatedClasses()
     */
    public Collection<ClassifierFacade> getAllAssociatedClasses()
    {
        return this.getSuperEntity().getAllAssociatedClasses();
    }

    /**
     * <p>
     * A collection containing all 'properties' of the classifier and
     * its ancestors.  Properties are any attributes and navigable
     * connecting association ends.
     * </p>
     * @see ClassifierFacade#getAllProperties()
     */
    public Collection getAllProperties()
    {
        return this.getSuperEntity().getAllProperties();
    }

    /**
     * <p>
     * A collection containing all required and/or read-only
     * 'properties' of the classifier and its ancestors. Properties are
     * any attributes and navigable connecting association ends.
     * </p>
     * @see ClassifierFacade#getAllRequiredConstructorParameters()
     */
    public Collection getAllRequiredConstructorParameters()
    {
        return this.getSuperEntity().getAllRequiredConstructorParameters();
    }

    /**
     * <p>
     * Gets the array type for this classifier.  If this classifier
     * already represents an array, it just returns itself.
     * </p>
     * @see ClassifierFacade#getArray()
     */
    public ClassifierFacade getArray()
    {
        return this.getSuperEntity().getArray();
    }

    /**
     * <p>
     * The name of the classifier as an array.
     * </p>
     * @see ClassifierFacade#getArrayName()
     */
    public String getArrayName()
    {
        return this.getSuperEntity().getArrayName();
    }

    /**
     * <p>
     * Lists the classes associated to this one, there is no repitition
     * of classes. The order of the elements is predictable.
     * </p>
     * @see ClassifierFacade#getAssociatedClasses()
     */
    public Collection<ClassifierFacade> getAssociatedClasses()
    {
        return this.getSuperEntity().getAssociatedClasses();
    }

    /**
     * <p>
     * Gets the association ends belonging to a classifier.
     * </p>
     * @see ClassifierFacade#getAssociationEnds()
     */
    public List<AssociationEndFacade> getAssociationEnds()
    {
        return this.getSuperEntity().getAssociationEnds();
    }

    /**
     * <p>
     * Gets the attributes that belong to the classifier.
     * </p>
     * @see ClassifierFacade#getAttributes()
     */
    public List<AttributeFacade> getAttributes()
    {
        return this.getSuperEntity().getAttributes();
    }

    /**
     * <p>
     * Gets all attributes for the classifier and if 'follow' is true
     * goes up the inheritance hierarchy and gets the attributes from
     * the super classes as well.
     * </p>
     * @see ClassifierFacade#getAttributes(boolean follow)
     */
    public List getAttributes(boolean follow)
    {
        return this.getSuperEntity().getAttributes(follow);
    }

    /**
     * <p>
     * The fully qualified name of the classifier as an array.
     * </p>
     * @see ClassifierFacade#getFullyQualifiedArrayName()
     */
    public String getFullyQualifiedArrayName()
    {
        return this.getSuperEntity().getFullyQualifiedArrayName();
    }

    /**
     * <p>
     * Returns all those operations that could be implemented at this
     * classifier's level. This means the operations owned by this
     * classifier as well as any realized interface's operations
     * (recursively) in case this classifier itself is not already an
     * interface, or generalized when this classifier is an interface.
     * </p>
     * @see ClassifierFacade#getImplementationOperations()
     */
    public Collection<OperationFacade> getImplementationOperations()
    {
        return this.getSuperEntity().getImplementationOperations();
    }

    /**
     * <p>
     * A comma separated list of the fully qualified names of all
     * implemented interfaces.
     * </p>
     * @see ClassifierFacade#getImplementedInterfaceList()
     */
    public String getImplementedInterfaceList()
    {
        return this.getSuperEntity().getImplementedInterfaceList();
    }

    /**
     * <p>
     * Those attributes that are scoped to an instance of this class.
     * </p>
     * @see ClassifierFacade#getInstanceAttributes()
     */
    public Collection<AttributeFacade> getInstanceAttributes()
    {
        return this.getSuperEntity().getInstanceAttributes();
    }

    /**
     * <p>
     * Those operations that are scoped to an instance of this class.
     * </p>
     * @see ClassifierFacade#getInstanceOperations()
     */
    public List<OperationFacade> getInstanceOperations()
    {
        return this.getSuperEntity().getInstanceOperations();
    }

    /**
     * <p>
     * Those interfaces that are abstractions of this classifier, this
     * basically means this classifier realizes them.
     * </p>
     * @see ClassifierFacade#getInterfaceAbstractions()
     */
    public Collection<ClassifierFacade> getInterfaceAbstractions()
    {
        return this.getSuperEntity().getInterfaceAbstractions();
    }

    /**
     * <p>
     * A String representing a new Constructor declaration for this
     * classifier type to be used in a Java environment.
     * </p>
     * @see ClassifierFacade#getJavaNewString()
     */
    public String getJavaNewString()
    {
        return this.getSuperEntity().getJavaNewString();
    }

    /**
     * <p>
     * A String representing the null-value for this classifier type to
     * be used in a Java environment.
     * </p>
     * @see ClassifierFacade#getJavaNullString()
     */
    public String getJavaNullString()
    {
        return this.getSuperEntity().getJavaNullString();
    }

    /**
     * <p>
     * The other ends of this classifier's association ends which are
     * navigable.
     * </p>
     * @see ClassifierFacade#getNavigableConnectingEnds()
     */
    public Collection<ClassifierFacade> getNavigableConnectingEnds()
    {
        return this.getSuperEntity().getNavigableConnectingEnds();
    }

    /**
     * <p>
     * Get the other ends of this classifier's association ends which
     * are navigable and if 'follow' is true goes up the inheritance
     * hierarchy and gets the super association ends as well.
     * </p>
     * @see ClassifierFacade#getNavigableConnectingEnds(boolean follow)
     */
    public List getNavigableConnectingEnds(boolean follow)
    {
        return this.getSuperEntity().getNavigableConnectingEnds(follow);
    }

    /**
     * <p>
     * Assuming that the classifier is an array, this will return the
     * non array type of the classifier from
     * </p>
     * <p>
     * the model.  If the classifier is NOT an array, it will just
     * return itself.
     * </p>
     * @see ClassifierFacade#getNonArray()
     */
    public ClassifierFacade getNonArray()
    {
        return this.getSuperEntity().getNonArray();
    }

    /**
     * <p>
     * The attributes from this classifier in the form of an operation
     * call (this example would be in Java): '(String attributeOne,
     * String attributeTwo).  If there were no attributes on the
     * classifier, the result would be an empty '()'.
     * </p>
     * @see ClassifierFacade#getOperationCallFromAttributes()
     */
    public String getOperationCallFromAttributes()
    {
        return this.getSuperEntity().getOperationCallFromAttributes();
    }

    /**
     * <p>
     * The operations owned by this classifier.
     * </p>
     * @see ClassifierFacade#getOperations()
     */
    public List<OperationFacade> getOperations()
    {
        return this.getSuperEntity().getOperations();
    }

    /**
     * <p>
     * A collection containing all 'properties' of the classifier. 
     * Properties are any attributes and navigable connecting
     * association ends.
     * </p>
     * @see ClassifierFacade#getProperties()
     */
    public List getProperties()
    {
        return this.getSuperEntity().getProperties();
    }

    /**
     * <p>
     * Gets all properties (attributes and navigable association ends)
     * for the classifier and if 'follow' is true goes up the
     * inheritance hierarchy and gets the properties from the super
     * classes as well.
     * </p>
     * @see ClassifierFacade#getProperties(boolean follow)
     */
    public List getProperties(boolean follow)
    {
        return this.getSuperEntity().getProperties(follow);
    }

    /**
     * <p>
     * A collection containing all required and/or read-only
     * 'properties' of the classifier.  Properties are any attributes
     * and navigable connecting association ends.
     * </p>
     * @see ClassifierFacade#getRequiredConstructorParameters()
     */
    public Collection getRequiredConstructorParameters()
    {
        return this.getSuperEntity().getRequiredConstructorParameters();
    }

    /**
     * <p>
     * Returns the serial version UID of the underlying model element.
     * </p>
     * @see ClassifierFacade#getSerialVersionUID()
     */
    public long getSerialVersionUID()
    {
        return this.getSuperEntity().getSerialVersionUID();
    }

    /**
     * <p>
     * Those attributes that are scoped to the definition of this
     * class.
     * </p>
     * @see ClassifierFacade#getStaticAttributes()
     */
    public Collection<AttributeFacade> getStaticAttributes()
    {
        return this.getSuperEntity().getStaticAttributes();
    }

    /**
     * <p>
     * Those operations that are scoped to the definition of this
     * class.
     * </p>
     * @see ClassifierFacade#getStaticOperations()
     */
    public List<OperationFacade> getStaticOperations()
    {
        return this.getSuperEntity().getStaticOperations();
    }

    /**
     * <p>
     * This class' superclass, returns the generalization if it is a
     * ClassifierFacade, null otherwise.
     * </p>
     * @see ClassifierFacade#getSuperClass()
     */
    public ClassifierFacade getSuperClass()
    {
        return this.getSuperEntity().getSuperClass();
    }

    /**
     * <p>
     * The wrapper name for this classifier if a mapped type has a
     * defined wrapper class (ie. 'long' maps to 'Long').  If the
     * classifier doesn't have a wrapper defined for it, this method
     * will return a null.  Note that wrapper mappings must be defined
     * for the namespace by defining the 'wrapperMappingsUri', this
     * property must point to the location of the mappings file which
     * maps the primitives to wrapper types.
     * </p>
     * @see ClassifierFacade#getWrapperName()
     */
    public String getWrapperName()
    {
        return this.getSuperEntity().getWrapperName();
    }

    /**
     * <p>
     * Indicates if this classifier is 'abstract'.
     * </p>
     * @see ClassifierFacade#isAbstract()
     */
    public boolean isAbstract()
    {
        return this.getSuperEntity().isAbstract();
    }

    /**
     * <p>
     * True if this classifier represents an array type. False
     * otherwise.
     * </p>
     * @see ClassifierFacade#isArrayType()
     */
    public boolean isArrayType()
    {
        return this.getSuperEntity().isArrayType();
    }

    /**
     * 
     * @see ClassifierFacade#isAssociationClass()
     */
    public boolean isAssociationClass()
    {
        return this.getSuperEntity().isAssociationClass();
    }

    /**
     * <p>
     * Returns true if this type represents a Blob type.
     * </p>
     * @see ClassifierFacade#isBlobType()
     */
    public boolean isBlobType()
    {
        return this.getSuperEntity().isBlobType();
    }

    /**
     * <p>
     * Indicates if this type represents a boolean type or not.
     * </p>
     * @see ClassifierFacade#isBooleanType()
     */
    public boolean isBooleanType()
    {
        return this.getSuperEntity().isBooleanType();
    }

    /**
     * <p>
     * Indicates if this type represents a char, Character, or
     * java.lang.Character type or not.
     * </p>
     * @see ClassifierFacade#isCharacterType()
     */
    public boolean isCharacterType()
    {
        return this.getSuperEntity().isCharacterType();
    }

    /**
     * <p>
     * Returns true if this type represents a Clob type.
     * </p>
     * @see ClassifierFacade#isClobType()
     */
    public boolean isClobType()
    {
        return this.getSuperEntity().isClobType();
    }

    /**
     * <p>
     * True if this classifier represents a collection type. False
     * otherwise.
     * </p>
     * @see ClassifierFacade#isCollectionType()
     */
    public boolean isCollectionType()
    {
        return this.getSuperEntity().isCollectionType();
    }

    /**
     * <p>
     * True/false depending on whether or not this classifier
     * represents a datatype. A data type is a type whose instances are
     * identified only by their value. A data type may contain
     * attributes to support the modeling of structured data types.
     * </p>
     * @see ClassifierFacade#isDataType()
     */
    public boolean isDataType()
    {
        return this.getSuperEntity().isDataType();
    }

    /**
     * <p>
     * True when this classifier is a date type.
     * </p>
     * @see ClassifierFacade#isDateType()
     */
    public boolean isDateType()
    {
        return this.getSuperEntity().isDateType();
    }

    /**
     * <p>
     * Indicates if this type represents a Double type or not.
     * </p>
     * @see ClassifierFacade#isDoubleType()
     */
    public boolean isDoubleType()
    {
        return this.getSuperEntity().isDoubleType();
    }

    /**
     * <p>
     * Indicates whether or not this classifier represents an
     * "EmbeddedValue'.
     * </p>
     * @see ClassifierFacade#isEmbeddedValue()
     */
    public boolean isEmbeddedValue()
    {
        return this.getSuperEntity().isEmbeddedValue();
    }

    /**
     * <p>
     * True if this classifier is in fact marked as an enumeration.
     * </p>
     * @see ClassifierFacade#isEnumeration()
     */
    public boolean isEnumeration()
    {
        return this.getSuperEntity().isEnumeration();
    }

    /**
     * <p>
     * Returns true if this type represents a 'file' type.
     * </p>
     * @see ClassifierFacade#isFileType()
     */
    public boolean isFileType()
    {
        return this.getSuperEntity().isFileType();
    }

    /**
     * <p>
     * Indicates if this type represents a Float type or not.
     * </p>
     * @see ClassifierFacade#isFloatType()
     */
    public boolean isFloatType()
    {
        return this.getSuperEntity().isFloatType();
    }

    /**
     * <p>
     * Indicates if this type represents an int or Integer or
     * java.lang.Integer type or not.
     * </p>
     * @see ClassifierFacade#isIntegerType()
     */
    public boolean isIntegerType()
    {
        return this.getSuperEntity().isIntegerType();
    }

    /**
     * <p>
     * True/false depending on whether or not this Classifier
     * represents an interface.
     * </p>
     * @see ClassifierFacade#isInterface()
     */
    public boolean isInterface()
    {
        return this.getSuperEntity().isInterface();
    }

    /**
     * <p>
     * True if this classifier cannot be extended and represent a leaf
     * in the inheritance tree.
     * </p>
     * @see ClassifierFacade#isLeaf()
     */
    public boolean isLeaf()
    {
        return this.getSuperEntity().isLeaf();
    }

    /**
     * <p>
     * True if this classifier represents a list type. False otherwise.
     * </p>
     * @see ClassifierFacade#isListType()
     */
    public boolean isListType()
    {
        return this.getSuperEntity().isListType();
    }

    /**
     * <p>
     * Indicates if this type represents a Long type or not.
     * </p>
     * @see ClassifierFacade#isLongType()
     */
    public boolean isLongType()
    {
        return this.getSuperEntity().isLongType();
    }

    /**
     * <p>
     * Indicates whether or not this classifier represents a Map type.
     * </p>
     * @see ClassifierFacade#isMapType()
     */
    public boolean isMapType()
    {
        return this.getSuperEntity().isMapType();
    }

    /**
     * <p>
     * Indicates whether or not this classifier represents a primitive
     * type.
     * </p>
     * @see ClassifierFacade#isPrimitive()
     */
    public boolean isPrimitive()
    {
        return this.getSuperEntity().isPrimitive();
    }

    /**
     * <p>
     * True if this classifier represents a set type. False otherwise.
     * </p>
     * @see ClassifierFacade#isSetType()
     */
    public boolean isSetType()
    {
        return this.getSuperEntity().isSetType();
    }

    /**
     * <p>
     * Indicates whether or not this classifier represents a string
     * type.
     * </p>
     * @see ClassifierFacade#isStringType()
     */
    public boolean isStringType()
    {
        return this.getSuperEntity().isStringType();
    }

    /**
     * <p>
     * Indicates whether or not this classifier represents a time type.
     * </p>
     * @see ClassifierFacade#isTimeType()
     */
    public boolean isTimeType()
    {
        return this.getSuperEntity().isTimeType();
    }

    /**
     * <p>
     * Returns true if this type is a wrapped primitive type.
     * </p>
     * @see ClassifierFacade#isWrappedPrimitive()
     */
    public boolean isWrappedPrimitive()
    {
        return this.getSuperEntity().isWrappedPrimitive();
    }

    /**
     * <p>
     * Returns a collection of all entities this entity and its
     * ancestors have a relation to.
     * </p>
     * @see Entity#getAllEntityReferences()
     */
    public Collection<DependencyFacade> getAllEntityReferences()
    {
        return this.getSuperEntity().getAllEntityReferences();
    }

    /**
     * <p>
     * Gets a comma separated list of attribute names.  If 'follow' is
     * true, will travel up the inheritance hiearchy to include
     * attributes in parent entities as well.  If 'withIdentifiers' is
     * true, will include identifiers.
     * </p>
     * @see Entity#getAttributeNameList(boolean follow, boolean withIdentifiers)
     */
    public String getAttributeNameList(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getAttributeNameList(follow, withIdentifiers);
    }

    /**
     * <p>
     * Gets a comma separated list of attribute names.  If 'follow' is
     * true, will travel up the inheritance hiearchy to include
     * attributes in parent entities as well.  If 'withIdentifiers' is
     * true, will include identifiers  and  if 'withDerived' is set to
     * true, will include derived attributes.
     * </p>
     * @see Entity#getAttributeNameList(boolean follow, boolean withIdentifiers, boolean withDerived)
     */
    public String getAttributeNameList(boolean follow, boolean withIdentifiers, boolean withDerived)
    {
        return this.getSuperEntity().getAttributeNameList(follow, withIdentifiers, withDerived);
    }

    /**
     * <p>
     * Gets a comma separated list of attribute types.  If 'follow' is
     * true, will travel up the inheritance hierarchy to include
     * attributes in parent entities as well.  If 'withIdentifiers' is
     * true, will include identifiers.
     * </p>
     * @see Entity#getAttributeTypeList(boolean follow, boolean withIdentifiers)
     */
    public String getAttributeTypeList(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getAttributeTypeList(follow, withIdentifiers);
    }

    /**
     * <p>
     * Gets all attributes of the entity, and optionally retieves the
     * super entities attributes as well as excludes the entity's
     * identifiers if 'withIdentifiers' is set to false.
     * </p>
     * @see Entity#getAttributes(boolean follow, boolean withIdentifiers)
     */
    public Collection getAttributes(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getAttributes(follow, withIdentifiers);
    }

    /**
     * <p>
     * Gets all attributes of the entity, and optionally retieves the
     * super entities attributes as well as excludes the entity's
     * identifiers if 'withIdentifiers' is set to false and exclude
     * derived attributes if 'withDerived' is set to false.
     * </p>
     * @see Entity#getAttributes(boolean follow, boolean withIdentifiers, boolean withDerived)
     */
    public Collection getAttributes(boolean follow, boolean withIdentifiers, boolean withDerived)
    {
        return this.getSuperEntity().getAttributes(follow, withIdentifiers, withDerived);
    }

    /**
     * <p>
     * All business operations of the entity, these include any
     * operations that aren't queries.
     * </p>
     * @see Entity#getBusinessOperations()
     */
    public Collection<OperationFacade> getBusinessOperations()
    {
        return this.getSuperEntity().getBusinessOperations();
    }

    /**
     * <p>
     * Gets any children association ends (i.e. entity association ends
     * that are participants in an association with this entity and
     * this entity has composite aggregation defined for those
     * associations).
     * </p>
     * @see Entity#getChildEnds()
     */
    public Collection<EntityAssociationEnd> getChildEnds()
    {
        return this.getSuperEntity().getChildEnds();
    }

    /**
     * <p>
     * The embedded values belonging to this entity.
     * </p>
     * @see Entity#getEmbeddedValues()
     */
    public Collection getEmbeddedValues()
    {
        return this.getSuperEntity().getEmbeddedValues();
    }

    /**
     * <p>
     * All entities referenced by this entity.
     * </p>
     * @see Entity#getEntityReferences()
     */
    public Collection<DependencyFacade> getEntityReferences()
    {
        return this.getSuperEntity().getEntityReferences();
    }

    /**
     * <p>
     * The full name of the type of the identifier. If composite
     * identifier add the PK sufix to the class name. If not, retorns
     * the fully qualified name of the identifier.
     * </p>
     * @see Entity#getFullyQualifiedIdentifierTypeName()
     */
    public String getFullyQualifiedIdentifierTypeName()
    {
        return this.getSuperEntity().getFullyQualifiedIdentifierTypeName();
    }

    /**
     * <p>
     * Gets all the associationEnds of this entity marked with the
     * identifiers stereotype.
     * </p>
     * @see Entity#getIdentifierAssociationEnds()
     */
    public Collection getIdentifierAssociationEnds()
    {
        return this.getSuperEntity().getIdentifierAssociationEnds();
    }

    /**
     * <p>
     * The getter name of the identifier.
     * </p>
     * @see Entity#getIdentifierGetterName()
     */
    public String getIdentifierGetterName()
    {
        return this.getSuperEntity().getIdentifierGetterName();
    }

    /**
     * <p>
     * The name of the identifier. If composite identifier add the Pk
     * sufix. If not composite returns the atribute name of the
     * identifier.
     * </p>
     * @see Entity#getIdentifierName()
     */
    public String getIdentifierName()
    {
        return this.getSuperEntity().getIdentifierName();
    }

    /**
     * <p>
     * The setter name of the identifier.
     * </p>
     * @see Entity#getIdentifierSetterName()
     */
    public String getIdentifierSetterName()
    {
        return this.getSuperEntity().getIdentifierSetterName();
    }

    /**
     * <p>
     * The name of the type of the identifier. If composite identifier
     * add the PK sufix to the class name. If not, retorns the name of
     * the identifier.
     * </p>
     * @see Entity#getIdentifierTypeName()
     */
    public String getIdentifierTypeName()
    {
        return this.getSuperEntity().getIdentifierTypeName();
    }

    /**
     * <p>
     * All the attributes of the entity which make up its identifier
     * (primary key).  Will search any super classes as well.  If no
     * identifiers exist, a default identifier will be created if the
     * allowDefaultIdentifiers property is set to true.
     * </p>
     * @see Entity#getIdentifiers()
     */
    public Collection<EntityAttribute> getIdentifiers()
    {
        return this.getSuperEntity().getIdentifiers();
    }

    /**
     * <p>
     * Gets all identifiers for an entity. If 'follow' is true, and if
     * no identifiers can be found on the entity, a search up the
     * inheritance chain will be performed, and the identifiers from
     * the first super class having them will be used.   If no
     * identifiers exist, a default identifier will be created if the
     * allowDefaultIdentifiers property is set to true.
     * </p>
     * @see Entity#getIdentifiers(boolean follow)
     */
    public Collection getIdentifiers(boolean follow)
    {
        return this.getSuperEntity().getIdentifiers(follow);
    }

    /**
     * <p>
     * The maximum length a SQL name may be.
     * </p>
     * @see Entity#getMaxSqlNameLength()
     */
    public short getMaxSqlNameLength()
    {
        return this.getSuperEntity().getMaxSqlNameLength();
    }

    /**
     * <p>
     * Gets the attributes as a list within an operation call,
     * optionally including the type names and the identifier
     * attributes.
     * </p>
     * @see Entity#getOperationCallFromAttributes(boolean withIdentifiers)
     */
    public String getOperationCallFromAttributes(boolean withIdentifiers)
    {
        return this.getSuperEntity().getOperationCallFromAttributes(withIdentifiers);
    }

    /**
     * <p>
     * Gets the attributes as a list within an operation call.  If
     * 'withTypeNames' is true, it will include the type names, if
     * 'withIdentifiers' is true it will include the identifiers.  If
     * 'follow' is true it will follow the inheritance hierarchy and
     * get the attributes of the super class as well.
     * </p>
     * @see Entity#getOperationCallFromAttributes(boolean withIdentifiers, boolean follow)
     */
    public String getOperationCallFromAttributes(boolean withIdentifiers, boolean follow)
    {
        return this.getSuperEntity().getOperationCallFromAttributes(withIdentifiers, follow);
    }

    /**
     * <p>
     * Returns the parent association end of this entity if its a child
     * entity.  The parent is the entity that is the participant the
     * association that has composite aggregation defined.  Will return
     * null if the entity has no parent.
     * </p>
     * @see Entity#getParentEnd()
     */
    public EntityAssociationEnd getParentEnd()
    {
        return this.getSuperEntity().getParentEnd();
    }

    /**
     * <p>
     * Gets all properties of this entity, this includes the attributes
     * and navigable association ends of the entity.  The 'follow' flag
     * indcates whether or not the inheritance hierarchy should be
     * followed when getting all the properties.  The 'withIdentifiers'
     * flag indicates whether or not identifiers should be included in
     * the collection of properties.
     * </p>
     * @see Entity#getProperties(boolean follow, boolean withIdentifiers)
     */
    public Collection getProperties(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getProperties(follow, withIdentifiers);
    }

    /**
     * <p>
     * Returns all the operations that can perform queries on the
     * entity.
     * </p>
     * @see Entity#getQueryOperations()
     */
    public Collection<EntityQueryOperation> getQueryOperations()
    {
        return this.getSuperEntity().getQueryOperations();
    }

    /**
     * <p>
     * Gets all query operations for an entity. If 'follow' is true,
     * and if no query operations can be found on the entity, a search
     * up the inheritance chain will be performed, and the identifiers
     * from the first super class having them will be used.   If no
     * identifiers exist, a default identifier will be created if the
     * allowDefaultIdentifiers property is set to true.
     * </p>
     * @see Entity#getQueryOperations(boolean follow)
     */
    public Collection getQueryOperations(boolean follow)
    {
        return this.getSuperEntity().getQueryOperations(follow);
    }

    /**
     * <p>
     * Gets a comma separated list of required attribute names.  If
     * 'follow' is true, will travel up the inheritance hierarchy to
     * include attributes in parent entities as well.  If
     * 'withIdentifiers' is true, will include identifiers.
     * </p>
     * @see Entity#getRequiredAttributeNameList(boolean follow, boolean withIdentifiers)
     */
    public String getRequiredAttributeNameList(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getRequiredAttributeNameList(follow, withIdentifiers);
    }

    /**
     * <p>
     * Gets a comma separated list of attribute types with are
     * required.  If 'follow' is true, will travel up the inheritance
     * hierarchy to include attributes in parent entities as well.  If
     * 'withIdentifiers' is true, will include identifiers.
     * </p>
     * @see Entity#getRequiredAttributeTypeList(boolean follow, boolean withIdentifiers)
     */
    public String getRequiredAttributeTypeList(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getRequiredAttributeTypeList(follow, withIdentifiers);
    }

    /**
     * <p>
     * Returns all attributes that are specified as 'required' in the
     * model.  If 'follow' is true, then required attributes in super
     * classes will also be returned, if false, just the ones directly
     * on the entity will be returned.  If 'withIdentifiers' is true,
     * the identifiers will be include, if false, no identifiers will
     * be included.
     * </p>
     * @see Entity#getRequiredAttributes(boolean follow, boolean withIdentifiers)
     */
    public Collection getRequiredAttributes(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getRequiredAttributes(follow, withIdentifiers);
    }

    /**
     * <p>
     * Gets all required properties for this entity.  These consist of
     * any required attributes as well as navigable associations that
     * are marked as 'required'.  If 'follow' is true, then the
     * inheritance hierchy will be followed and all required properties
     * from super classes will be included as well.
     * </p>
     * <p>
     * If 'withIdentifiers' is true, the identifiers will be include,
     * if false, no identifiers will be included.
     * </p>
     * @see Entity#getRequiredProperties(boolean follow, boolean withIdentifiers)
     */
    public Collection getRequiredProperties(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getRequiredProperties(follow, withIdentifiers);
    }

    /**
     * <p>
     * Creates a comma separated list of the required property names.
     * </p>
     * @see Entity#getRequiredPropertyNameList(boolean follow, boolean withIdentifiers)
     */
    public String getRequiredPropertyNameList(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getRequiredPropertyNameList(follow, withIdentifiers);
    }

    /**
     * <p>
     * A comma separated list of the required property types.
     * </p>
     * @see Entity#getRequiredPropertyTypeList(boolean follow, boolean withIdentifiers)
     */
    public String getRequiredPropertyTypeList(boolean follow, boolean withIdentifiers)
    {
        return this.getSuperEntity().getRequiredPropertyTypeList(follow, withIdentifiers);
    }

    /**
     * <p>
     * The name of the schema that contains the database table
     * </p>
     * @see Entity#getSchema()
     */
    public String getSchema()
    {
        return this.getSuperEntity().getSchema();
    }

    /**
     * <p>
     * The name of the database table to which this entity is
     * persisted.
     * </p>
     * @see Entity#getTableName()
     */
    public String getTableName()
    {
        return this.getSuperEntity().getTableName();
    }

    /**
     * <p>
     * Returns true/false depending on whether or not this entity
     * represetns a child in an association (this occurs when this
     * entity is on the opposite end of an assocation end defined as
     * composite).
     * </p>
     * @see Entity#isChild()
     */
    public boolean isChild()
    {
        return this.getSuperEntity().isChild();
    }

    /**
     * 
     * @see Entity#isCompositeIdentifier()
     */
    public boolean isCompositeIdentifier()
    {
        return this.getSuperEntity().isCompositeIdentifier();
    }

    /**
     * <p>
     * True if the entity has its identifiers dynamically added, false
     * otherwise.
     * </p>
     * @see Entity#isDynamicIdentifiersPresent()
     */
    public boolean isDynamicIdentifiersPresent()
    {
        return this.getSuperEntity().isDynamicIdentifiersPresent();
    }

    /**
     * <p>
     * True if the entity has any identifiers defined, false otherwise.
     * </p>
     * @see Entity#isIdentifiersPresent()
     */
    public boolean isIdentifiersPresent()
    {
        return this.getSuperEntity().isIdentifiersPresent();
    }

    /**
     * <p>
     * Indiciates if this entity is using an assigned identifier or
     * not.
     * </p>
     * @see Entity#isUsingAssignedIdentifier()
     */
    public boolean isUsingAssignedIdentifier()
    {
        return this.getSuperEntity().isUsingAssignedIdentifier();
    }

    /**
     * <p>
     * Indicates whether or not this entity is using a foreign
     * identifier as its identifiers.  That is: the foreignIdentifier
     * flag was set on an incoming association end and the entity is
     * therefore using the related foreign parent entity's identifier.
     * </p>
     * @see Entity#isUsingForeignIdentifier()
     */
    public boolean isUsingForeignIdentifier()
    {
        return this.getSuperEntity().isUsingForeignIdentifier();
    }

    /**
     * <p>
     * Finds the tagged value optional searching the entire inheritance
     * hierarchy if 'follow' is set to true.
     * </p>
     * @see GeneralizableElementFacade#findTaggedValue(String tagName, boolean follow)
     */
    public Object findTaggedValue(String tagName, boolean follow)
    {
        return this.getSuperEntity().findTaggedValue(tagName, follow);
    }

    /**
     * <p>
     * All generalizations for this generalizable element, goes up the
     * inheritance tree.
     * </p>
     * @see GeneralizableElementFacade#getAllGeneralizations()
     */
    public Collection<GeneralizableElementFacade> getAllGeneralizations()
    {
        return this.getSuperEntity().getAllGeneralizations();
    }

    /**
     * <p>
     * All specializations (travels down the inheritance hierarchy).
     * </p>
     * @see GeneralizableElementFacade#getAllSpecializations()
     */
    public Collection<GeneralizableElementFacade> getAllSpecializations()
    {
        return this.getSuperEntity().getAllSpecializations();
    }

    /**
     * <p>
     * Gets the direct generalization for this generalizable element.
     * </p>
     * @see GeneralizableElementFacade#getGeneralization()
     */
    public GeneralizableElementFacade getGeneralization()
    {
        return this.getSuperEntity().getGeneralization();
    }

    /**
     * <p>
     * Gets the actual links that this generalization element is part
     * of (it plays either the specialization or generalization).
     * </p>
     * @see GeneralizableElementFacade#getGeneralizationLinks()
     */
    public Collection<GeneralizationFacade> getGeneralizationLinks()
    {
        return this.getSuperEntity().getGeneralizationLinks();
    }

    /**
     * <p>
     * A comma separated list of the fully qualified names of all
     * generalizations.
     * </p>
     * @see GeneralizableElementFacade#getGeneralizationList()
     */
    public String getGeneralizationList()
    {
        return this.getSuperEntity().getGeneralizationList();
    }

    /**
     * <p>
     * The element found when you recursively follow the generalization
     * path up to the root. If an element has no generalization itself
     * will be considered the root.
     * </p>
     * @see GeneralizableElementFacade#getGeneralizationRoot()
     */
    public GeneralizableElementFacade getGeneralizationRoot()
    {
        return this.getSuperEntity().getGeneralizationRoot();
    }

    /**
     * 
     * @see GeneralizableElementFacade#getGeneralizations()
     */
    public Collection<GeneralizableElementFacade> getGeneralizations()
    {
        return this.getSuperEntity().getGeneralizations();
    }

    /**
     * <p>
     * Gets the direct specializations (i.e. sub elements) for this
     * generalizatble element.
     * </p>
     * @see GeneralizableElementFacade#getSpecializations()
     */
    public Collection<GeneralizableElementFacade> getSpecializations()
    {
        return this.getSuperEntity().getSpecializations();
    }

    /**
     * <p>
     * Copies all tagged values from the given ModelElementFacade to
     * this model element facade.
     * </p>
     * @see ModelElementFacade#copyTaggedValues(ModelElementFacade element)
     */
    public void copyTaggedValues(ModelElementFacade element)
    {
        this.getSuperEntity().copyTaggedValues(element);
    }

    /**
     * <p>
     * Finds the tagged value with the specified 'tagName'. In case
     * there are more values the first one found will be returned.
     * </p>
     * @see ModelElementFacade#findTaggedValue(String tagName)
     */
    public Object findTaggedValue(String tagName)
    {
        return this.getSuperEntity().findTaggedValue(tagName);
    }

    /**
     * <p>
     * Returns all the values for the tagged value with the specified
     * name. The returned collection will contains only String
     * instances, or will be empty. Never null.
     * </p>
     * @see ModelElementFacade#findTaggedValues(String tagName)
     */
    public Collection findTaggedValues(String tagName)
    {
        return this.getSuperEntity().findTaggedValues(tagName);
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element. The templates parameter will be
     * replaced by the correct one given the binding relation of the
     * parameter to this element.
     * </p>
     * @see ModelElementFacade#getBindedFullyQualifiedName(ModelElementFacade bindedElement)
     */
    public String getBindedFullyQualifiedName(ModelElementFacade bindedElement)
    {
        return this.getSuperEntity().getBindedFullyQualifiedName(bindedElement);
    }

    /**
     * <p>
     * Gets all constraints belonging to the model element.
     * </p>
     * @see ModelElementFacade#getConstraints()
     */
    public Collection<ConstraintFacade> getConstraints()
    {
        return this.getSuperEntity().getConstraints();
    }

    /**
     * <p>
     * Returns the constraints of the argument kind that have been
     * placed onto this model. Typical kinds are "inv", "pre" and
     * "post". Other kinds are possible.
     * </p>
     * @see ModelElementFacade#getConstraints(String kind)
     */
    public Collection getConstraints(String kind)
    {
        return this.getSuperEntity().getConstraints(kind);
    }

    /**
     * <p>
     * Gets the documentation for the model element, The indent
     * argument is prefixed to each line. By default this method wraps
     * lines after 64 characters.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * 64)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent)
     */
    public String getDocumentation(String indent)
    {
        return this.getSuperEntity().getDocumentation(indent);
    }

    /**
     * <p>
     * This method returns the documentation for this model element,
     * with the lines wrapped after the specified number of characters,
     * values of less than 1 will indicate no line wrapping is
     * required. By default paragraphs are returned as HTML.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * lineLength, true)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength)
     */
    public String getDocumentation(String indent, int lineLength)
    {
        return this.getSuperEntity().getDocumentation(indent, lineLength);
    }

    /**
     * 
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength, boolean htmlStyle)
     */
    public String getDocumentation(String indent, int lineLength, boolean htmlStyle)
    {
        return this.getSuperEntity().getDocumentation(indent, lineLength, htmlStyle);
    }

    /**
     * <p>
     * The fully qualified name of this model element.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName()
     */
    public String getFullyQualifiedName()
    {
        return this.getSuperEntity().getFullyQualifiedName();
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element.  If modelName is true, then the
     * original name of the model element (the name contained within
     * the model) will be the name returned, otherwise a name from a
     * language mapping will be returned.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName(boolean modelName)
     */
    public String getFullyQualifiedName(boolean modelName)
    {
        return this.getSuperEntity().getFullyQualifiedName(modelName);
    }

    /**
     * <p>
     * Returns the fully qualified name as a path, the returned value
     * always starts with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedNamePath()
     */
    public String getFullyQualifiedNamePath()
    {
        return this.getSuperEntity().getFullyQualifiedNamePath();
    }

    /**
     * <p>
     * Gets the unique identifier of the underlying model element.
     * </p>
     * @see ModelElementFacade#getId()
     */
    public String getId()
    {
        return this.getSuperEntity().getId();
    }

    /**
     * <p>
     * UML2: Retrieves the keywords for this element. Used to modify
     * implementation properties which are not represented by other
     * properties, i.e. native, transient, volatile, synchronized,
     * (added annotations) override, deprecated. Can also be used to
     * suppress compiler warnings: (added annotations) unchecked,
     * fallthrough, path, serial, finally, all. Annotations require
     * JDK5 compiler level.
     * </p>
     * @see ModelElementFacade#getKeywords()
     */
    public Collection<String> getKeywords()
    {
        return this.getSuperEntity().getKeywords();
    }

    /**
     * <p>
     * UML2: Retrieves a localized label for this named element.
     * </p>
     * @see ModelElementFacade#getLabel()
     */
    public String getLabel()
    {
        return this.getSuperEntity().getLabel();
    }

    /**
     * <p>
     * The language mappings that have been set for this model elemnt.
     * </p>
     * @see ModelElementFacade#getLanguageMappings()
     */
    public TypeMappings getLanguageMappings()
    {
        return this.getSuperEntity().getLanguageMappings();
    }

    /**
     * 
     * @see ModelElementFacade#getModel()
     */
    public ModelFacade getModel()
    {
        return this.getSuperEntity().getModel();
    }

    /**
     * <p>
     * The name of the model element.
     * </p>
     * @see ModelElementFacade#getName()
     */
    public String getName()
    {
        return this.getSuperEntity().getName();
    }

    /**
     * <p>
     * Gets the package to which this model element belongs.
     * </p>
     * @see ModelElementFacade#getPackage()
     */
    public ModelElementFacade getPackage()
    {
        return this.getSuperEntity().getPackage();
    }

    /**
     * <p>
     * The name of this model element's package.
     * </p>
     * @see ModelElementFacade#getPackageName()
     */
    public String getPackageName()
    {
        return this.getSuperEntity().getPackageName();
    }

    /**
     * <p>
     * Gets the package name (optionally providing the ability to
     * retrieve the model name and not the mapped name).
     * </p>
     * @see ModelElementFacade#getPackageName(boolean modelName)
     */
    public String getPackageName(boolean modelName)
    {
        return this.getSuperEntity().getPackageName(modelName);
    }

    /**
     * <p>
     * Returns the package as a path, the returned value always starts
     * with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getPackagePath()
     */
    public String getPackagePath()
    {
        return this.getSuperEntity().getPackagePath();
    }

    /**
     * <p>
     * UML2: Returns the value of the 'Qualified Name' attribute. A
     * name which allows the NamedElement to be identified within a
     * hierarchy of nested Namespaces. It is constructed from the names
     * of the containing namespaces starting at the root of the
     * hierarchy and ending with the name of the NamedElement itself.
     * </p>
     * @see ModelElementFacade#getQualifiedName()
     */
    public String getQualifiedName()
    {
        return this.getSuperEntity().getQualifiedName();
    }

    /**
     * <p>
     * Gets the root package for the model element.
     * </p>
     * @see ModelElementFacade#getRootPackage()
     */
    public PackageFacade getRootPackage()
    {
        return this.getSuperEntity().getRootPackage();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * source.
     * </p>
     * @see ModelElementFacade#getSourceDependencies()
     */
    public Collection<DependencyFacade> getSourceDependencies()
    {
        return this.getSuperEntity().getSourceDependencies();
    }

    /**
     * <p>
     * If this model element is the context of an activity graph, this
     * represents that activity graph.
     * </p>
     * @see ModelElementFacade#getStateMachineContext()
     */
    public StateMachineFacade getStateMachineContext()
    {
        return this.getSuperEntity().getStateMachineContext();
    }

    /**
     * <p>
     * The collection of ALL stereotype names for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypeNames()
     */
    public Collection<String> getStereotypeNames()
    {
        return this.getSuperEntity().getStereotypeNames();
    }

    /**
     * <p>
     * Gets all stereotypes for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypes()
     */
    public Collection<StereotypeFacade> getStereotypes()
    {
        return this.getSuperEntity().getStereotypes();
    }

    /**
     * 
     * @see ModelElementFacade#getTaggedValues()
     */
    public Collection<TaggedValueFacade> getTaggedValues()
    {
        return this.getSuperEntity().getTaggedValues();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * target.
     * </p>
     * @see ModelElementFacade#getTargetDependencies()
     */
    public Collection<DependencyFacade> getTargetDependencies()
    {
        return this.getSuperEntity().getTargetDependencies();
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameter(String parameterName)
     */
    public Object getTemplateParameter(String parameterName)
    {
        return this.getSuperEntity().getTemplateParameter(parameterName);
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameters()
     */
    public Collection<TemplateParameterFacade> getTemplateParameters()
    {
        return this.getSuperEntity().getTemplateParameters();
    }

    /**
     * <p>
     * The visibility (i.e. public, private, protected or package) of
     * the model element, will attempt a lookup for these values in the
     * language mappings (if any).
     * </p>
     * @see ModelElementFacade#getVisibility()
     */
    public String getVisibility()
    {
        return this.getSuperEntity().getVisibility();
    }

    /**
     * <p>
     * Returns true if the model element has the exact stereotype
     * (meaning no stereotype inheritance is taken into account when
     * searching for the stereotype), false otherwise.
     * </p>
     * @see ModelElementFacade#hasExactStereotype(String stereotypeName)
     */
    public boolean hasExactStereotype(String stereotypeName)
    {
        return this.getSuperEntity().hasExactStereotype(stereotypeName);
    }

    /**
     * <p>
     * Does the UML Element contain the named Keyword? Keywords can be
     * separated by space, comma, pipe, semicolon, or << >>
     * </p>
     * @see ModelElementFacade#hasKeyword(String keywordName)
     */
    public boolean hasKeyword(String keywordName)
    {
        return this.getSuperEntity().hasKeyword(keywordName);
    }

    /**
     * <p>
     * Returns true if the model element has the specified stereotype. 
     * If the stereotype itself does not match, then a search will be
     * made up the stereotype inheritance hierarchy, and if one of the
     * stereotype's ancestors has a matching name this method will
     * return true, false otherwise.
     * </p>
     * <p>
     * For example, if we have a certain stereotype called
     * <<exception>> and a model element has a stereotype called
     * <<applicationException>> which extends <<exception>>, when
     * calling this method with 'stereotypeName' defined as 'exception'
     * the method would return true since <<applicationException>>
     * inherits from <<exception>>.  If you want to check if the model
     * element has the exact stereotype, then use the method
     * 'hasExactStereotype' instead.
     * </p>
     * @see ModelElementFacade#hasStereotype(String stereotypeName)
     */
    public boolean hasStereotype(String stereotypeName)
    {
        return this.getSuperEntity().hasStereotype(stereotypeName);
    }

    /**
     * 
     * @see ModelElementFacade#isBindingDependenciesPresent()
     */
    public boolean isBindingDependenciesPresent()
    {
        return this.getSuperEntity().isBindingDependenciesPresent();
    }

    /**
     * <p>
     * Indicates if any constraints are present on this model element.
     * </p>
     * @see ModelElementFacade#isConstraintsPresent()
     */
    public boolean isConstraintsPresent()
    {
        return this.getSuperEntity().isConstraintsPresent();
    }

    /**
     * <p>
     * Indicates if any documentation is present on this model element.
     * </p>
     * @see ModelElementFacade#isDocumentationPresent()
     */
    public boolean isDocumentationPresent()
    {
        return this.getSuperEntity().isDocumentationPresent();
    }

    /**
     * <p>
     * True if this element name is a reserved word in Java, C#, ANSI
     * or ISO C, C++, JavaScript.
     * </p>
     * @see ModelElementFacade#isReservedWord()
     */
    public boolean isReservedWord()
    {
        return this.getSuperEntity().isReservedWord();
    }

    /**
     * 
     * @see ModelElementFacade#isTemplateParametersPresent()
     */
    public boolean isTemplateParametersPresent()
    {
        return this.getSuperEntity().isTemplateParametersPresent();
    }

    /**
     * <p>
     * Searches for the constraint with the specified 'name' on this
     * model element, and if found translates it using the specified
     * 'translation' from a translation library discovered by the
     * framework.
     * </p>
     * @see ModelElementFacade#translateConstraint(String name, String translation)
     */
    public String translateConstraint(String name, String translation)
    {
        return this.getSuperEntity().translateConstraint(name, translation);
    }

    /**
     * <p>
     * Translates all constraints belonging to this model element with
     * the given 'translation'.
     * </p>
     * @see ModelElementFacade#translateConstraints(String translation)
     */
    public String[] translateConstraints(String translation)
    {
        return this.getSuperEntity().translateConstraints(translation);
    }

    /**
     * <p>
     * Translates the constraints of the specified 'kind' belonging to
     * this model element.
     * </p>
     * @see ModelElementFacade#translateConstraints(String kind, String translation)
     */
    public String[] translateConstraints(String kind, String translation)
    {
        return this.getSuperEntity().translateConstraints(kind, translation);
    }

    /**
     * @see MetafacadeBase#initialize()
     */
    @Override
    public void initialize()
    {
        this.getSuperEntity().initialize();
    }

    /**
     * @return Object getSuperEntity().getValidationOwner()
     * @see MetafacadeBase#getValidationOwner()
     */
    @Override
    public Object getValidationOwner()
    {
        Object owner = this.getSuperEntity().getValidationOwner();
        return owner;
    }

    /**
     * @return String getSuperEntity().getValidationName()
     * @see MetafacadeBase#getValidationName()
     */
    @Override
    public String getValidationName()
    {
        String name = this.getSuperEntity().getValidationName();
        return name;
    }

    /**
     * @param validationMessages Collection<ModelValidationMessage>
     * @see MetafacadeBase#validateInvariants(Collection validationMessages)
     */
    @Override
    public void validateInvariants(Collection<ModelValidationMessage> validationMessages)
    {
        this.getSuperEntity().validateInvariants(validationMessages);
    }

    /**
     * The property that stores the name of the metafacade.
     */
    private static final String NAME_PROPERTY = "name";
    private static final String FQNAME_PROPERTY = "fullyQualifiedName";

    /**
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        final StringBuilder toString = new StringBuilder(this.getClass().getName());
        toString.append("[");
        try
        {
            toString.append(Introspector.instance().getProperty(this, FQNAME_PROPERTY));
        }
        catch (final Throwable tryAgain)
        {
            try
            {
                toString.append(Introspector.instance().getProperty(this, NAME_PROPERTY));
            }
            catch (final Throwable ignore)
            {
                // - just ignore when the metafacade doesn't have a name or fullyQualifiedName property
            }
        }
        toString.append("]");
        return toString.toString();
    }
}