// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import java.util.Collection;
import org.andromda.metafacades.uml.Service;

/**
 * <p>
 * Represents a Spring service (which can include regular java
 * objects, and/or session EJBs).
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface SpringService
    extends Service
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isSpringServiceMetaType();

    /**
     * <p>
     * The service base class name.
     * </p>
     * @return String
     */
    public String getBaseName();

    /**
     * <p>
     * The bean name of this service.
     * </p>
     * @return String
     */
    public String getBeanName();

    /**
     * <p>
     * Gets the Spring bean name, and optionally adds a target suffix,
     * if 'targetSuffix' is set to true.
     * </p>
     * @param targetSuffix boolean
     * @return String
     */
    public String getBeanName(boolean targetSuffix);

    /**
     * <p>
     * The name of the default exception to be generated for this
     * service.
     * </p>
     * @return String
     */
    public String getDefaultExceptionName();

    /**
     * <p>
     * This is a name of the destroy-method of this service, or is
     * empty if doesn't exists.
     * </p>
     * @return String
     */
    public String getDestroyMethodName();

    /**
     * <p>
     * The EJB implementation class name.
     * </p>
     * @return String
     */
    public String getEjbImplementationName();

    /**
     * <p>
     * The JNDI name to which a Spring remote Session EJB will be
     * bound.
     * </p>
     * @return String
     */
    public String getEjbJndiName();

    /**
     * <p>
     * The JNDI name to which a Spring local Session EJB will be bound.
     * </p>
     * @return String
     */
    public String getEjbLocalJndiName();

    /**
     * <p>
     * This can be either the package name the model element exists
     * within OR it can be the package with a prefix or suffix (i.e.
     * the package could have '.ejb') appended to it. This option is
     * available if the EJB is just used a wrapper around a POJO Spring
     * Service.
     * </p>
     * @return String
     */
    public String getEjbPackageName();

    /**
     * <p>
     * The EJB package name as a path (i.e. '.' are replaced with '/').
     * </p>
     * @return String
     */
    public String getEjbPackageNamePath();

    /**
     * <p>
     * The EJB transaction type (Bean or Container).
     * </p>
     * @return String
     */
    public String getEjbTransactionType();

    /**
     * <p>
     * The fully qualified service base class name.
     * </p>
     * @return String
     */
    public String getFullyQualifiedBaseName();

    /**
     * <p>
     * The fully qualified class name of the default exception.
     * </p>
     * @return String
     */
    public String getFullyQualifiedDefaultExceptionName();

    /**
     * <p>
     * The fully qualified name of the implementation class name.
     * </p>
     * @return String
     */
    public String getFullyQualifiedEjbImplementationName();

    /**
     * 
     * @return String
     */
    public String getFullyQualifiedEjbName();

    /**
     * <p>
     * The fully qualified name of the implementation class.
     * </p>
     * @return String
     */
    public String getFullyQualifiedImplementationName();

    /**
     * 
     * @return String
     */
    public String getFullyQualifiedLocalEjbName();

    /**
     * <p>
     * The fully qualified web service delegator class name.
     * </p>
     * @return String
     */
    public String getFullyQualifiedWebServiceDelegatorName();

    /**
     * <p>
     * The implementation name of the service
     * </p>
     * @return String
     */
    public String getImplementationName();

    /**
     * <p>
     * This can be either the package name the model element exists
     * within OR it can be the package with a prefix or suffix (i.e.
     * the package could have '.impl') appended to it.
     * </p>
     * @return String
     */
    public String getImplementationPackageName();

    /**
     * <p>
     * The service implementation package name as a path (i.e. '.' are
     * replaced with '/').
     * </p>
     * @return String
     */
    public String getImplementationPackagePath();

    /**
     * <p>
     * This is a name of the init-method of this service, or is empty
     * if doesn't exists.
     * </p>
     * @return String
     */
    public String getInitMethodName();

    /**
     * 
     * @return Collection<String>
     */
    public Collection<String> getInterceptors();

    /**
     * <p>
     * Returns the remote context for this service.
     * </p>
     * @return String
     */
    public String getRemoteContext();

    /**
     * <p>
     * Determines which port this service will be published on at the
     * server side.
     * </p>
     * @return String
     */
    public String getRemotePort();

    /**
     * <p>
     * Returns the name of the remote server for this service.
     * </p>
     * @return String
     */
    public String getRemoteServer();

    /**
     * <p>
     * The URL this servie will be run on at the server side.
     * </p>
     * @return String
     */
    public String getRemoteUrl();

    /**
     * <p>
     * The name of the web service delegator class.
     * </p>
     * @return String
     */
    public String getWebServiceDelegatorName();

    /**
     * <p>
     * The call to the incoming web service attachment call.
     * </p>
     * @return String
     */
    public String getWebServiceIncomingAttachmentHandlerCall();

    /**
     * <p>
     * The operations that can be exposed in a webservice.
     * </p>
     * @return Collection<SpringServiceOperation>
     */
    public Collection<SpringServiceOperation> getWebServiceOperations();

    /**
     * <p>
     * The call to the outgoing web service attachment call.
     * </p>
     * @return String
     */
    public String getWebServiceOutgoingAttachmentHandlerCall();

    /**
     * <p>
     * Indicates whether or not a default service exception should be
     * allowed.
     * </p>
     * @return boolean
     */
    public boolean isAllowDefaultServiceException();

    /**
     * <p>
     * Defines whether this service will only be listed in the config,
     * but note be generated as a Spring bean.
     * </p>
     * @return boolean
     */
    public boolean isConfigonly();

    /**
     * 
     * @return boolean
     */
    public boolean isEjbLocalView();

    /**
     * <p>
     * Indicates if the view type of this service is remote.
     * </p>
     * @return boolean
     */
    public boolean isEjbRemoteView();

    /**
     * <p>
     * Indicates whether or not the hibernate intercetor is enabled for
     * this service.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInterceptorEnabled();

    /**
     * <p>
     * Returns true if the service is considered as private. Private
     * services are not available through the ServiceLocator, are not
     * exposed via remoting and their methods are not intercepted by
     * transaction manager.
     * </p>
     * @return boolean
     */
    public boolean isPrivate();

    /**
     * <p>
     * Returns true if this service is remotable. Derived from
     * remotingType.
     * </p>
     * @return boolean
     */
    public boolean isRemotable();

    /**
     * <p>
     * Indicates if the remoting type is "burlap".
     * </p>
     * @return boolean
     */
    public boolean isRemotingTypeBurlap();

    /**
     * <p>
     * Indicates if the remoting type is "hessian".
     * </p>
     * @return boolean
     */
    public boolean isRemotingTypeHessian();

    /**
     * <p>
     * Indicates if the remoting type is "httpinvoker".
     * </p>
     * @return boolean
     */
    public boolean isRemotingTypeHttpInvoker();

    /**
     * <p>
     * Indicates whether this service can be talked to using Lingo
     * remoting.
     * </p>
     * @return boolean
     */
    public boolean isRemotingTypeLingo();

    /**
     * <p>
     * Indicates if the remoting type for this service is "none".
     * </p>
     * @return boolean
     */
    public boolean isRemotingTypeNone();

    /**
     * <p>
     * Indicates if the remoting type is RMI.
     * </p>
     * @return boolean
     */
    public boolean isRemotingTypeRmi();

    /**
     * <p>
     * Returns true if this service is meant to take part in a richt
     * client application.
     * </p>
     * @return boolean
     */
    public boolean isRichClient();

    /**
     * <p>
     * Returns true/false depending on whether or not this
     * SpringService represents a web service.
     * </p>
     * @return boolean
     */
    public boolean isWebService();
}