// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import org.andromda.metafacades.uml.ServiceOperation;

/**
 * <p>
 * Represents an operation for a SpringService.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface SpringServiceOperation
    extends ServiceOperation
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isSpringServiceOperationMetaType();

    /**
     * <p>
     * The transaction type for EJB service operations (this is used
     * when Session EJBs wrap the spring services).
     * </p>
     * @return String
     */
    public String getEjbTransactionType();

    /**
     * <p>
     * The fully qualified name of the listener that accepts incoming
     * messages for this operation.
     * </p>
     * @return String
     */
    public String getFullyQualifiedMessageListenerName();

    /**
     * <p>
     * The method call for the implementation operation.
     * </p>
     * @return String
     */
    public String getImplementationCall();

    /**
     * <p>
     * The name of the the operation used within the service
     * implementation.
     * </p>
     * @return String
     */
    public String getImplementationName();

    /**
     * <p>
     * The fully qualified name of the implementation return type.
     * </p>
     * @return String
     */
    public String getImplementationReturnTypeName();

    /**
     * <p>
     * The signature for the implementation operation.
     * </p>
     * @return String
     */
    public String getImplementationSignature();

    /**
     * <p>
     * The incoming JMS method implementation call.
     * </p>
     * @return String
     */
    public String getIncomingMessageImplementationCall();

    /**
     * <p>
     * The incoming JMS implementation method signature.
     * </p>
     * @return String
     */
    public String getIncomingMessageImplementationSignature();

    /**
     * <p>
     * The bean name of the message listener.
     * </p>
     * @return String
     */
    public String getMessageListenerBeanName();

    /**
     * <p>
     * The bean name of the message listener container.
     * </p>
     * @return String
     */
    public String getMessageListenerContainerBeanName();

    /**
     * <p>
     * The bean name for the message listener container reference.
     * </p>
     * @return String
     */
    public String getMessageListenerContainerReferenceName();

    /**
     * <p>
     * Returns the name of the listener that accepts incoming messages
     * for this operation.
     * </p>
     * @return String
     */
    public String getMessageListenerName();

    /**
     * <p>
     * The outgoing JMS method implementation call.
     * </p>
     * @return String
     */
    public String getOutgoingMessageImplementationCall();

    /**
     * <p>
     * The outgoing JMS implementation method signature.
     * </p>
     * @return String
     */
    public String getOutgoingMessageImplementationSignature();

    /**
     * <p>
     * Indicates the "session acknowledge mode" for the JMS session
     * when this operation acts as a message receiver from the
     * messaging destination (aka JMS topic/queue).
     * </p>
     * @return String
     */
    public String getSessionAcknowledgeMode();

    /**
     * <p>
     * Gets the throws clause for this service or null if the operation
     * doesn't have any exceptions.
     * </p>
     * @return String
     */
    public String getThrowsClause();

    /**
     * <p>
     * Retrieves the throws clause allowing a comma separated list of
     * exceptions to be passed in and appended to the list.
     * </p>
     * @param initialExceptions String
     * @return String
     */
    public String getThrowsClause(String initialExceptions);

    /**
     * <p>
     * Stores the Spring transaction type for an operation.
     * </p>
     * @return String
     */
    public String getTransactionType();

    /**
     * <p>
     * Returns true/false depending on whether or not this
     * SpringServiceOperation should be an destroy-method
     * </p>
     * @return boolean
     */
    public boolean isDestroyMethod();

    /**
     * <p>
     * Returns true/false depending on whether or not this
     * SpringServiceOperation should be an init-method
     * </p>
     * @return boolean
     */
    public boolean isInitMethod();

    /**
     * <p>
     * This flag tells if the MessageConverter associated to the
     * MessageListenerAdapter handling incoming message should be set
     * to null.
     * </p>
     * @return boolean
     */
    public boolean isNullMessageConverterRequired();

    /**
     * <p>
     * Tthis flag includes whether or not the "optimizeAcknowledge" is
     * true/false for a messaging destination (aka JMS topic/queue);
     * when receiving a message through an ActiveMQ connection,
     * </p>
     * @return boolean
     */
    public boolean isOptimizeAcknowledge();

    /**
     * <p>
     * Returns true/false depending on whether or not this
     * SpringServiceOperation should be exposed in a webservice.
     * </p>
     * @return boolean
     */
    public boolean isWebserviceExposed();
}