// license-header java merge-point
//
// Attention: generated code (by MetafacadeLogic.vsl) - do not modify!
//
package org.andromda.cartridges.spring.metafacades;

import java.util.Collection;
import org.andromda.core.common.Introspector;
import org.andromda.core.metafacade.MetafacadeBase;
import org.andromda.core.metafacade.MetafacadeFactory;
import org.andromda.core.metafacade.ModelValidationMessage;
import org.andromda.metafacades.uml.ClassifierFacade;
import org.andromda.metafacades.uml.ConstraintFacade;
import org.andromda.metafacades.uml.DependencyFacade;
import org.andromda.metafacades.uml.Destination;
import org.andromda.metafacades.uml.ModelElementFacade;
import org.andromda.metafacades.uml.ModelFacade;
import org.andromda.metafacades.uml.OperationFacade;
import org.andromda.metafacades.uml.PackageFacade;
import org.andromda.metafacades.uml.ParameterFacade;
import org.andromda.metafacades.uml.Role;
import org.andromda.metafacades.uml.Service;
import org.andromda.metafacades.uml.ServiceOperation;
import org.andromda.metafacades.uml.StateMachineFacade;
import org.andromda.metafacades.uml.StereotypeFacade;
import org.andromda.metafacades.uml.TaggedValueFacade;
import org.andromda.metafacades.uml.TemplateParameterFacade;
import org.andromda.metafacades.uml.TypeMappings;

/**
 * <p>
 * Represents an operation for a SpringService.
 * </p>
 * MetafacadeLogic for SpringServiceOperation
 *
 * @see SpringServiceOperation
 */
public abstract class SpringServiceOperationLogic
    extends MetafacadeBase
    implements SpringServiceOperation
{
    /**
     * The underlying UML object
     * @see Object
     */
    protected Object metaObject;

    /** Create Metafacade implementation instance using the MetafacadeFactory from the context
     * @param metaObjectIn
     * @param context
     */
    protected SpringServiceOperationLogic(Object metaObjectIn, String context)
    {
        super(metaObjectIn, getContext(context));
        this.superServiceOperation =
           (ServiceOperation)
            MetafacadeFactory.getInstance().createFacadeImpl(
                    "org.andromda.metafacades.uml.ServiceOperation",
                    metaObjectIn,
                    getContext(context));
        this.metaObject = metaObjectIn;
    }

    /**
     * Gets the context for this metafacade logic instance.
     * @param context String. Set to SpringServiceOperation if null
     * @return context String
     */
    private static String getContext(String context)
    {
        if (context == null)
        {
            context = "org.andromda.cartridges.spring.metafacades.SpringServiceOperation";
        }
        return context;
    }

    private ServiceOperation superServiceOperation;
    private boolean superServiceOperationInitialized = false;

    /**
     * Gets the ServiceOperation parent instance.
     * @return this.superServiceOperation ServiceOperation
     */
    private ServiceOperation getSuperServiceOperation()
    {
        if (!this.superServiceOperationInitialized)
        {
            ((MetafacadeBase)this.superServiceOperation).setMetafacadeContext(this.getMetafacadeContext());
            this.superServiceOperationInitialized = true;
        }
        return this.superServiceOperation;
    }

    /** Reset context only for non-root metafacades
     * @param context
     * @see org.andromda.core.metafacade.MetafacadeBase#resetMetafacadeContext(String context)
     */
    @Override
    public void resetMetafacadeContext(String context)
    {
        if (!this.contextRoot) // reset context only for non-root metafacades
        {
            context = getContext(context);  // to have same value as in original constructor call
            setMetafacadeContext (context);
            if (this.superServiceOperationInitialized)
            {
                ((MetafacadeBase)this.superServiceOperation).resetMetafacadeContext(context);
            }
        }
    }

    /**
     * @return boolean true always
     * @see SpringServiceOperation
     */
    public boolean isSpringServiceOperationMetaType()
    {
        return true;
    }

    // --------------- attributes ---------------------

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#isWebserviceExposed()
    * @return boolean
    */
    protected abstract boolean handleIsWebserviceExposed();

    private boolean __webserviceExposed1a;
    private boolean __webserviceExposed1aSet = false;

    /**
     * <p>
     * Returns true/false depending on whether or not this
     * SpringServiceOperation should be exposed in a webservice.
     * </p>
     * @return (boolean)handleIsWebserviceExposed()
     */
    public final boolean isWebserviceExposed()
    {
        boolean webserviceExposed1a = this.__webserviceExposed1a;
        if (!this.__webserviceExposed1aSet)
        {
            // webserviceExposed has no pre constraints
            webserviceExposed1a = handleIsWebserviceExposed();
            // webserviceExposed has no post constraints
            this.__webserviceExposed1a = webserviceExposed1a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__webserviceExposed1aSet = true;
            }
        }
        return webserviceExposed1a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getImplementationName()
    * @return String
    */
    protected abstract String handleGetImplementationName();

    private String __implementationName2a;
    private boolean __implementationName2aSet = false;

    /**
     * <p>
     * The name of the the operation used within the service
     * implementation.
     * </p>
     * @return (String)handleGetImplementationName()
     */
    public final String getImplementationName()
    {
        String implementationName2a = this.__implementationName2a;
        if (!this.__implementationName2aSet)
        {
            // implementationName has no pre constraints
            implementationName2a = handleGetImplementationName();
            // implementationName has no post constraints
            this.__implementationName2a = implementationName2a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__implementationName2aSet = true;
            }
        }
        return implementationName2a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getImplementationSignature()
    * @return String
    */
    protected abstract String handleGetImplementationSignature();

    private String __implementationSignature3a;
    private boolean __implementationSignature3aSet = false;

    /**
     * <p>
     * The signature for the implementation operation.
     * </p>
     * @return (String)handleGetImplementationSignature()
     */
    public final String getImplementationSignature()
    {
        String implementationSignature3a = this.__implementationSignature3a;
        if (!this.__implementationSignature3aSet)
        {
            // implementationSignature has no pre constraints
            implementationSignature3a = handleGetImplementationSignature();
            // implementationSignature has no post constraints
            this.__implementationSignature3a = implementationSignature3a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__implementationSignature3aSet = true;
            }
        }
        return implementationSignature3a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getImplementationCall()
    * @return String
    */
    protected abstract String handleGetImplementationCall();

    private String __implementationCall4a;
    private boolean __implementationCall4aSet = false;

    /**
     * <p>
     * The method call for the implementation operation.
     * </p>
     * @return (String)handleGetImplementationCall()
     */
    public final String getImplementationCall()
    {
        String implementationCall4a = this.__implementationCall4a;
        if (!this.__implementationCall4aSet)
        {
            // implementationCall has no pre constraints
            implementationCall4a = handleGetImplementationCall();
            // implementationCall has no post constraints
            this.__implementationCall4a = implementationCall4a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__implementationCall4aSet = true;
            }
        }
        return implementationCall4a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getEjbTransactionType()
    * @return String
    */
    protected abstract String handleGetEjbTransactionType();

    private String __ejbTransactionType5a;
    private boolean __ejbTransactionType5aSet = false;

    /**
     * <p>
     * The transaction type for EJB service operations (this is used
     * when Session EJBs wrap the spring services).
     * </p>
     * @return (String)handleGetEjbTransactionType()
     */
    public final String getEjbTransactionType()
    {
        String ejbTransactionType5a = this.__ejbTransactionType5a;
        if (!this.__ejbTransactionType5aSet)
        {
            // ejbTransactionType has no pre constraints
            ejbTransactionType5a = handleGetEjbTransactionType();
            // ejbTransactionType has no post constraints
            this.__ejbTransactionType5a = ejbTransactionType5a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__ejbTransactionType5aSet = true;
            }
        }
        return ejbTransactionType5a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getTransactionType()
    * @return String
    */
    protected abstract String handleGetTransactionType();

    private String __transactionType6a;
    private boolean __transactionType6aSet = false;

    /**
     * <p>
     * Stores the Spring transaction type for an operation.
     * </p>
     * @return (String)handleGetTransactionType()
     */
    public final String getTransactionType()
    {
        String transactionType6a = this.__transactionType6a;
        if (!this.__transactionType6aSet)
        {
            // transactionType has no pre constraints
            transactionType6a = handleGetTransactionType();
            // transactionType has no post constraints
            this.__transactionType6a = transactionType6a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__transactionType6aSet = true;
            }
        }
        return transactionType6a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getThrowsClause()
    * @return String
    */
    protected abstract String handleGetThrowsClause();

    private String __throwsClause7a;
    private boolean __throwsClause7aSet = false;

    /**
     * <p>
     * Gets the throws clause for this service or null if the operation
     * doesn't have any exceptions.
     * </p>
     * @return (String)handleGetThrowsClause()
     */
    public final String getThrowsClause()
    {
        String throwsClause7a = this.__throwsClause7a;
        if (!this.__throwsClause7aSet)
        {
            // throwsClause has no pre constraints
            throwsClause7a = handleGetThrowsClause();
            // throwsClause has no post constraints
            this.__throwsClause7a = throwsClause7a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__throwsClause7aSet = true;
            }
        }
        return throwsClause7a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getOutgoingMessageImplementationCall()
    * @return String
    */
    protected abstract String handleGetOutgoingMessageImplementationCall();

    private String __outgoingMessageImplementationCall8a;
    private boolean __outgoingMessageImplementationCall8aSet = false;

    /**
     * <p>
     * The outgoing JMS method implementation call.
     * </p>
     * @return (String)handleGetOutgoingMessageImplementationCall()
     */
    public final String getOutgoingMessageImplementationCall()
    {
        String outgoingMessageImplementationCall8a = this.__outgoingMessageImplementationCall8a;
        if (!this.__outgoingMessageImplementationCall8aSet)
        {
            // outgoingMessageImplementationCall has no pre constraints
            outgoingMessageImplementationCall8a = handleGetOutgoingMessageImplementationCall();
            // outgoingMessageImplementationCall has no post constraints
            this.__outgoingMessageImplementationCall8a = outgoingMessageImplementationCall8a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__outgoingMessageImplementationCall8aSet = true;
            }
        }
        return outgoingMessageImplementationCall8a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getOutgoingMessageImplementationSignature()
    * @return String
    */
    protected abstract String handleGetOutgoingMessageImplementationSignature();

    private String __outgoingMessageImplementationSignature9a;
    private boolean __outgoingMessageImplementationSignature9aSet = false;

    /**
     * <p>
     * The outgoing JMS implementation method signature.
     * </p>
     * @return (String)handleGetOutgoingMessageImplementationSignature()
     */
    public final String getOutgoingMessageImplementationSignature()
    {
        String outgoingMessageImplementationSignature9a = this.__outgoingMessageImplementationSignature9a;
        if (!this.__outgoingMessageImplementationSignature9aSet)
        {
            // outgoingMessageImplementationSignature has no pre constraints
            outgoingMessageImplementationSignature9a = handleGetOutgoingMessageImplementationSignature();
            // outgoingMessageImplementationSignature has no post constraints
            this.__outgoingMessageImplementationSignature9a = outgoingMessageImplementationSignature9a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__outgoingMessageImplementationSignature9aSet = true;
            }
        }
        return outgoingMessageImplementationSignature9a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getIncomingMessageImplementationSignature()
    * @return String
    */
    protected abstract String handleGetIncomingMessageImplementationSignature();

    private String __incomingMessageImplementationSignature10a;
    private boolean __incomingMessageImplementationSignature10aSet = false;

    /**
     * <p>
     * The incoming JMS implementation method signature.
     * </p>
     * @return (String)handleGetIncomingMessageImplementationSignature()
     */
    public final String getIncomingMessageImplementationSignature()
    {
        String incomingMessageImplementationSignature10a = this.__incomingMessageImplementationSignature10a;
        if (!this.__incomingMessageImplementationSignature10aSet)
        {
            // incomingMessageImplementationSignature has no pre constraints
            incomingMessageImplementationSignature10a = handleGetIncomingMessageImplementationSignature();
            // incomingMessageImplementationSignature has no post constraints
            this.__incomingMessageImplementationSignature10a = incomingMessageImplementationSignature10a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__incomingMessageImplementationSignature10aSet = true;
            }
        }
        return incomingMessageImplementationSignature10a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getIncomingMessageImplementationCall()
    * @return String
    */
    protected abstract String handleGetIncomingMessageImplementationCall();

    private String __incomingMessageImplementationCall11a;
    private boolean __incomingMessageImplementationCall11aSet = false;

    /**
     * <p>
     * The incoming JMS method implementation call.
     * </p>
     * @return (String)handleGetIncomingMessageImplementationCall()
     */
    public final String getIncomingMessageImplementationCall()
    {
        String incomingMessageImplementationCall11a = this.__incomingMessageImplementationCall11a;
        if (!this.__incomingMessageImplementationCall11aSet)
        {
            // incomingMessageImplementationCall has no pre constraints
            incomingMessageImplementationCall11a = handleGetIncomingMessageImplementationCall();
            // incomingMessageImplementationCall has no post constraints
            this.__incomingMessageImplementationCall11a = incomingMessageImplementationCall11a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__incomingMessageImplementationCall11aSet = true;
            }
        }
        return incomingMessageImplementationCall11a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getImplementationReturnTypeName()
    * @return String
    */
    protected abstract String handleGetImplementationReturnTypeName();

    private String __implementationReturnTypeName12a;
    private boolean __implementationReturnTypeName12aSet = false;

    /**
     * <p>
     * The fully qualified name of the implementation return type.
     * </p>
     * @return (String)handleGetImplementationReturnTypeName()
     */
    public final String getImplementationReturnTypeName()
    {
        String implementationReturnTypeName12a = this.__implementationReturnTypeName12a;
        if (!this.__implementationReturnTypeName12aSet)
        {
            // implementationReturnTypeName has no pre constraints
            implementationReturnTypeName12a = handleGetImplementationReturnTypeName();
            // implementationReturnTypeName has no post constraints
            this.__implementationReturnTypeName12a = implementationReturnTypeName12a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__implementationReturnTypeName12aSet = true;
            }
        }
        return implementationReturnTypeName12a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getMessageListenerName()
    * @return String
    */
    protected abstract String handleGetMessageListenerName();

    private String __messageListenerName13a;
    private boolean __messageListenerName13aSet = false;

    /**
     * <p>
     * Returns the name of the listener that accepts incoming messages
     * for this operation.
     * </p>
     * @return (String)handleGetMessageListenerName()
     */
    public final String getMessageListenerName()
    {
        String messageListenerName13a = this.__messageListenerName13a;
        if (!this.__messageListenerName13aSet)
        {
            // messageListenerName has no pre constraints
            messageListenerName13a = handleGetMessageListenerName();
            // messageListenerName has no post constraints
            this.__messageListenerName13a = messageListenerName13a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__messageListenerName13aSet = true;
            }
        }
        return messageListenerName13a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getFullyQualifiedMessageListenerName()
    * @return String
    */
    protected abstract String handleGetFullyQualifiedMessageListenerName();

    private String __fullyQualifiedMessageListenerName14a;
    private boolean __fullyQualifiedMessageListenerName14aSet = false;

    /**
     * <p>
     * The fully qualified name of the listener that accepts incoming
     * messages for this operation.
     * </p>
     * @return (String)handleGetFullyQualifiedMessageListenerName()
     */
    public final String getFullyQualifiedMessageListenerName()
    {
        String fullyQualifiedMessageListenerName14a = this.__fullyQualifiedMessageListenerName14a;
        if (!this.__fullyQualifiedMessageListenerName14aSet)
        {
            // fullyQualifiedMessageListenerName has no pre constraints
            fullyQualifiedMessageListenerName14a = handleGetFullyQualifiedMessageListenerName();
            // fullyQualifiedMessageListenerName has no post constraints
            this.__fullyQualifiedMessageListenerName14a = fullyQualifiedMessageListenerName14a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__fullyQualifiedMessageListenerName14aSet = true;
            }
        }
        return fullyQualifiedMessageListenerName14a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getMessageListenerBeanName()
    * @return String
    */
    protected abstract String handleGetMessageListenerBeanName();

    private String __messageListenerBeanName15a;
    private boolean __messageListenerBeanName15aSet = false;

    /**
     * <p>
     * The bean name of the message listener.
     * </p>
     * @return (String)handleGetMessageListenerBeanName()
     */
    public final String getMessageListenerBeanName()
    {
        String messageListenerBeanName15a = this.__messageListenerBeanName15a;
        if (!this.__messageListenerBeanName15aSet)
        {
            // messageListenerBeanName has no pre constraints
            messageListenerBeanName15a = handleGetMessageListenerBeanName();
            // messageListenerBeanName has no post constraints
            this.__messageListenerBeanName15a = messageListenerBeanName15a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__messageListenerBeanName15aSet = true;
            }
        }
        return messageListenerBeanName15a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getMessageListenerContainerReferenceName()
    * @return String
    */
    protected abstract String handleGetMessageListenerContainerReferenceName();

    private String __messageListenerContainerReferenceName16a;
    private boolean __messageListenerContainerReferenceName16aSet = false;

    /**
     * <p>
     * The bean name for the message listener container reference.
     * </p>
     * @return (String)handleGetMessageListenerContainerReferenceName()
     */
    public final String getMessageListenerContainerReferenceName()
    {
        String messageListenerContainerReferenceName16a = this.__messageListenerContainerReferenceName16a;
        if (!this.__messageListenerContainerReferenceName16aSet)
        {
            // messageListenerContainerReferenceName has no pre constraints
            messageListenerContainerReferenceName16a = handleGetMessageListenerContainerReferenceName();
            // messageListenerContainerReferenceName has no post constraints
            this.__messageListenerContainerReferenceName16a = messageListenerContainerReferenceName16a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__messageListenerContainerReferenceName16aSet = true;
            }
        }
        return messageListenerContainerReferenceName16a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getMessageListenerContainerBeanName()
    * @return String
    */
    protected abstract String handleGetMessageListenerContainerBeanName();

    private String __messageListenerContainerBeanName17a;
    private boolean __messageListenerContainerBeanName17aSet = false;

    /**
     * <p>
     * The bean name of the message listener container.
     * </p>
     * @return (String)handleGetMessageListenerContainerBeanName()
     */
    public final String getMessageListenerContainerBeanName()
    {
        String messageListenerContainerBeanName17a = this.__messageListenerContainerBeanName17a;
        if (!this.__messageListenerContainerBeanName17aSet)
        {
            // messageListenerContainerBeanName has no pre constraints
            messageListenerContainerBeanName17a = handleGetMessageListenerContainerBeanName();
            // messageListenerContainerBeanName has no post constraints
            this.__messageListenerContainerBeanName17a = messageListenerContainerBeanName17a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__messageListenerContainerBeanName17aSet = true;
            }
        }
        return messageListenerContainerBeanName17a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#isOptimizeAcknowledge()
    * @return boolean
    */
    protected abstract boolean handleIsOptimizeAcknowledge();

    private boolean __optimizeAcknowledge18a;
    private boolean __optimizeAcknowledge18aSet = false;

    /**
     * <p>
     * Tthis flag includes whether or not the "optimizeAcknowledge" is
     * true/false for a messaging destination (aka JMS topic/queue);
     * when receiving a message through an ActiveMQ connection,
     * </p>
     * @return (boolean)handleIsOptimizeAcknowledge()
     */
    public final boolean isOptimizeAcknowledge()
    {
        boolean optimizeAcknowledge18a = this.__optimizeAcknowledge18a;
        if (!this.__optimizeAcknowledge18aSet)
        {
            // optimizeAcknowledge has no pre constraints
            optimizeAcknowledge18a = handleIsOptimizeAcknowledge();
            // optimizeAcknowledge has no post constraints
            this.__optimizeAcknowledge18a = optimizeAcknowledge18a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__optimizeAcknowledge18aSet = true;
            }
        }
        return optimizeAcknowledge18a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#getSessionAcknowledgeMode()
    * @return String
    */
    protected abstract String handleGetSessionAcknowledgeMode();

    private String __sessionAcknowledgeMode19a;
    private boolean __sessionAcknowledgeMode19aSet = false;

    /**
     * <p>
     * Indicates the "session acknowledge mode" for the JMS session
     * when this operation acts as a message receiver from the
     * messaging destination (aka JMS topic/queue).
     * </p>
     * @return (String)handleGetSessionAcknowledgeMode()
     */
    public final String getSessionAcknowledgeMode()
    {
        String sessionAcknowledgeMode19a = this.__sessionAcknowledgeMode19a;
        if (!this.__sessionAcknowledgeMode19aSet)
        {
            // sessionAcknowledgeMode has no pre constraints
            sessionAcknowledgeMode19a = handleGetSessionAcknowledgeMode();
            // sessionAcknowledgeMode has no post constraints
            this.__sessionAcknowledgeMode19a = sessionAcknowledgeMode19a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__sessionAcknowledgeMode19aSet = true;
            }
        }
        return sessionAcknowledgeMode19a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#isNullMessageConverterRequired()
    * @return boolean
    */
    protected abstract boolean handleIsNullMessageConverterRequired();

    private boolean __nullMessageConverterRequired20a;
    private boolean __nullMessageConverterRequired20aSet = false;

    /**
     * <p>
     * This flag tells if the MessageConverter associated to the
     * MessageListenerAdapter handling incoming message should be set
     * to null.
     * </p>
     * @return (boolean)handleIsNullMessageConverterRequired()
     */
    public final boolean isNullMessageConverterRequired()
    {
        boolean nullMessageConverterRequired20a = this.__nullMessageConverterRequired20a;
        if (!this.__nullMessageConverterRequired20aSet)
        {
            // nullMessageConverterRequired has no pre constraints
            nullMessageConverterRequired20a = handleIsNullMessageConverterRequired();
            // nullMessageConverterRequired has no post constraints
            this.__nullMessageConverterRequired20a = nullMessageConverterRequired20a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__nullMessageConverterRequired20aSet = true;
            }
        }
        return nullMessageConverterRequired20a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#isInitMethod()
    * @return boolean
    */
    protected abstract boolean handleIsInitMethod();

    private boolean __initMethod21a;
    private boolean __initMethod21aSet = false;

    /**
     * <p>
     * Returns true/false depending on whether or not this
     * SpringServiceOperation should be an init-method
     * </p>
     * @return (boolean)handleIsInitMethod()
     */
    public final boolean isInitMethod()
    {
        boolean initMethod21a = this.__initMethod21a;
        if (!this.__initMethod21aSet)
        {
            // initMethod has no pre constraints
            initMethod21a = handleIsInitMethod();
            // initMethod has no post constraints
            this.__initMethod21a = initMethod21a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__initMethod21aSet = true;
            }
        }
        return initMethod21a;
    }

   /**
    * @see org.andromda.cartridges.spring.metafacades.SpringServiceOperation#isDestroyMethod()
    * @return boolean
    */
    protected abstract boolean handleIsDestroyMethod();

    private boolean __destroyMethod22a;
    private boolean __destroyMethod22aSet = false;

    /**
     * <p>
     * Returns true/false depending on whether or not this
     * SpringServiceOperation should be an destroy-method
     * </p>
     * @return (boolean)handleIsDestroyMethod()
     */
    public final boolean isDestroyMethod()
    {
        boolean destroyMethod22a = this.__destroyMethod22a;
        if (!this.__destroyMethod22aSet)
        {
            // destroyMethod has no pre constraints
            destroyMethod22a = handleIsDestroyMethod();
            // destroyMethod has no post constraints
            this.__destroyMethod22a = destroyMethod22a;
            if (isMetafacadePropertyCachingEnabled())
            {
                this.__destroyMethod22aSet = true;
            }
        }
        return destroyMethod22a;
    }

    // ---------------- business methods ----------------------

    /**
     * Method to be implemented in descendants
     * <p>
     * Retrieves the throws clause allowing a comma separated list of
     * exceptions to be passed in and appended to the list.
     * </p>
     * @param initialExceptions
     * @return String
     */
    protected abstract String handleGetThrowsClause(String initialExceptions);

    /**
     * <p>
     * Retrieves the throws clause allowing a comma separated list of
     * exceptions to be passed in and appended to the list.
     * </p>
     * @param initialExceptions String
     * <p>
     * A comma separated list of initial exceptions to add to the list.
     * </p>
     * @return handleGetThrowsClause(initialExceptions)
     */
    public String getThrowsClause(String initialExceptions)
    {
        // getThrowsClause has no pre constraints
        String returnValue = handleGetThrowsClause(initialExceptions);
        // getThrowsClause has no post constraints
        return returnValue;
    }

    // ------------- associations ------------------

    /**
     * @return true
     * @see ServiceOperation
     */
    public boolean isServiceOperationMetaType()
    {
        return true;
    }

    /**
     * @return true
     * @see OperationFacade
     */
    public boolean isOperationFacadeMetaType()
    {
        return true;
    }

    /**
     * @return true
     * @see ModelElementFacade
     */
    public boolean isModelElementFacadeMetaType()
    {
        return true;
    }

    // ----------- delegates to ServiceOperation ------------
    /**
     * <p>
     * Copies all tagged values from the given ModelElementFacade to
     * this model element facade.
     * </p>
     * @see ModelElementFacade#copyTaggedValues(ModelElementFacade element)
     */
    public void copyTaggedValues(ModelElementFacade element)
    {
        this.getSuperServiceOperation().copyTaggedValues(element);
    }

    /**
     * <p>
     * Finds the tagged value with the specified 'tagName'. In case
     * there are more values the first one found will be returned.
     * </p>
     * @see ModelElementFacade#findTaggedValue(String tagName)
     */
    public Object findTaggedValue(String tagName)
    {
        return this.getSuperServiceOperation().findTaggedValue(tagName);
    }

    /**
     * <p>
     * Returns all the values for the tagged value with the specified
     * name. The returned collection will contains only String
     * instances, or will be empty. Never null.
     * </p>
     * @see ModelElementFacade#findTaggedValues(String tagName)
     */
    public Collection findTaggedValues(String tagName)
    {
        return this.getSuperServiceOperation().findTaggedValues(tagName);
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element. The templates parameter will be
     * replaced by the correct one given the binding relation of the
     * parameter to this element.
     * </p>
     * @see ModelElementFacade#getBindedFullyQualifiedName(ModelElementFacade bindedElement)
     */
    public String getBindedFullyQualifiedName(ModelElementFacade bindedElement)
    {
        return this.getSuperServiceOperation().getBindedFullyQualifiedName(bindedElement);
    }

    /**
     * <p>
     * Gets all constraints belonging to the model element.
     * </p>
     * @see ModelElementFacade#getConstraints()
     */
    public Collection<ConstraintFacade> getConstraints()
    {
        return this.getSuperServiceOperation().getConstraints();
    }

    /**
     * <p>
     * Returns the constraints of the argument kind that have been
     * placed onto this model. Typical kinds are "inv", "pre" and
     * "post". Other kinds are possible.
     * </p>
     * @see ModelElementFacade#getConstraints(String kind)
     */
    public Collection getConstraints(String kind)
    {
        return this.getSuperServiceOperation().getConstraints(kind);
    }

    /**
     * <p>
     * Gets the documentation for the model element, The indent
     * argument is prefixed to each line. By default this method wraps
     * lines after 64 characters.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * 64)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent)
     */
    public String getDocumentation(String indent)
    {
        return this.getSuperServiceOperation().getDocumentation(indent);
    }

    /**
     * <p>
     * This method returns the documentation for this model element,
     * with the lines wrapped after the specified number of characters,
     * values of less than 1 will indicate no line wrapping is
     * required. By default paragraphs are returned as HTML.
     * </p>
     * <p>
     * This method is equivalent to <code>getDocumentation(indent,
     * lineLength, true)</code>.
     * </p>
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength)
     */
    public String getDocumentation(String indent, int lineLength)
    {
        return this.getSuperServiceOperation().getDocumentation(indent, lineLength);
    }

    /**
     * 
     * @see ModelElementFacade#getDocumentation(String indent, int lineLength, boolean htmlStyle)
     */
    public String getDocumentation(String indent, int lineLength, boolean htmlStyle)
    {
        return this.getSuperServiceOperation().getDocumentation(indent, lineLength, htmlStyle);
    }

    /**
     * <p>
     * The fully qualified name of this model element.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName()
     */
    public String getFullyQualifiedName()
    {
        return this.getSuperServiceOperation().getFullyQualifiedName();
    }

    /**
     * <p>
     * Returns the fully qualified name of the model element. The fully
     * qualified name includes complete package qualified name of the
     * underlying model element.  If modelName is true, then the
     * original name of the model element (the name contained within
     * the model) will be the name returned, otherwise a name from a
     * language mapping will be returned.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedName(boolean modelName)
     */
    public String getFullyQualifiedName(boolean modelName)
    {
        return this.getSuperServiceOperation().getFullyQualifiedName(modelName);
    }

    /**
     * <p>
     * Returns the fully qualified name as a path, the returned value
     * always starts with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getFullyQualifiedNamePath()
     */
    public String getFullyQualifiedNamePath()
    {
        return this.getSuperServiceOperation().getFullyQualifiedNamePath();
    }

    /**
     * <p>
     * Gets the unique identifier of the underlying model element.
     * </p>
     * @see ModelElementFacade#getId()
     */
    public String getId()
    {
        return this.getSuperServiceOperation().getId();
    }

    /**
     * <p>
     * UML2: Retrieves the keywords for this element. Used to modify
     * implementation properties which are not represented by other
     * properties, i.e. native, transient, volatile, synchronized,
     * (added annotations) override, deprecated. Can also be used to
     * suppress compiler warnings: (added annotations) unchecked,
     * fallthrough, path, serial, finally, all. Annotations require
     * JDK5 compiler level.
     * </p>
     * @see ModelElementFacade#getKeywords()
     */
    public Collection<String> getKeywords()
    {
        return this.getSuperServiceOperation().getKeywords();
    }

    /**
     * <p>
     * UML2: Retrieves a localized label for this named element.
     * </p>
     * @see ModelElementFacade#getLabel()
     */
    public String getLabel()
    {
        return this.getSuperServiceOperation().getLabel();
    }

    /**
     * <p>
     * The language mappings that have been set for this model elemnt.
     * </p>
     * @see ModelElementFacade#getLanguageMappings()
     */
    public TypeMappings getLanguageMappings()
    {
        return this.getSuperServiceOperation().getLanguageMappings();
    }

    /**
     * 
     * @see ModelElementFacade#getModel()
     */
    public ModelFacade getModel()
    {
        return this.getSuperServiceOperation().getModel();
    }

    /**
     * <p>
     * The name of the model element.
     * </p>
     * @see ModelElementFacade#getName()
     */
    public String getName()
    {
        return this.getSuperServiceOperation().getName();
    }

    /**
     * <p>
     * Gets the package to which this model element belongs.
     * </p>
     * @see ModelElementFacade#getPackage()
     */
    public ModelElementFacade getPackage()
    {
        return this.getSuperServiceOperation().getPackage();
    }

    /**
     * <p>
     * The name of this model element's package.
     * </p>
     * @see ModelElementFacade#getPackageName()
     */
    public String getPackageName()
    {
        return this.getSuperServiceOperation().getPackageName();
    }

    /**
     * <p>
     * Gets the package name (optionally providing the ability to
     * retrieve the model name and not the mapped name).
     * </p>
     * @see ModelElementFacade#getPackageName(boolean modelName)
     */
    public String getPackageName(boolean modelName)
    {
        return this.getSuperServiceOperation().getPackageName(modelName);
    }

    /**
     * <p>
     * Returns the package as a path, the returned value always starts
     * with out a slash '/'.
     * </p>
     * @see ModelElementFacade#getPackagePath()
     */
    public String getPackagePath()
    {
        return this.getSuperServiceOperation().getPackagePath();
    }

    /**
     * <p>
     * UML2: Returns the value of the 'Qualified Name' attribute. A
     * name which allows the NamedElement to be identified within a
     * hierarchy of nested Namespaces. It is constructed from the names
     * of the containing namespaces starting at the root of the
     * hierarchy and ending with the name of the NamedElement itself.
     * </p>
     * @see ModelElementFacade#getQualifiedName()
     */
    public String getQualifiedName()
    {
        return this.getSuperServiceOperation().getQualifiedName();
    }

    /**
     * <p>
     * Gets the root package for the model element.
     * </p>
     * @see ModelElementFacade#getRootPackage()
     */
    public PackageFacade getRootPackage()
    {
        return this.getSuperServiceOperation().getRootPackage();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * source.
     * </p>
     * @see ModelElementFacade#getSourceDependencies()
     */
    public Collection<DependencyFacade> getSourceDependencies()
    {
        return this.getSuperServiceOperation().getSourceDependencies();
    }

    /**
     * <p>
     * If this model element is the context of an activity graph, this
     * represents that activity graph.
     * </p>
     * @see ModelElementFacade#getStateMachineContext()
     */
    public StateMachineFacade getStateMachineContext()
    {
        return this.getSuperServiceOperation().getStateMachineContext();
    }

    /**
     * <p>
     * The collection of ALL stereotype names for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypeNames()
     */
    public Collection<String> getStereotypeNames()
    {
        return this.getSuperServiceOperation().getStereotypeNames();
    }

    /**
     * <p>
     * Gets all stereotypes for this model element.
     * </p>
     * @see ModelElementFacade#getStereotypes()
     */
    public Collection<StereotypeFacade> getStereotypes()
    {
        return this.getSuperServiceOperation().getStereotypes();
    }

    /**
     * 
     * @see ModelElementFacade#getTaggedValues()
     */
    public Collection<TaggedValueFacade> getTaggedValues()
    {
        return this.getSuperServiceOperation().getTaggedValues();
    }

    /**
     * <p>
     * Gets the dependencies for which this model element is the
     * target.
     * </p>
     * @see ModelElementFacade#getTargetDependencies()
     */
    public Collection<DependencyFacade> getTargetDependencies()
    {
        return this.getSuperServiceOperation().getTargetDependencies();
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameter(String parameterName)
     */
    public Object getTemplateParameter(String parameterName)
    {
        return this.getSuperServiceOperation().getTemplateParameter(parameterName);
    }

    /**
     * 
     * @see ModelElementFacade#getTemplateParameters()
     */
    public Collection<TemplateParameterFacade> getTemplateParameters()
    {
        return this.getSuperServiceOperation().getTemplateParameters();
    }

    /**
     * <p>
     * The visibility (i.e. public, private, protected or package) of
     * the model element, will attempt a lookup for these values in the
     * language mappings (if any).
     * </p>
     * @see ModelElementFacade#getVisibility()
     */
    public String getVisibility()
    {
        return this.getSuperServiceOperation().getVisibility();
    }

    /**
     * <p>
     * Returns true if the model element has the exact stereotype
     * (meaning no stereotype inheritance is taken into account when
     * searching for the stereotype), false otherwise.
     * </p>
     * @see ModelElementFacade#hasExactStereotype(String stereotypeName)
     */
    public boolean hasExactStereotype(String stereotypeName)
    {
        return this.getSuperServiceOperation().hasExactStereotype(stereotypeName);
    }

    /**
     * <p>
     * Does the UML Element contain the named Keyword? Keywords can be
     * separated by space, comma, pipe, semicolon, or << >>
     * </p>
     * @see ModelElementFacade#hasKeyword(String keywordName)
     */
    public boolean hasKeyword(String keywordName)
    {
        return this.getSuperServiceOperation().hasKeyword(keywordName);
    }

    /**
     * <p>
     * Returns true if the model element has the specified stereotype. 
     * If the stereotype itself does not match, then a search will be
     * made up the stereotype inheritance hierarchy, and if one of the
     * stereotype's ancestors has a matching name this method will
     * return true, false otherwise.
     * </p>
     * <p>
     * For example, if we have a certain stereotype called
     * <<exception>> and a model element has a stereotype called
     * <<applicationException>> which extends <<exception>>, when
     * calling this method with 'stereotypeName' defined as 'exception'
     * the method would return true since <<applicationException>>
     * inherits from <<exception>>.  If you want to check if the model
     * element has the exact stereotype, then use the method
     * 'hasExactStereotype' instead.
     * </p>
     * @see ModelElementFacade#hasStereotype(String stereotypeName)
     */
    public boolean hasStereotype(String stereotypeName)
    {
        return this.getSuperServiceOperation().hasStereotype(stereotypeName);
    }

    /**
     * 
     * @see ModelElementFacade#isBindingDependenciesPresent()
     */
    public boolean isBindingDependenciesPresent()
    {
        return this.getSuperServiceOperation().isBindingDependenciesPresent();
    }

    /**
     * <p>
     * Indicates if any constraints are present on this model element.
     * </p>
     * @see ModelElementFacade#isConstraintsPresent()
     */
    public boolean isConstraintsPresent()
    {
        return this.getSuperServiceOperation().isConstraintsPresent();
    }

    /**
     * <p>
     * Indicates if any documentation is present on this model element.
     * </p>
     * @see ModelElementFacade#isDocumentationPresent()
     */
    public boolean isDocumentationPresent()
    {
        return this.getSuperServiceOperation().isDocumentationPresent();
    }

    /**
     * <p>
     * True if this element name is a reserved word in Java, C#, ANSI
     * or ISO C, C++, JavaScript.
     * </p>
     * @see ModelElementFacade#isReservedWord()
     */
    public boolean isReservedWord()
    {
        return this.getSuperServiceOperation().isReservedWord();
    }

    /**
     * 
     * @see ModelElementFacade#isTemplateParametersPresent()
     */
    public boolean isTemplateParametersPresent()
    {
        return this.getSuperServiceOperation().isTemplateParametersPresent();
    }

    /**
     * <p>
     * Searches for the constraint with the specified 'name' on this
     * model element, and if found translates it using the specified
     * 'translation' from a translation library discovered by the
     * framework.
     * </p>
     * @see ModelElementFacade#translateConstraint(String name, String translation)
     */
    public String translateConstraint(String name, String translation)
    {
        return this.getSuperServiceOperation().translateConstraint(name, translation);
    }

    /**
     * <p>
     * Translates all constraints belonging to this model element with
     * the given 'translation'.
     * </p>
     * @see ModelElementFacade#translateConstraints(String translation)
     */
    public String[] translateConstraints(String translation)
    {
        return this.getSuperServiceOperation().translateConstraints(translation);
    }

    /**
     * <p>
     * Translates the constraints of the specified 'kind' belonging to
     * this model element.
     * </p>
     * @see ModelElementFacade#translateConstraints(String kind, String translation)
     */
    public String[] translateConstraints(String kind, String translation)
    {
        return this.getSuperServiceOperation().translateConstraints(kind, translation);
    }

    /**
     * <p>
     * Finds the parameter on this operation having the given name, if
     * no parameter is found, null is returned instead.
     * </p>
     * @see OperationFacade#findParameter(String name)
     */
    public ParameterFacade findParameter(String name)
    {
        return this.getSuperServiceOperation().findParameter(name);
    }

    /**
     * <p>
     * Searches the given feature for the specified tag.
     * </p>
     * <p>
     * If the follow boolean is set to true then the search will
     * continue from the class operation to the class itself and then
     * up the class hierarchy.
     * </p>
     * @see OperationFacade#findTaggedValue(String name, boolean follow)
     */
    public Object findTaggedValue(String name, boolean follow)
    {
        return this.getSuperServiceOperation().findTaggedValue(name, follow);
    }

    /**
     * <p>
     * A comma separated list of all argument names.
     * </p>
     * @see OperationFacade#getArgumentNames()
     */
    public String getArgumentNames()
    {
        return this.getSuperServiceOperation().getArgumentNames();
    }

    /**
     * 
     * @see OperationFacade#getArgumentTypeNames()
     */
    public String getArgumentTypeNames()
    {
        return this.getSuperServiceOperation().getArgumentTypeNames();
    }

    /**
     * 
     * @see OperationFacade#getArguments()
     */
    public Collection<ParameterFacade> getArguments()
    {
        return this.getSuperServiceOperation().getArguments();
    }

    /**
     * 
     * @see OperationFacade#getCall()
     */
    public String getCall()
    {
        return this.getSuperServiceOperation().getCall();
    }

    /**
     * <p>
     * Returns the concurrency modifier for this operation (i.e.
     * concurrent, guarded or sequential) of the model element, will
     * attempt a lookup for these values in the language mappings (if
     * any).
     * </p>
     * @see OperationFacade#getConcurrency()
     */
    public String getConcurrency()
    {
        return this.getSuperServiceOperation().getConcurrency();
    }

    /**
     * <p>
     * A comma separated list containing all exceptions that this
     * operation throws.  Exceptions are determined through
     * dependencies that have the target element stereotyped as
     * <<Exception>>.
     * </p>
     * @see OperationFacade#getExceptionList()
     */
    public String getExceptionList()
    {
        return this.getSuperServiceOperation().getExceptionList();
    }

    /**
     * <p>
     * Returns a comma separated list of exceptions appended to the
     * comma separated list of fully qualified 'initialException'
     * classes passed in to this method.
     * </p>
     * @see OperationFacade#getExceptionList(String initialExceptions)
     */
    public String getExceptionList(String initialExceptions)
    {
        return this.getSuperServiceOperation().getExceptionList(initialExceptions);
    }

    /**
     * <p>
     * A collection of all exceptions thrown by this operation.
     * </p>
     * @see OperationFacade#getExceptions()
     */
    public Collection getExceptions()
    {
        return this.getSuperServiceOperation().getExceptions();
    }

    /**
     * <p>
     * Return Type with multiplicity taken into account. UML14 does not
     * allow multiplicity *.
     * </p>
     * @see OperationFacade#getGetterSetterReturnTypeName()
     */
    public String getGetterSetterReturnTypeName()
    {
        return this.getSuperServiceOperation().getGetterSetterReturnTypeName();
    }

    /**
     * <p>
     * the lower value for the multiplicity
     * </p>
     * <p>
     * -only applicable for UML2
     * </p>
     * @see OperationFacade#getLower()
     */
    public int getLower()
    {
        return this.getSuperServiceOperation().getLower();
    }

    /**
     * <p>
     * Returns the operation method body determined from UML sequence
     * diagrams or other UML sources.
     * </p>
     * @see OperationFacade#getMethodBody()
     */
    public String getMethodBody()
    {
        return this.getSuperServiceOperation().getMethodBody();
    }

    /**
     * <p>
     * The operation this operation overrides, null if this operation
     * is not overriding.
     * </p>
     * @see OperationFacade#getOverriddenOperation()
     */
    public OperationFacade getOverriddenOperation()
    {
        return this.getSuperServiceOperation().getOverriddenOperation();
    }

    /**
     * <p>
     * Gets the owner of this operation
     * </p>
     * @see OperationFacade#getOwner()
     */
    public ClassifierFacade getOwner()
    {
        return this.getSuperServiceOperation().getOwner();
    }

    /**
     * 
     * @see OperationFacade#getParameters()
     */
    public Collection<ParameterFacade> getParameters()
    {
        return this.getSuperServiceOperation().getParameters();
    }

    /**
     * <p>
     * The name of the operation that handles postcondition
     * constraints.
     * </p>
     * @see OperationFacade#getPostconditionName()
     */
    public String getPostconditionName()
    {
        return this.getSuperServiceOperation().getPostconditionName();
    }

    /**
     * <p>
     * The postcondition constraints belonging to this operation.
     * </p>
     * @see OperationFacade#getPostconditions()
     */
    public Collection<ConstraintFacade> getPostconditions()
    {
        return this.getSuperServiceOperation().getPostconditions();
    }

    /**
     * <p>
     * The call to the precondition operation.
     * </p>
     * @see OperationFacade#getPreconditionCall()
     */
    public String getPreconditionCall()
    {
        return this.getSuperServiceOperation().getPreconditionCall();
    }

    /**
     * <p>
     * The name of the operation that handles precondition constraints.
     * </p>
     * @see OperationFacade#getPreconditionName()
     */
    public String getPreconditionName()
    {
        return this.getSuperServiceOperation().getPreconditionName();
    }

    /**
     * <p>
     * The signature of the precondition operation.
     * </p>
     * @see OperationFacade#getPreconditionSignature()
     */
    public String getPreconditionSignature()
    {
        return this.getSuperServiceOperation().getPreconditionSignature();
    }

    /**
     * <p>
     * The precondition constraints belonging to this operation.
     * </p>
     * @see OperationFacade#getPreconditions()
     */
    public Collection<ConstraintFacade> getPreconditions()
    {
        return this.getSuperServiceOperation().getPreconditions();
    }

    /**
     * <p>
     * (UML2 Only). Get the actual return parameter (which may have
     * stereotypes etc).
     * </p>
     * @see OperationFacade#getReturnParameter()
     */
    public ParameterFacade getReturnParameter()
    {
        return this.getSuperServiceOperation().getReturnParameter();
    }

    /**
     * 
     * @see OperationFacade#getReturnType()
     */
    public ClassifierFacade getReturnType()
    {
        return this.getSuperServiceOperation().getReturnType();
    }

    /**
     * 
     * @see OperationFacade#getSignature()
     */
    public String getSignature()
    {
        return this.getSuperServiceOperation().getSignature();
    }

    /**
     * <p>
     * Returns the signature of the operation and optionally appends
     * the argument names (if withArgumentNames is true), otherwise
     * returns the signature with just the types alone in the
     * signature.
     * </p>
     * @see OperationFacade#getSignature(boolean withArgumentNames)
     */
    public String getSignature(boolean withArgumentNames)
    {
        return this.getSuperServiceOperation().getSignature(withArgumentNames);
    }

    /**
     * <p>
     * Returns the signature of the operation and optionally appends
     * the given 'argumentModifier' to each argument.
     * </p>
     * @see OperationFacade#getSignature(String argumentModifier)
     */
    public String getSignature(String argumentModifier)
    {
        return this.getSuperServiceOperation().getSignature(argumentModifier);
    }

    /**
     * <p>
     * A comma-separated parameter list  (type and name of each
     * parameter) of an operation.
     * </p>
     * @see OperationFacade#getTypedArgumentList()
     */
    public String getTypedArgumentList()
    {
        return this.getSuperServiceOperation().getTypedArgumentList();
    }

    /**
     * <p>
     * A comma-separated parameter list  (type and name of each
     * parameter) of an operation with an optional modifier (i.e final)
     * before each parameter.
     * </p>
     * @see OperationFacade#getTypedArgumentList(String modifier)
     */
    public String getTypedArgumentList(String modifier)
    {
        return this.getSuperServiceOperation().getTypedArgumentList(modifier);
    }

    /**
     * <p>
     * the upper value for the multiplicity (will be -1 for *)
     * </p>
     * <p>
     * - only applicable for UML2
     * </p>
     * @see OperationFacade#getUpper()
     */
    public int getUpper()
    {
        return this.getSuperServiceOperation().getUpper();
    }

    /**
     * 
     * @see OperationFacade#isAbstract()
     */
    public boolean isAbstract()
    {
        return this.getSuperServiceOperation().isAbstract();
    }

    /**
     * <p>
     * True if the operation has (i.e. throws any exceptions) false
     * otherwise.
     * </p>
     * @see OperationFacade#isExceptionsPresent()
     */
    public boolean isExceptionsPresent()
    {
        return this.getSuperServiceOperation().isExceptionsPresent();
    }

    /**
     * <p>
     * IsLeaf property in the operation. If true, operation is final,
     * cannot be extended or implemented by a descendant.
     * Default=false.
     * </p>
     * @see OperationFacade#isLeaf()
     */
    public boolean isLeaf()
    {
        return this.getSuperServiceOperation().isLeaf();
    }

    /**
     * <p>
     * UML2 only. If the return type parameter multiplicity>1 OR the
     * operation multiplicity>1. Default=false.
     * </p>
     * @see OperationFacade#isMany()
     */
    public boolean isMany()
    {
        return this.getSuperServiceOperation().isMany();
    }

    /**
     * <p>
     * UML2 only: If isMany (Collection type returned), is the type
     * unique within the collection.  Unique+Ordered determines
     * CollectionType implementation of return result. Default=false.
     * </p>
     * @see OperationFacade#isOrdered()
     */
    public boolean isOrdered()
    {
        return this.getSuperServiceOperation().isOrdered();
    }

    /**
     * <p>
     * True if this operation overrides an operation defined in an
     * ancestor class. An operation overrides when the names of the
     * operations as well as the types of the arguments are equal. The
     * return type may be different and is, as well as any exceptions,
     * ignored.
     * </p>
     * @see OperationFacade#isOverriding()
     */
    public boolean isOverriding()
    {
        return this.getSuperServiceOperation().isOverriding();
    }

    /**
     * <p>
     * Whether any postcondition constraints are present on this
     * operation.
     * </p>
     * @see OperationFacade#isPostconditionsPresent()
     */
    public boolean isPostconditionsPresent()
    {
        return this.getSuperServiceOperation().isPostconditionsPresent();
    }

    /**
     * <p>
     * Whether any precondition constraints are present on this
     * operation.
     * </p>
     * @see OperationFacade#isPreconditionsPresent()
     */
    public boolean isPreconditionsPresent()
    {
        return this.getSuperServiceOperation().isPreconditionsPresent();
    }

    /**
     * <p>
     * Indicates whether or not this operation is a query operation.
     * </p>
     * @see OperationFacade#isQuery()
     */
    public boolean isQuery()
    {
        return this.getSuperServiceOperation().isQuery();
    }

    /**
     * <p>
     * True/false depending on whether or not the operation has a
     * return type or not (i.e. a return type of something other than
     * void).
     * </p>
     * @see OperationFacade#isReturnTypePresent()
     */
    public boolean isReturnTypePresent()
    {
        return this.getSuperServiceOperation().isReturnTypePresent();
    }

    /**
     * 
     * @see OperationFacade#isStatic()
     */
    public boolean isStatic()
    {
        return this.getSuperServiceOperation().isStatic();
    }

    /**
     * <p>
     * UML2 only: for Collection return type, is the type unique within
     * the collection. Unique+Ordered determines the returned
     * CollectionType. Default=false.
     * </p>
     * @see OperationFacade#isUnique()
     */
    public boolean isUnique()
    {
        return this.getSuperServiceOperation().isUnique();
    }

    /**
     * <p>
     * The destination for any incoming messages.
     * </p>
     * @see ServiceOperation#getIncomingDestination()
     */
    public Destination getIncomingDestination()
    {
        return this.getSuperServiceOperation().getIncomingDestination();
    }

    /**
     * <p>
     * The destination for any outgoing messages.
     * </p>
     * @see ServiceOperation#getOutgoingDestination()
     */
    public Destination getOutgoingDestination()
    {
        return this.getSuperServiceOperation().getOutgoingDestination();
    }

    /**
     * <p>
     * The users of the service operation, these are the actor's that
     * can access this operation.
     * </p>
     * @see ServiceOperation#getRoles()
     */
    public Collection<Role> getRoles()
    {
        return this.getSuperServiceOperation().getRoles();
    }

    /**
     * <p>
     * The service which owns the service operation.
     * </p>
     * @see ServiceOperation#getService()
     */
    public Service getService()
    {
        return this.getSuperServiceOperation().getService();
    }

    /**
     * <p>
     * Whether or not this operation represents an "incoming" message
     * operation (i.e. it receives messages from Queues or Topics).
     * </p>
     * @see ServiceOperation#isIncomingMessageOperation()
     */
    public boolean isIncomingMessageOperation()
    {
        return this.getSuperServiceOperation().isIncomingMessageOperation();
    }

    /**
     * <p>
     * Whether or not this is operation accepts incoming or outgoing
     * messages.
     * </p>
     * @see ServiceOperation#isMessageOperation()
     */
    public boolean isMessageOperation()
    {
        return this.getSuperServiceOperation().isMessageOperation();
    }

    /**
     * <p>
     * Whether or not this service operation represents an "outgoing"
     * messaging operation (i.e. it sends messages to Queues or
     * Topics).
     * </p>
     * @see ServiceOperation#isOutgoingMessageOperation()
     */
    public boolean isOutgoingMessageOperation()
    {
        return this.getSuperServiceOperation().isOutgoingMessageOperation();
    }

    /**
     * @see org.andromda.core.metafacade.MetafacadeBase#initialize()
     */
    @Override
    public void initialize()
    {
        this.getSuperServiceOperation().initialize();
    }

    /**
     * @return Object getSuperServiceOperation().getValidationOwner()
     * @see org.andromda.core.metafacade.MetafacadeBase#getValidationOwner()
     */
    @Override
    public Object getValidationOwner()
    {
        Object owner = this.getSuperServiceOperation().getValidationOwner();
        return owner;
    }

    /**
     * @return String getSuperServiceOperation().getValidationName()
     * @see org.andromda.core.metafacade.MetafacadeBase#getValidationName()
     */
    @Override
    public String getValidationName()
    {
        String name = this.getSuperServiceOperation().getValidationName();
        return name;
    }

    /**
     * @param validationMessages Collection<ModelValidationMessage>
     * @see org.andromda.core.metafacade.MetafacadeBase#validateInvariants(Collection validationMessages)
     */
    @Override
    public void validateInvariants(Collection<ModelValidationMessage> validationMessages)
    {
        this.getSuperServiceOperation().validateInvariants(validationMessages);
    }

    /**
     * The property that stores the name of the metafacade.
     */
    private static final String NAME_PROPERTY = "name";
    private static final String FQNAME_PROPERTY = "fullyQualifiedName";

    /**
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        final StringBuilder toString = new StringBuilder(this.getClass().getName());
        toString.append("[");
        try
        {
            toString.append(Introspector.instance().getProperty(this, FQNAME_PROPERTY));
        }
        catch (final Throwable tryAgain)
        {
            try
            {
                toString.append(Introspector.instance().getProperty(this, NAME_PROPERTY));
            }
            catch (final Throwable ignore)
            {
                // - just ignore when the metafacade doesn't have a name or fullyQualifiedName property
            }
        }
        toString.append("]");
        return toString.toString();
    }
}